/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine;

import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.parser.nodes.INode;
import cin.jats.engine.visitors.CloningVisitor;

/**
 * Esta classe  responsvel por fazer um clone de uma rvore sinttica.
 *
 * @author Adeline de Sousa Silva
 * @author Fernando Castor
 */
public class JatsClonner {


    private CloningVisitor clonner;

    /**
     * Construtor da classe
     */
    public JatsClonner() {

        this.clonner = new CloningVisitor();
    }

    /**
     * Retorna o clone do n passado como parametro
     */
    public INode clone(INode node) throws InconsistentNodeException,
            IllegalArgumentException, ExecutionException {

        if (node == null) {
            throw new IllegalArgumentException("node ou output sao null");
        }
        INode retorno = null;
        node.accept(clonner, null);
        retorno = (INode) clonner.getClone();
        return retorno;
    }
}
