/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine;

import cin.jats.engine.visitors.TransformationVisitor;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.INode;
import cin.jats.engine.util.TransformationState;

/**
 * 
 * @author Adeline Sousa
 * @version 09/04/2003
 */
public class JatsTransformer {

    TransformationVisitor transVisitor;

    public JatsTransformer() {
        this.transVisitor = new TransformationVisitor();
    }


    /**
     * Dispara a transformao presente no objeto <code>TransformationState</code>
     * no objeto <code>source</code>
     *
     * @param source
     * @param transState
     * @throws cin.jats.engine.parser.nodes.exceptions.ExecutionException
     * @throws cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException
     */
    public void transform(INode source, TransformationState transState)
            throws ExecutionException, InconsistentNodeException {
        if (source == null) {
            throw new IllegalArgumentException(" N fonte da transformao  nulo");
        }
        source.accept(this.transVisitor, transState);

    }

}
