/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * Esta interface define os operadores de atribuio, como =, >=, *=, etc.
 *
 * @author Adeline de Sousa
 * @version 09/07/2002
 */
public interface AssignmentOperator {

    // atribuio simples
    public static final int ASSIGN = 1;

    // atribuio e soma "+="
    public static final int PLUS_ASSIGN = 2;

    // atribuio e subtrao "-="
    public static final int MINUS_ASSIGN = 4;

    // atribuio e multiplicao "*="
    public static final int TIMES_ASSIGN = 8;

    // atribuio e diviso "/="
    public static final int DIVIDE_ASSIGN = 16;

    // atribuio e shift a esquerda "<<="
    public static final int LSHIFT_ASSIGN = 32;

    // atribuio e shift  direita ">>="
    // leva o sinal em considerao
    public static final int RSIGNED_SHIFT_ASSIGN = 64;

    // atribuio e shift lgico  direita ">>>="
    // no leva o sinal em considerao
    public static final int RUNSIGNED_SHIFT_ASSIGN = 128;

    // atribuio e resto da diviso "%="
    public static final int REM_ASSIGN = 256;

    // atribuio e and lgico ( feito bit a bit) "&="
    public static final int AND_ASSIGN = 512;

    // atribuio e or lgico (bit a bit) "|="
    public static final int OR_ASSIGN = 1024;

    // atribuio e xor lgico  "^="
    public static final int XOR_ASSIGN = 2048;
}
