/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * Esta interface  define o  comportamento dos ns sintticos que podem conter
 * comentarios Javadoc. Inicialmente, teremos: declaraes de classe, interface,
 * construtor e mtodo. Depois, estenderemos para atributo e,. no caso dos
 * mtodos, teremos comentrios especiais para get/sets
 * 
 * @author Adeline de Sousa
 * @version 22/10/2002
 */

public interface Commentable {

    /**
     * Retorna true, caso o n, possua javadoc
     *
     * @return true, se  o n possui um javadoc
     *         false, caso contrrio
     */
    public boolean hasComment();


    /**
     * Retorna o javadoc associado a este n
     *
     * @return javadoc associado a este n
     */
    public JComment getComment();


    /**
     * Seta o javadoc associado a este n
     *
     * @param comment javadoc associado a este n
     */
    public void setComment(JComment comment);

    /**
     * Retorna a assinatura do n. Ou seja, o atributo que o  identifica.
     * Para declaraes de atributo, a assinatura  o seu nome, para declaraes
     * de mtodo, a assinatura  o nome mais a lista de parametros.
     *
     * @return A assinatura do n
     */
    public Signature getSignature();


}
