/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * @author Adeline de Sousa
 */
public interface ITypeDeclaration extends Declaration//NamespaceMember 
{

    /**
     * Retorna a lista de modificadores do tipo.
     *
     * @return Modificadores do tipo
     */
    JModifierList getModifiers();

    /**
     * Retorna o nome identificador (nome) do tipo.
     *
     * @return Nome do tipo
     */
    JIdentifier getName();

    /**
     * Seta a lista de modificadores do mtodo.
     *
     * @param modList Lista de modificadores deste mtodo
     * @throws IllegalArgumentException
     *          - se o modList passado for null.
     */
    void setModifiers(JModifierList modList)
            throws IllegalArgumentException;

    /**
     * Diz se este tipo  publico ou no.
     *
     * @return true, se o tipo  publico
     *         false, caso contrrio
     */
    boolean isPublic();

    /**
     * Seta o identificador (nome) do tipo
     *
     * @param id Nome  classe
     * @throws IllegalArgumentException
     *          - se o id passado for null.
     */
    void setName(JIdentifier id) throws IllegalArgumentException;
}
