/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

public interface JModifier {
    /**
     * The <code>int</code> value representing the <code>public</code>
     * modifier.
     */
    public static final int PUBLIC = 1;

    /**
     * The <code>int</code> value representing the <code>private</code>
     * modifier.
     */
    public static final int PRIVATE = 2;

    /**
     * The <code>int</code> value representing the <code>protected</code>
     * modifier.
     */
    public static final int PROTECTED = 4;

    /**
     * The <code>int</code> value representing the <code>static</code>
     * modifier.
     */
    public static final int STATIC = 8;

    /**
     * The <code>int</code> value representing the <code>final</code>
     * modifier.
     */
    public static final int FINAL = 16;

    /**
     * The <code>int</code> value representing the <code>synchronized</code>
     * modifier.
     */
    public static final int SYNCHRONIZED = 32;

    /**
     * The <code>int</code> value representing the <code>volatile</code>
     * modifier.
     */
    public static final int VOLATILE = 64;

    /**
     * The <code>int</code> value representing the <code>transient</code>
     * modifier.
     */
    public static final int TRANSIENT = 128;

    /**
     * The <code>int</code> value representing the <code>native</code>
     * modifier.
     */
    public static final int NATIVE = 256;

    /**
     * The <code>int</code> value representing the <code>interface</code>
     * modifier.
     */
    public static final int INTERFACE = 512;

    /**
     * The <code>int</code> value representing the <code>abstract</code>
     * modifier.
     */
    public static final int ABSTRACT = 1024;

    /**
     * The <code>int</code> value representing the <code>strictfp</code>
     * modifier.
     */
    public static final int STRICT = 2048;


    /****************************************************************************/
    /*******                         C# modifiers                       *********/
    /****************************************************************************/

    /**
     * The <code>int</code> value representing the <code>internal</code>
     * modifier.
     */
    public static final int INTERNAL = 4096;

    /**
     * The <code>int</code> value representing the <code>sealed</code>
     * modifier.
     */
    public static final int SEALED = 8192;

    /**
     * The <code>int</code> value representing the <code>new</code>
     * modifier.
     */
    public static final int NEW = 16384;

    /**
     * The <code>int</code> value representing the <code>const</code>
     * modifier.
     */
    public static final int CONST = 32768;

    /**
     * The <code>int</code> value representing the <code>virtual</code>
     * modifier.
     */
    public static final int VIRTUAL = 65536;

    /**
     * The <code>int</code> value representing the <code>override</code>
     * modifier.
     */
    public static final int OVERRIDE = 131072;

    /**
     * The <code>int</code> value representing the <code>extern</code>
     * modifier.
     */
    public static final int EXTERN = 262144;

    /**
     * The <code>int</code> value representing the <code>reandonly</code>
     * modifier.
     */
    public static final int READ_ONLY = 524288;

    /**
     * The <code>int</code> value representing the <code>ref</code>
     * modifier.
     */
    public static final int REF = 1048576;

    /**
     * The <code>int</code> value representing the <code>out</code>
     * modifier.
     */
    public static final int OUT = 2097152;


    /**
     * The <code>int</code> value representing the <code>params</code>
     * modifier.
     */
    public static final int PARAMS = 4194304;



}
