/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * Esta interface define o comportamento comum a declaraes  executveis
 * (declaraes iterativas ou condicionais), que podem ser aninhadas.
 *
 * @author Adeline de Sousa
 * @since JDK 1.3
 */
public interface NestableExecutableDeclaration {


    /**
     * Seta o n pai da declarao. Ou seja, o n onde o resultado do processamento
     * desta declarao ir ficar.
     *
     * @param parNode O pai deste n.
     * @throws IllegalArgumentException Levantada se <code>parNode</code> for
     *                                  <code>null</code>.
     */
    public void setParentNode(INode parNode) throws IllegalArgumentException;


    /**
     * Retorna o n pai da declarao iterativa.
     *
     * @return O pai deste n.
     */
    public INode getParentNode();

}



