/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.visitors.IVisitor;

/**
 * @author gas
 *
 */
public class CodeAssignStatement extends MetaStatement {
	
	private String id;
	private Object value;

	/**
	 * 
	 */
	public CodeAssignStatement() {
	}
	
	public CodeAssignStatement(String id, Object value) {
		this.id = id;
		this.value = value;
	}

	/**
	 * @return Returns the file.
	 */
	public Object getValue() {
		return value;
	}

	/**
	 * @param file The file to set.
	 */
	public void setValue(Object value) {
		this.value = value;
	}

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}

	public Object accept(IVisitor visitor, Object data) throws InconsistentNodeException, IllegalArgumentException, ExecutionException {
		
		return visitor.visit(this, data);
	}	
}
