/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import cin.jats.engine.parser.nodes.INode;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.parser.nodes.exceptions.NodesNotMatchedException;
import cin.jats.engine.util.ResultSet;

/**
 * 
 * @author Gustavo Santos
 * @created 12/12/2005
 * 
 * @version 12/12/2005
 *
 */
public class MatchingMetaExpression extends MetaExpression {

	private List variables;
	
	/**
	 * Empty constructor for MatchingMetaExpression objects.
	 *
	 */
	public MatchingMetaExpression() {
		this.variables = new ArrayList();
	}
	/**
	 * Constructor for MatchingMetaExpression objects.
	 *
	 */
	public MatchingMetaExpression(List variables) {
		this.variables = variables;
	}
	
//	@Override
	public boolean evaluate(ResultSet rs, Object obj) {
		boolean result = false;
		
		for (Iterator iter = variables.iterator(); iter.hasNext();) {
			MetaVariable element = (MetaVariable) iter.next();
			
			if (element.evaluate(rs, obj)) {
				result = true;
				break;
			}			
		}
		
		return result;
	}

}
