/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import cin.jats.engine.parser.nodes.AbstractNode;
import cin.jats.engine.parser.nodes.INode;
import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.parser.nodes.exceptions.NodesNotMatchedException;
import cin.jats.engine.util.ResultSet;
import cin.jats.engine.visitors.IVisitor;

/**
 * Base node for meta expression ASTs.
 * 
 * @author Gustavo Santos
 * @created 12/12/2005
 * 
 * @version 12/12/2005
 *
 */
public abstract class MetaExpression extends AbstractNode {

	public Object accept(IVisitor visitor, Object data) throws InconsistentNodeException, IllegalArgumentException, ExecutionException {
		// TODO implemente for all subnodes
		return null;
	}

	public void match(INode node, ResultSet results) throws IllegalArgumentException, InconsistentNodeException, NodesNotMatchedException {
		//not used
	}
	
	public abstract boolean evaluate(ResultSet rs, Object obj);

}
