/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.visitors.IVisitor;

/**
 * @author gas
 *
 */
public class RSetEntryStatement extends MetaStatement {

	private String rSetId;
	private String jatsVarId;
	private String valueId;
	private String positionId;
	
	/**
	 * 
	 */
	public RSetEntryStatement() {
	}

	
	/**
	 * @param jatsVarId
	 * @param positionId
	 * @param rSetId
	 * @param valueId
	 */
	public RSetEntryStatement(String rSetId, String jatsVarId, 
			 String valueId, String positionId) {
		this.jatsVarId = jatsVarId;
		this.positionId = positionId;
		this.rSetId = rSetId;
		this.valueId = valueId;
	}


	/**
	 * @return Returns the jatsVarId.
	 */
	public String getJatsVarId() {
		return jatsVarId;
	}
	/**
	 * @param jatsVarId The jatsVarId to set.
	 */
	public void setJatsVarId(String jatsVarId) {
		this.jatsVarId = jatsVarId;
	}
	/**
	 * @return Returns the positionId.
	 */
	public String getPositionId() {
		return positionId;
	}
	/**
	 * @param positionId The positionId to set.
	 */
	public void setPositionId(String positionId) {
		this.positionId = positionId;
	}
	/**
	 * @return Returns the rSetId.
	 */
	public String getRSetId() {
		return rSetId;
	}
	/**
	 * @param setId The rSetId to set.
	 */
	public void setRSetId(String setId) {
		rSetId = setId;
	}
	/**
	 * @return Returns the valueId.
	 */
	public String getValueId() {
		return valueId;
	}
	/**
	 * @param valueId The valueId to set.
	 */
	public void setValueId(String valueId) {
		this.valueId = valueId;
	}

	/**
	 * 
	 */
	public Object accept(IVisitor visitor, Object data)
			throws InconsistentNodeException, IllegalArgumentException,
			ExecutionException {
		return visitor.visit(this, data);
	}
	
}
