/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import cin.jats.engine.parser.nodes.exceptions.ExecutionException;
import cin.jats.engine.parser.nodes.exceptions.InconsistentNodeException;
import cin.jats.engine.visitors.IVisitor;

public class TransfDeclaration extends MetaStatement {

	private String id;
	private String sourcePtnId;
	private String targetPtnId;
	
	public TransfDeclaration() {
	}
	
	/**
	 * @param id
	 * @param id2
	 * @param id3
	 */
	public TransfDeclaration(String id, String sourcePtnId, String targetPtnId) {
		this.id = id;
		this.sourcePtnId = sourcePtnId;
		this.targetPtnId = targetPtnId;
	}


	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}


	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}


	/**
	 * @return Returns the sourcePtnId.
	 */
	public String getSourcePtnId() {
		return sourcePtnId;
	}


	/**
	 * @param sourcePtnId The sourcePtnId to set.
	 */
	public void setSourcePtnId(String sourcePtnId) {
		this.sourcePtnId = sourcePtnId;
	}


	/**
	 * @return Returns the targetPtnId.
	 */
	public String getTargetPtnId() {
		return targetPtnId;
	}


	/**
	 * @param targetPtnId The targetPtnId to set.
	 */
	public void setTargetPtnId(String targetPtnId) {
		this.targetPtnId = targetPtnId;
	}


	/**
	 * 
	 */
	public Object accept(IVisitor visitor, Object data)
			throws InconsistentNodeException, IllegalArgumentException,
			ExecutionException {
		return visitor.visit(this, data);
	}

}
