/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

/**
 * 
 * @author Gustavo Santos
 * @created 12/12/2005
 * 
 * @version 12/12/2005
 * @see cin.jats.engine.parser.nodes.metajats.TraverseMetaExpression
 */
public class TraverseMetaOperator {

	public static int DIRECT_PARENT_OP = 0;
	public static int PARENT_OP = 1;
	public static int DIRECT_CHILD_OP = 2;
	public static int CHILD_OP = 3;
	public static int DIRECT_PRED_OP = 4;
	public static int PRED_OP = 5;
	public static int DIRECT_SUCC_OP = 6;
	public static int SUCC_OP = 7;
	public static int DEC_OP = 8;

	private int value;

	public TraverseMetaOperator(int value) {
		this.value = value;
	}

	/**
	 * @return Returns the value.
	 */
	public int getValue() {
		return value;
	}

	/**
	 * @param value The value to set.
	 */
	public void setValue(int value) {
		this.value = value;
	}

}
