/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

import cin.jats.engine.util.ResultSet;

/**
 * Unary expressions represent a meta expression with an unique
 * operand.
 * 
 * @author Gustavo Santos
 * @created 12/12/2005
 * 
 * @version 12/12/2005
 *
 */
public class UnaryMetaExpression extends MetaExpression {
	
	private MetaExpression operand;
	private LogicMetaOperator operator;

	/**
	 * Empty constructor for UnaryMetaExpression objects
	 *
	 */
	public UnaryMetaExpression() {
	}
	
	/**
	 * Constructor for UnaryMetaExpression objects
	 *
	 * @param operand the operand value
	 */
	public UnaryMetaExpression(MetaExpression operand) {
		this.operand = operand;
	}

	/**
	 * @return Returns the operand.
	 */
	public MetaExpression getOperand() {
		return operand;
	}

	/**
	 * @param operand The operand to set.
	 */
	public void setOperand(MetaExpression operand) {
		this.operand = operand;
	}

//	@Override
	public boolean evaluate(ResultSet rs, Object obj) {
		// TODO Auto-generated method stub
		return false;
	}

}
