/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.printing;

/**
 * Esta interface define as Tags utilizadas pelo gerador de Javadoc.
 * Inicialmente, suportar apenas um subconjunto das tags reconhecidas pelo
 * utilitrio javadoc
 *
 * @author Adeline de Sousa
 * @version 24/10/2002
 */
public interface JavadocTags {

    // classes
    String AUTHOR = "@author";
    String CREATED = "@created";

    // classes, metodos e construtores
    String SEE = "@see";
    String DEPRECATED = "@deprecated";

    // mtodos e construtores
    String PARAM = "@param";
    String EXCEPTION = "@exception";
    String THROWS = "@throws";

    // mtodos
    String RETURN = "@return";

}
