/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.util;

import java.util.Iterator;

import cin.jats.engine.parser.nodes.INode;

/**
 * 
 * @author Adeline de Sousa
 * @version  0.1 - 27/08/2001
 * @since JDK 1.3
 */
public class JaTSIterator {

    private Iterator iterator;

    /**
     * Construtor da classe
     */
    public JaTSIterator(Iterator it) {
        if (it != null) {
            this.iterator = it;
        } else {
            throw new IllegalArgumentException();
        }


    }


    /**
     * Retorna o prximo elemento do conjunto
     */
    public INode next() {
        INode retorno = null;
        Object tmp = this.iterator.next();
        if (tmp instanceof INode) {
            retorno = (INode) tmp;
        }
        return retorno;
    }

    /**
     * Retorna true, se ainda houver algum elemento no conjunto
     */
    public boolean hasNext() {
        return this.iterator.hasNext();
    }


}