/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.util;

import java.util.Vector;

/**
 Esta classe implementa uma pilha de objetos do tipo <code>String</code>.
 @author Fernando Castor
 */
public class StringStack {


    /**
     A lista onde sero armazenados os elementos.
     */
    private Vector elements;

    /**
     Construtor vazio da classe.
     */
    public StringStack() {
        elements = new Vector();
    }

    /**
     Diz se a pilha es vazia.
     @return Um boolean que, caso tenho o valor <code>true</code>, indica
     que a lista est vazia.
     */
    public boolean isEmpty() {
        return this.elements.isEmpty();
    }

    /**
     Remove o elemento que se encontra no topo da pilha e o retorna.
     @return O string que se encontra no topo ds pilha.
     */
    public String pop() {
        int i = 0;
        String retorno = null;

        if (!elements.isEmpty()) {
            i = elements.size() - 1;
            retorno = (String) elements.elementAt(i);
            elements.removeElementAt(i);
        }


        return retorno;
    }

    /**
     * Adiciona um elemento  pilha.
     *
     * @param str Um objeto qualquer do tipo <code>String</code>.
     *
     * @exception java.lang.IllegalArgumentException Levantada quando o argumento
     * <code>node</code> for <code>null</code>.
     */
    public void push(String str) throws IllegalArgumentException {
        if (str == null) {
            throw new IllegalArgumentException();
        }
        this.elements.addElement(str);
    }
}
