/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.util;

import java.util.List;
import java.util.Vector;

import cin.jats.engine.transformation.MicroTransformation;
import cin.jats.engine.parser.nodes.INode;

/**
 * 
 * @author Adeline Sousa
 * @version 09/04/2003
 */
public class TransformationState {

    private List transformation;
    private ResultSet results;

    public TransformationState(MicroTransformation transformation,
                               ResultSet results) {
        this.transformation = new Vector();
        this.transformation.add(transformation);
        this.results = results;
    }
    
    public TransformationState(List transformations,
			ResultSet results) {
		this.transformation = transformations;
		this.results = results;
	}

    public MicroTransformation getTransformation(int i) {
        return (MicroTransformation) transformation.get(i);
    }
    
    public List getTransformation() {
        return transformation;
    }

    public void setTransformation(List transformation) {
        this.transformation = transformation;
    }
    
    public void addTransformation(MicroTransformation transformation) {
        this.transformation.add(transformation);
    }

    public ResultSet getResults() {
        return results;
    }

    public void setResults(ResultSet results) {
        this.results = results;
    }

    public INode getSource(int i) {
        return this.getTransformation(i).getSource();
    }

    public INode getTarget(int i) {
        return this.getTransformation(i).getTarget();
    }

    public ResultSet getResultSetClone() {
        return (ResultSet) this.getResults().clone();
    }
    

}
