package cin.jats.tests.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Vector;
import cin.jats.engine.parser.ParseException;
import cin.jats.engine.parser.nodes.JaTSNode;
import cin.jats.engine.parser.nodes.JLiteral;
import cin.jats.engine.parser.nodes.ICompilationUnit;
import cin.jats.tests.JaTSTester;
import cin.jats.tests.util.UserJaTSVariable;

/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     Gustavo Santos
 *@created    24 de Maro de 2003
 *@version    1.0
 */

public class PanelEditProperties
    extends JPanel {

  JFileChooser fileChooser;

  JLabel jLabelFileName = new JLabel();
  JLabel jLabelOutputDir = new JLabel();
  JTextField jTextFieldOutputDir = new JTextField();
  JLabel jLabelJarTempl = new JLabel();
  JTextField jTextFieldJarTempl = new JTextField();
  JLabel jLabelJarSouces = new JLabel();
  JTextField jTextFieldJarSources = new JTextField();
  PanelListFiles panelListFilesLeft = new PanelListFiles();
  PanelListFiles panelListFilesSource = new PanelListFiles();
  PanelListFiles panelListFilesRight = new PanelListFiles();
  PanelListVar panelListVar1 = new PanelListVar();
  JPanel jPanel1 = new JPanel();
  TitledBorder titledBorder1;
  GridLayout gridLayout1 = new GridLayout();
  JButton jButtonNewFile = new JButton();
  JButton jButtonEdit = new JButton();
  JButton jButtonSave = new JButton();
  JLabel jLabelPropFileName = new JLabel();
  JButton jButtonDots = new JButton();
  JButton jButtonUnmatched = new JButton();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextArea textArea = new JTextArea();

  /**
   *  Constructor for the PanelEditProperties object
   */
  public PanelEditProperties() {
    try {
      jbInit();
      this.fileChooser = JaTSTesterFrame.fileChooser;
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    jLabelFileName.setText("File name:");
    jLabelFileName.setBounds(new Rectangle(15, 8, 70, 25));
    this.setLayout(null);
    jLabelOutputDir.setToolTipText("");
    jLabelOutputDir.setText("Output:");
    jLabelOutputDir.setBounds(new Rectangle(15, 38, 87, 25));
    jTextFieldOutputDir.setBounds(new Rectangle(129, 39, 368, 21));
    jLabelJarTempl.setText("Jar file (templates):");
    jLabelJarTempl.setBounds(new Rectangle(15, 69, 115, 25));
    jTextFieldJarTempl.setBounds(new Rectangle(129, 70, 368, 21));
    jLabelJarSouces.setText("Jar file (sources):");
    jLabelJarSouces.setBounds(new Rectangle(15, 98, 111, 25));
    jTextFieldJarSources.setBounds(new Rectangle(129, 99, 368, 21));
    panelListFilesLeft.setBounds(new Rectangle(14, 153, 177, 143));
    panelListFilesSource.setBounds(new Rectangle(199, 153, 177, 143));
    panelListFilesRight.setBounds(new Rectangle(385, 153, 177, 143));
    panelListVar1.setBorder(BorderFactory.createEtchedBorder());
    panelListVar1.setBounds(new Rectangle(572, 152, 225, 148));
    jPanel1.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(148, 145, 140)), "Actions :"));
    jPanel1.setBounds(new Rectangle(570, 30, 227, 113));
    jPanel1.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(4);
    jButtonNewFile.setText("New File...");
    jButtonNewFile.addActionListener(
        new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonNewFile_actionPerformed(e);
      }
    });
    jButtonEdit.setText("Edit File...");
    jButtonEdit.addActionListener(
        new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonEdit_actionPerformed(e);
      }
    });
    jButtonSave.setText("Save File");
    jButtonSave.addActionListener(
        new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonSave_actionPerformed(e);
      }
    });
    jLabelPropFileName.setFont(new java.awt.Font("Dialog", 1, 13));
    jLabelPropFileName.setHorizontalTextPosition(SwingConstants.RIGHT);
    jLabelPropFileName.setBounds(new Rectangle(129, 12, 649, 21));
    jButtonDots.setBounds(new Rectangle(507, 38, 54, 21));
    jButtonDots.setFont(new java.awt.Font("Dialog", 1, 15));
    jButtonDots.setText(". . .");
    jButtonDots.addActionListener(
        new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonDots_actionPerformed(e);
      }
    });
    jButtonUnmatched.setText("Unmatched Variables");
    jButtonUnmatched.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonUnmatched_actionPerformed(e);
      }
    });
    jLabel1.setText("Source Patterns:");
    jLabel1.setBounds(new Rectangle(14, 137, 93, 16));
    jLabel2.setBounds(new Rectangle(199, 138, 93, 16));
    jLabel2.setText("Source Files:");
    jLabel3.setBounds(new Rectangle(385, 137, 102, 16));
    jLabel3.setText("Target Patterns:");
    jPanel1.add(jButtonNewFile, null);
    jPanel1.add(jButtonEdit, null);
    jPanel1.add(jButtonSave, null);
    jPanel1.add(jButtonUnmatched, null);
    this.add(jButtonDots, null);
    this.add(jLabelFileName, null);
    this.add(jLabelPropFileName, null);
    this.add(jTextFieldJarTempl, null);
    this.add(jTextFieldOutputDir, null);
    this.add(jLabelOutputDir, null);
    this.add(jLabelJarTempl, null);
    this.add(jLabelJarSouces, null);
    this.add(jTextFieldJarSources, null);
    this.add(panelListFilesLeft, null);
    this.add(panelListFilesSource, null);
    this.add(panelListFilesRight, null);
    this.add(panelListVar1, null);
    this.add(jLabel1, null);
    this.add(jLabel3, null);
    this.add(jLabel2, null);
    this.add(jPanel1, null);
  }

  void jButtonNewFile_actionPerformed(ActionEvent e) {
    //JFileChooser chooser = new JFileChooser(JaTSTesterFrame.TEMPLATES_PATH);

fileChooser.setDragEnabled(true);
    //fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    int option = fileChooser.showOpenDialog(this);

    if (option == JFileChooser.APPROVE_OPTION) {

      File file = fileChooser.getSelectedFile();

//      try {
//        file.createNewFile();
//      }
//      catch (Exception ex) {
//        JOptionPane.showMessageDialog(this,
//                                      "Error creating file: " + ex.toString());
//        return;
//      }

      this.jTextFieldOutputDir.setText(file.getParentFile().getAbsolutePath());

      String fileName = file.getAbsolutePath();
      if (!fileName.endsWith(".jtp")) {
          fileName = fileName.concat(".jtp");
      }      
      JaTSTester.createJaTSTesterPropertiesFile(fileName);
      
      this.openPropertiesFileToEdit(fileName);
    }
  }

  private void openPropertiesFileToEdit(String file) {
    JaTSTester tester = JaTSTester.getInstance();
    
    JaTSTesterFrame.propertiesFilePath = file;

    try {
      tester.loadJaTSTesterProperties(new FileInputStream(file));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    this.jLabelPropFileName.setText(file);
    this.panelListFilesLeft.setValues(tester.getTemplateLeftNames());
    this.panelListFilesRight.setValues(tester.getTemplateRightNames());
    this.panelListFilesSource.setValues(tester.getSourceNames());
    this.panelListVar1.setVariables(tester.getUserVariables());
   // this.jTextFieldFilesDir.setText(tester.getFileDirectory());
    this.jTextFieldJarSources.setText(tester.getSourceJarFileName());
    this.jTextFieldJarTempl.setText(tester.getWizardJarFileName());
  }

  void jButtonEdit_actionPerformed(ActionEvent e) {
    //JFileChooser chooser = new JFileChooser(JaTSTesterFrame.TEMPLATES_PATH);
    fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
    int option = fileChooser.showOpenDialog(this);

    if (option == JFileChooser.APPROVE_OPTION) {
      File file = fileChooser.getSelectedFile();
      this.openPropertiesFileToEdit(file.getAbsolutePath());

    }
  }

  void jButtonSave_actionPerformed(ActionEvent e) {
    String fileName = this.jLabelPropFileName.getText();
    FileOutputStream out = null;

    try {
      if (!fileName.endsWith(".jtp")) {
        fileName = fileName.concat(".jtp");
      }
      out = new FileOutputStream(fileName);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    JaTSTester tester = new JaTSTester();
    tester.setFilesDirectory(fileName.substring(0, fileName.lastIndexOf("\\")));
    tester.setOutputDirectory(this.jTextFieldOutputDir.getText());
    tester.setSourceNames(this.panelListFilesSource.getValues());
    tester.setTemplateLeftNames(this.panelListFilesLeft.getValues());
    tester.setTemplateRightNames(this.panelListFilesRight.getValues());
    tester.setUserVariables(this.panelListVar1.getVariables());

    tester.saveJaTSTesterPropertiesFile(out);

  }

  void jButtonDots_actionPerformed(ActionEvent e) {
    //JFileChooser chooser = new JFileChooser(JaTSTesterFrame.TEMPLATES_PATH);
    fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    int option = fileChooser.showOpenDialog(this);

    if (option == JFileChooser.APPROVE_OPTION) {
      this.jTextFieldOutputDir.setText(
          fileChooser.getSelectedFile().getAbsolutePath());
    }
  }

  void jButtonUnmatched_actionPerformed(ActionEvent e) {
    String parsingItem = "";
    ICompilationUnit[] compsRight = null;
    ICompilationUnit[] compsLeft = null;
    try {
      this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
      if (JaTSTester.getInstance().isIsValidPropertyFile()) {
        int length = this.panelListFilesLeft.getValues().size();
        if (length > 0) {
          compsLeft = new cin.jats.engine.parser.nodes.JCompilationUnit[length];
          for (int i = 0; i < length; i++) {
            parsingItem = this.panelListFilesLeft.getValues()
                .elementAt(i).toString();
            compsLeft[i] = (ICompilationUnit) JaTSTester.getInstance().parseTemplateFile(
                parsingItem,
                false);
          }
        }
        length = this.panelListFilesRight.getValues().size();
        if (length > 0) {
          compsRight = new cin.jats.engine.parser.nodes.JCompilationUnit[length];
          for (int i = 0; i < length; i++) {
            parsingItem = this.panelListFilesRight.getValues()
                .elementAt(i).toString();
            compsRight[i] = (ICompilationUnit) JaTSTester.getInstance().parseTemplateFile(
                parsingItem,
                false);
          }
        }
      }
      else {
        printMessage("******  Load a valid property file first !  *******", true);
      }

      Vector totalLeft = new Vector();
      Vector totalRight = new Vector();
      Vector unmatched = new Vector();

      cin.jats.engine.util.NodeList list = null;
      Vector temp = null;
      for (int i = 0; i < compsLeft.length; i++) {
        temp = compsLeft[i].getTable().getTable();
        for (int j = 0; j < temp.size(); j++) {
          list = (cin.jats.engine.util.NodeList) temp.elementAt(j);
          totalLeft.addAll(list.getElements());
        }
      }
      for (int i = 0; i < compsRight.length; i++) {
        temp = compsRight[i].getTable().getTable();
        for (int j = 0; j < temp.size(); j++) {
          list = (cin.jats.engine.util.NodeList) temp.elementAt(j);
          totalRight.addAll(list.getElements());
        }
      }

      java.util.Iterator it = totalRight.iterator();

      while (it.hasNext()) {
        cin.jats.engine.parser.nodes.JaTSNode no =
            (cin.jats.engine.parser.nodes.JaTSNode) it.next();
        if (!totalLeft.contains(no)) {
          unmatched.add(no);
        }
      }

      Vector vars = new Vector();
      printMessage(
          "\n***********  Variaveis que constam apenas no lado direito *********\n", false);
      for (int i = 0; i < unmatched.size(); i++) {
        if ( ( (cin.jats.engine.parser.nodes.JaTSNode) unmatched.elementAt(i)).
            isVariable()) {

          vars.add(unmatched.elementAt(i));
          printMessage( ( (cin.jats.engine.parser.nodes.JaTSNode)
                         unmatched.elementAt(i)) + "", false);
        }
      }

      if (vars.size() > 0) {
        int option = JOptionPane.showConfirmDialog(this,
            "Add variables to the variables list?", "Add...",
            JOptionPane.YES_NO_OPTION);
        if (option == JOptionPane.OK_OPTION) {
          Vector listVars = this.panelListVar1.getVariables();
          for (int i = 0; i < vars.size(); i++) {
            JaTSNode node = (JaTSNode) vars.elementAt(i);
            int jatsType = node.getVariableType();
            if (jatsType == JaTSNode.LITERAL) {
              jatsType = ( (JLiteral) node).getLiteralType();

            }
            UserJaTSVariable v = new UserJaTSVariable(jatsType,
                node.getVariableName(), null);
            listVars.addElement(v);
          }
          this.panelListVar1.setVariables(listVars);
        }
      }

    }
    catch (ParseException ex) {
      printMessage("Error parsing the following file : " + "\"" + parsingItem +
                   "\"", true);
      ex.printStackTrace();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    finally {
      this.setCursor(null);
    }
  }

  public void setTextArea(JTextArea textArea) {
    this.textArea = textArea;
  }

  private void printMessage(String msg, boolean isWarning) {
    String temp = textArea.getText();
    if (isWarning) {
      textArea.setCaretColor(Color.red);
    }
    else {
      textArea.setCaretColor(Color.black);
    }
    textArea.setText(temp + msg + "\n");
  }

}
