/* Generated By:JavaCC: Do not edit this line. JaTSParser.java */
package cin.jats.engine.parser.jats;


import java.util.Vector;
import java.util.List;
import java.util.ArrayList;
import java.io.Reader;
import java.io.StringReader;

import cin.jats.engine.parser.nodes.*;
import cin.jats.engine.parser.nodes.metajats.*;
import cin.jats.engine.parser.nodes.exceptions.*;
import cin.jats.engine.util.*;
import cin.jats.engine.transformation.*;

public class JaTSParser implements JaTSParserConstants {

    // Esta tabela guarda todos os ns arvore sinttica do programa analisado
    private static NodeTable table = new NodeTable();

    // Guarda a linha atual no arquivo. Comea com o valor 1.
    public static int line = 1;


    /**
     *  Reinicia os valores dos atributos do parser, j que o parser
     *   esttico
     */
     public static void restoreValues(){
         line = 1;
     }

    /**
     *  Retorna a linha atual do parser.
     */
    public static int getCurrentLine(){
        return line;
    }

    /**
     * Retorna a tabela de ns gerados no processo de parsing.
     */
    public static NodeTable getNodeTable() {
         return table;
    }

    /**
     * Acrescenta um novo n  tabela de ns do parser.
     */
    public static void addElement(JaTSNode node) {
            if(node == null) {
             throw new IllegalArgumentException("Erro ao "
                                 + "adicionar elemento \u00e0 tabela do parser."
                                 + " - Classe JaTSParser, m\u00e9todo "
                                 + "addElement().");
            }

            if(!node.isExecutable()) {
                table.addElement(node);
            }
    }

    public static void reInitTable(){
             table = new NodeTable();
    }


    public static void main(String args[]) throws Exception {
           System.out.println("ATENCAO: O c\u00f3digo deste m\u00e9todo foi movido para a classe:" +
                              " cin.jats.engine.parser.Main");

    }

/*****************************************
 * THE JATS LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/

/**
 * Raiz da arvore sintatica
 */
  static final public JaTSProgram MetaProgram() throws ParseException {
    JaTSProgram metaProgram = new JaTSProgram();
    Pattern pattern = null;
    JaTSNode stm = null;

    reInitTable();
    restoreValues();
    label_1:
    while (true) {
      if (jj_2_1(3)) {
        //metajats statement
             stm = MetaStatement();
                             metaProgram.addStatement(stm);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CLASS:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case INTERFACE:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case CONTEXT_DEC:
        case STM_LIST:
        case BLOCK:
        case ID:
        case ITERATIVE_DECLARATION:
        case LITERAL:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case LEXECDEC:
        case SEMICOLON:
        case INCR:
        case DECR:
          //java statement
               stm = BlockStatement(null);
                                  metaProgram.addStatement(stm);
          break;
        case EXPLORE:
        case CLASS_SET_PATTERN:
        case CLASS_PATTERN:
        case METHOD_PATTERN:
          //pattern decraration
               pattern = Pattern();
          jj_consume_token(SEMICOLON);
                               metaProgram.addStatement(pattern);
          break;
        default:
          jj_la1[0] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case INTERFACE:
      case LONG:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case EXPLORE:
      case CONTEXT_DEC:
      case CLASS_SET_PATTERN:
      case CLASS_PATTERN:
      case METHOD_PATTERN:
      case TRANSFORMATION:
      case CODE:
      case STM_LIST:
      case BLOCK:
      case ID:
      case ITERATIVE_DECLARATION:
      case LITERAL:
      case MODIFIER_LIST:
      case NAME:
      case RESULT_TYPE:
      case TYPE:
      case CONDITIONAL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
      case INCR:
      case DECR:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
    }
     {if (true) return metaProgram;}
    jj_consume_token(0);
    throw new Error("Missing return statement in function");
  }

  static final public MetaStatement MetaStatement() throws ParseException {
        MetaStatement metaStm = null;
    if (jj_2_2(3)) {
      metaStm = TransfDeclaration();
    } else if (jj_2_3(3)) {
      metaStm = CodeAssignStatement();
    } else if (jj_2_4(3)) {
      metaStm = ParsingStatement();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        metaStm = RSetEntryStatement();
        break;
      default:
        jj_la1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                {if (true) return metaStm;}
    throw new Error("Missing return statement in function");
  }

  static final public RSetEntryStatement RSetEntryStatement() throws ParseException {
        RSetEntryStatement node = null;
        Token rsetId = null, jatsVar = null, valueId = null, pos = null;
    rsetId = jj_consume_token(IDENTIFIER);
    jj_consume_token(177);
    jj_consume_token(LPAREN);
    jatsVar = jj_consume_token(JIDENTIFIER);
    jj_consume_token(COMMA);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      valueId = jj_consume_token(IDENTIFIER);
      break;
    case LBRACKET:
      jj_consume_token(LBRACKET);
      valueId = jj_consume_token(IDENTIFIER);
      jj_consume_token(COMMA);
      pos = jj_consume_token(IDENTIFIER);
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
                String posId = null;
                if (pos != null) posId = pos.image;
                node = new RSetEntryStatement(rsetId.image, jatsVar.image,
                                              valueId.image, posId);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public ParsingStatement ParsingStatement() throws ParseException {
        Token t = null, id = null;
        String code = "";
        ParsingStatement node = null;
        Token first = null, last = null;
    if (jj_2_5(2147483647)) {
      t = jj_consume_token(STM_LIST);
      id = jj_consume_token(IDENTIFIER);
      jj_consume_token(177);
      jj_consume_token(LBRACE);
                first = getToken(1);
      StatementList();
                                                         last = getToken(0);
      jj_consume_token(RBRACE);
      jj_consume_token(SEMICOLON);
    } else if (jj_2_6(2147483647)) {
      t = jj_consume_token(MODIFIER_LIST);
      id = jj_consume_token(IDENTIFIER);
      jj_consume_token(177);
      jj_consume_token(LBRACE);
                first = getToken(1);
      Modifiers();
                                                     last = getToken(0);
      jj_consume_token(RBRACE);
      jj_consume_token(SEMICOLON);
    } else if (jj_2_7(2147483647)) {
      t = jj_consume_token(RESULT_TYPE);
      id = jj_consume_token(IDENTIFIER);
      jj_consume_token(177);
      jj_consume_token(LBRACE);
                first = getToken(1);
      ResultType();
                                                      last = getToken(0);
      jj_consume_token(RBRACE);
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAME:
        t = jj_consume_token(NAME);
        id = jj_consume_token(IDENTIFIER);
        jj_consume_token(177);
        jj_consume_token(LBRACE);
                first = getToken(1);
        Name();
                                                last = getToken(0);
        jj_consume_token(RBRACE);
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                code = ParserHelper.generateString(first, last);
                node = new ParsingStatement(t.image, id.image, code);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public CodeAssignStatement CodeAssignStatement() throws ParseException {
        Token id = null;
        Token lit = null;
        CodeAssignStatement node = null;
        ApplyExpression apply = null;
        Object expression = null;
    jj_consume_token(CODE);
    id = jj_consume_token(IDENTIFIER);
    jj_consume_token(177);
    if (jj_2_8(2)) {
      jj_consume_token(LOAD);
      jj_consume_token(LPAREN);
      lit = jj_consume_token(STRING_LITERAL);
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        apply = ApplyExpression();
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(SEMICOLON);
                if (lit != null) expression = lit.image;
                else expression = apply;
                node = new CodeAssignStatement(id.image, expression);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public ApplyExpression ApplyExpression() throws ParseException {
        ApplyExpression node = null;
        Token sourceId = null, transfId = null, rSetId = null;
    sourceId = jj_consume_token(IDENTIFIER);
    jj_consume_token(178);
    transfId = jj_consume_token(IDENTIFIER);
    jj_consume_token(SLASH);
    rSetId = jj_consume_token(IDENTIFIER);
                node = new ApplyExpression(sourceId.image, transfId.image, rSetId.image);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public TransfDeclaration TransfDeclaration() throws ParseException {
        TransfDeclaration resultNode = null;
        Token id = null, sourcePtnId = null, targetPtnId = null;
    jj_consume_token(TRANSFORMATION);
    id = jj_consume_token(IDENTIFIER);
    jj_consume_token(177);
    sourcePtnId = jj_consume_token(JIDENTIFIER);
    jj_consume_token(179);
    targetPtnId = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
                resultNode = new TransfDeclaration(id.image, sourcePtnId.image, targetPtnId.image);

                {if (true) return resultNode;}
    throw new Error("Missing return statement in function");
  }

  static final public Pattern Pattern() throws ParseException {
    Pattern p = new Pattern();
    JaTSNode pBody = null;
    JIdentifier id = null;
    Token first = null, last = null;
      first = getToken(1);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXPLORE:
      pBody = ExploreDeclaration();
      break;
    case CLASS_SET_PATTERN:
      jj_consume_token(CLASS_SET_PATTERN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        id = Identifier();
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      pBody = ExploreDeclaration();
      jj_consume_token(RBRACE);
      break;
    case CLASS_PATTERN:
      jj_consume_token(CLASS_PATTERN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        id = Identifier();
        break;
      default:
        jj_la1[7] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      if (jj_2_9(2147483647)) {
        pBody = ExploreDeclaration();
      } else {
        pBody = CompilationUnit();
      }
      jj_consume_token(RBRACE);
      break;
    case METHOD_PATTERN:
      jj_consume_token(METHOD_PATTERN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        id = Identifier();
        break;
      default:
        jj_la1[8] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      pBody = MethodDeclaration();
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      last = getToken(0);
        p.setBody(pBody);
        String str = ParserHelper.generateString(first, last);
        p.setFlatPattern(str);
        if (id != null) {
            p.setName(id);
        }
        {if (true) return p;}
    throw new Error("Missing return statement in function");
  }

  static final public JCompilationUnit CompilationUnit() throws ParseException {
    JCompilationUnit retorno = new JCompilationUnit();

    // pre-condicao
    JPreconditionDeclaration pre = null;
    // package
    JPackageDeclaration pack = null;
    // imports
    ImportDeclarations imports = retorno.getImports();
    JImportDeclarationSet importSet = imports.getImportsSet();
    NodeList importVarSet = imports.getImportVarSet();
    NodeList importsVarSet = imports.getImportsVarSet();
    JImportDeclaration tmpImport = null;
    JImportDeclarationSet importsVarDec = null;

    // tipos declarados
    JTypeDeclaration tmp;
    NodeList types = new NodeList();
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 180:
        pre = PreconditionDeclaration();
                                        retorno.setPrecondition(pre);
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      if (jj_2_10(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOPTDEC:
          jj_consume_token(LOPTDEC);
          pack = PackageDeclaration();
          jj_consume_token(ROPTCDEC);
              pack.setOptional(true);
              retorno.setPackage(pack);
          break;
        case PACKAGE:
        case PACKAGE_DECLARATION:
          pack = PackageDeclaration();
              retorno.setPackage(pack);
          break;
        default:
          jj_la1[11] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else {
        ;
      }
      label_2:
      while (true) {
        if (jj_2_11(2147483647)) {
          ;
        } else {
          break label_2;
        }
        if (jj_2_12(2147483647)) {
          tmpImport = ImportVarDeclaration();
          jj_consume_token(SEMICOLON);
             importVarSet.addElement(tmpImport);
        } else if (jj_2_13(2147483647)) {
          importsVarDec = ImportsVarDeclaration();
          jj_consume_token(SEMICOLON);
              importsVarSet.addElement(importsVarDec);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IMPORT:
          case IMPORT_DECLARATION:
            tmpImport = ImportDeclaration();
            jj_consume_token(SEMICOLON);
              importSet.add(tmpImport);
            break;
          default:
            jj_la1[12] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case CLASS:
        case FINAL:
        case INTERFACE:
        case PUBLIC:
        case STRICTFP:
        case MODIFIER_LIST:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_3;
        }
        tmp = TypeDeclaration();
                               types.addElement(tmp);
      }
    } catch (ParseException e) {
      {if (true) throw new JParseException(e,line);}
    }
     retorno.setTypeDeclarationList(types);
     retorno.setTable(table);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 *  Pre-condicao. Construcao JaTS, usadas para templates do lado
 *  direito
 */
  static final public JPreconditionDeclaration PreconditionDeclaration() throws ParseException {
    JPreconditionDeclaration retorno = null;
    JExecutableDeclaration execDec = null;
    Token tk = null;
    JLiteral l = null;
    JExpression exp = null;
    if (jj_2_14(2147483647)) {
      jj_consume_token(180);
      exp = Literal();
      jj_consume_token(181);
               addElement(exp);
               retorno = new JPreconditionDeclaration((JLiteral)exp);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 180:
        jj_consume_token(180);
        exp = Expression();
        jj_consume_token(181);
           JExecutableDeclaration exec = new JExecutableDeclaration(exp);
               exec.setExpressionType(JExecutableDeclaration.INFORMATION_EXTRACTING);
           retorno = new JPreconditionDeclaration(exec);
           retorno.setLine(line);
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de pacote
 */
  static final public JPackageDeclaration PackageDeclaration() throws ParseException {
    JPackageDeclaration retorno = new JPackageDeclaration();
    JName name = new JName();
    Token varName = null;
    JExecutableDeclaration execDec = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PACKAGE_DECLARATION:
      jj_consume_token(PACKAGE_DECLARATION);
      jj_consume_token(COLON);
      if (jj_2_15(2147483647)) {
        execDec = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.PACKAGE_DECLARATION);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JIDENTIFIER:
          varName = jj_consume_token(JIDENTIFIER);
          jj_consume_token(SEMICOLON);
            retorno.setVariableName(varName.image);
            retorno.setVariableType(JaTSNode.PACKAGE_DECLARATION);
          break;
        default:
          jj_la1[15] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    case PACKAGE:
      jj_consume_token(PACKAGE);
      name = Name();
               retorno.setName(name);
               retorno.setLine(line);
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    addElement(retorno);
    retorno.setLine(line);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de import, ex:
 *
 *  import java.io.Serializable;
 */
  static final public JImportDeclaration ImportDeclaration() throws ParseException {
   JImportDeclaration retorno = new JImportDeclaration();
   JName importc = null;
   JExecutableDeclaration execDec = null;
   JIdentifier classe = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IMPORT_DECLARATION:
      jj_consume_token(IMPORT_DECLARATION);
      jj_consume_token(COLON);
      execDec = ExecutableDeclaration();
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.IMPORT_DECLARATION);
      break;
    case IMPORT:
      jj_consume_token(IMPORT);
      importc = Name();
            retorno.setPackageName(importc);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        if (jj_2_16(2147483647)) {
          jj_consume_token(DOT);
          classe = Identifier();
              retorno.setClassName(classe);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
            jj_consume_token(DOT);
            jj_consume_token(STAR);
                     retorno.setImportAllClasses(true);
            break;
          default:
            jj_la1[17] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
       // diz se o n correspondente ao nome do pacote/classe
       // importados tem corpo, isto , o nome no  executvel
       // ou varivel
       boolean nameHasBody = importc != null &&
                             importc.isASourceNode();


       // se for uma instruo de import especfico e o nome da
       // classe no foi setado (por causa da produo Name(), que
       // engloba todo o nome),  preciso remover o nome da classe
       // que corresponde ao pacote e setar o nome corretamente.


       if (nameHasBody && !retorno.importAllClasses() &&
              classe == null && importc != null){

           // o nome da classe  o ltimo elemento do name
           classe = importc.getIdentifierAt(importc.size() -1);

           // remove o nome da classe
           importc.removeIdentifierAt(importc.size() -1);

           // seta o nome do pacote
           retorno.setPackageName(importc);

           // seta o nome da classe
           retorno.setClassName(classe);
       }
           addElement(retorno);
           retorno.setLine(line);
           {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Variavel do tipo Declaracao de import, ex:
 *
 *  #imp:ImportDeclaration;
 */
  static final public JImportDeclaration ImportVarDeclaration() throws ParseException {
    Token t = null;
    JImportDeclaration retorno  = new JImportDeclaration();
    jj_consume_token(IMPORT_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.IMPORT_DECLARATION);
       addElement(retorno);
       retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Variavel do tipo Conjunto de declaracao de import, ex:
 *
 *  #ImportSet:ImportDeclarationSet;
 */
  static final public JImportDeclarationSet ImportsVarDeclaration() throws ParseException {
    Token t = null;
    JImportDeclarationSet retorno  = new JImportDeclarationSet();
    jj_consume_token(IMPORT_DECLARATION_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.IMPORT_DECLARATION_SET);
       addElement(retorno);
       retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 *  Declaracao de tipo. Pode ser uma classe ou interface
 *  Esse n no pode ser varivel
 */
  static final public JTypeDeclaration TypeDeclaration() throws ParseException {
    JClassDeclaration classDec = new JClassDeclaration();
    JInterfaceDeclaration interfaceDec = new JInterfaceDeclaration();
    JTypeDeclaration retorno = null;
    if (jj_2_17(2147483647)) {
      classDec = ClassDeclaration();
    retorno = classDec;
    } else if (jj_2_18(2147483647)) {
      interfaceDec = InterfaceDeclaration();
    retorno = interfaceDec;
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
            {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de classe
 */
  static final public JClassDeclaration ClassDeclaration() throws ParseException {
    JClassDeclaration retorno = new JClassDeclaration();
    JModifierList mods = new JModifierList(JModifierList.CLASS_DECLARATION);
    // tokens auxiliares, para o comentario
    Token first = null, last = null;
    first = getToken(1);
    if (jj_2_19(2147483647)) {
      mods = ModifierList(JModifierList.CLASS_DECLARATION);
    } else {
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case FINAL:
        case PUBLIC:
        case STRICTFP:
          ;
          break;
        default:
          jj_la1[21] = jj_gen;
          break label_4;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
          jj_consume_token(ABSTRACT);
                            mods.addModifier(JModifier.ABSTRACT);
          break;
        case FINAL:
          jj_consume_token(FINAL);
                         mods.addModifier(JModifier.FINAL);
          break;
        case PUBLIC:
          jj_consume_token(PUBLIC);
                          mods.addModifier(JModifier.PUBLIC);
          break;
        case STRICTFP:
          jj_consume_token(STRICTFP);
                            mods.addModifier(JModifier.STRICT);
          break;
        default:
          jj_la1[22] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    retorno.setModifiers(mods);
    last = getToken(0);
    retorno = UnmodifiedClassDeclaration(retorno);
     // Modificadores so adicionados aqui por no terem uma produo "s deles".
     addElement(mods);
     String comment = ParserHelper.generateSpecialTokenString(first, last);
     if (comment != null && comment.length() > 0) {
        retorno.setComment(new JComment(comment));
     }
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de classe sem modificadores
 */
  static final public JClassDeclaration UnmodifiedClassDeclaration(JClassDeclaration classDec) throws ParseException {
    JName superClass = null;
    JName name1 = null;
    JName name2 = null;
    OrDeclaration or = new OrDeclaration();
    OrDeclaration or_nl = new OrDeclaration();

    JIdentifier id = null;
    JNameList interfaces = new JNameList();
    JNameList nl1 = new JNameList();
    JNameList nl2 = new JNameList();
    interfaces.setOptional(true);
    TypeBody body = null;
    Token first = null, last = null;
   first = getToken(1);
    jj_consume_token(CLASS);
    id = Identifier();
   last = getToken(0);
    if (jj_2_22(2147483647)) {
      if (jj_2_20(2147483647)) {
        jj_consume_token(LOPTDEC);
        jj_consume_token(EXTENDS);
        jj_consume_token(LPAREN);
        name1 = Name();
        jj_consume_token(BIT_OR);
        name2 = Name();
        jj_consume_token(RPAREN);
        jj_consume_token(ROPTCDEC);
             superClass = new JName();
                 superClass.setOptional(true);
                 or.setChoice1(name1);
             or.setChoice2(name2);
             superClass.setOrDeclaration(or);
             superClass.setVariable(true);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOPTDEC:
          jj_consume_token(LOPTDEC);
          jj_consume_token(EXTENDS);
          superClass = Name();
          jj_consume_token(ROPTCDEC);
               superClass.setOptional(true);
          break;
        default:
          jj_la1[23] = jj_gen;
          if (jj_2_21(2147483647)) {
            jj_consume_token(EXTENDS);
            jj_consume_token(LPAREN);
            name1 = Name();
            jj_consume_token(BIT_OR);
            name2 = Name();
            jj_consume_token(RPAREN);
             superClass = new JName();
                 or.setChoice1(name1);
             or.setChoice2(name2);
             superClass.setOrDeclaration(or);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case EXTENDS:
              jj_consume_token(EXTENDS);
              superClass = Name();
              break;
            default:
              jj_la1[24] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
    } else {
      ;
    }
    if (jj_2_25(2147483647)) {
      if (jj_2_23(2147483647)) {
        jj_consume_token(LOPTDEC);
        jj_consume_token(IMPLEMENTS);
        jj_consume_token(LPAREN);
        nl1 = NameList();
        jj_consume_token(BIT_OR);
        nl2 = NameList();
        jj_consume_token(RPAREN);
        jj_consume_token(ROPTCDEC);
                interfaces.setOptional(true);
                or_nl.setChoice1(nl1);
                or_nl.setChoice2(nl2);
                interfaces.setOrDeclaration(or_nl);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOPTDEC:
          jj_consume_token(LOPTDEC);
          jj_consume_token(IMPLEMENTS);
          interfaces = NameList();
          jj_consume_token(ROPTCDEC);
               interfaces.setOptional(true);
          break;
        default:
          jj_la1[25] = jj_gen;
          if (jj_2_24(2147483647)) {
            jj_consume_token(IMPLEMENTS);
            jj_consume_token(LPAREN);
            nl1 = NameList();
            jj_consume_token(BIT_OR);
            nl2 = NameList();
            jj_consume_token(RPAREN);
                interfaces.setOptional(false);
                or_nl.setChoice1(nl1);
                or_nl.setChoice2(nl2);
                interfaces.setOrDeclaration(or_nl);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case IMPLEMENTS:
              jj_consume_token(IMPLEMENTS);
              interfaces = NameList();
           interfaces.setOptional(false);
              break;
            default:
              jj_la1[26] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
    } else {
      ;
    }
    body = ClassBody(classDec);
     if (!classDec.hasComment()){
         String comment = ParserHelper.generateSpecialTokenString(first, last);
         if (comment != null && comment.length() > 0) {
             classDec.setComment(new JComment(comment));
         }
     }

     classDec.setName(id);
     if (superClass != null) {
            classDec.setSuperClass(superClass);
     }

        classDec.setInterfaces(interfaces);

     if(body!=null) {
            classDec.setBody(body);
     }

     {if (true) return classDec;}
    throw new Error("Missing return statement in function");
  }

/**
 * Corpo da classe
 */
  static final public TypeBody ClassBody(JClassDeclaration classDec) throws ParseException {
    TypeBody retorno = new TypeBody();
    jj_consume_token(LBRACE);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case CLASS:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case INTERFACE:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case BLOCK:
      case CLASS_DECLARATION:
      case CONSTRUCTOR_DECLARATION:
      case CONSTRUCTOR_DECLARATION_SET:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case INITIALIZER:
      case INITIALIZER_SET:
      case ITERATIVE_DECLARATION:
      case INTERFACE_DECLARATION:
      case INTERFACE_DECLARATION_SET:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[27] = jj_gen;
        break label_5;
      }
      ClassBodyDeclaration(retorno, classDec);
    }
    jj_consume_token(RBRACE);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de classe aninhada (Inner-class)
 */
  static final public JClassDeclaration NestedClassDeclaration() throws ParseException {
   JClassDeclaration inner = new JClassDeclaration();
   JModifierList modList = new JModifierList(JModifierList.NESTED_TYPE_DECLARATION);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[28] = jj_gen;
        break label_6;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                modList.addModifier(JModifier.ABSTRACT);
        break;
      case FINAL:
        jj_consume_token(FINAL);
             modList.addModifier(JModifier.FINAL);
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
              modList.addModifier( JModifier.PUBLIC);
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                modList.addModifier(JModifier.STRICT);
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                modList.addModifier(JModifier.PROTECTED);
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
              modList.addModifier(JModifier.PRIVATE);
        break;
      case STATIC:
        jj_consume_token(STATIC);
             modList.addModifier(JModifier.STATIC);
        break;
      default:
        jj_la1[29] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    inner = UnmodifiedClassDeclaration(inner);
      inner.setModifiers(modList);
      {if (true) return inner;}
    throw new Error("Missing return statement in function");
  }

  static final public void ClassBodyDeclaration(TypeBody body, JClassDeclaration classDec) throws ParseException {
    OtherDeclarationsSet bodyOtherDecsSet = body.getOtherDeclarationsSet();

    JFieldDeclaration field = new JFieldDeclaration();
    JFieldDeclarationSet fieldSet = new JFieldDeclarationSet();

    JMethodDeclaration method = new JMethodDeclaration();
    JMethodDeclarationSet methodSet = new JMethodDeclarationSet();

    JConstructorDeclaration constructor = new JConstructorDeclaration();
    JConstructorDeclarationSet constructorSet = new JConstructorDeclarationSet();

    JTypeDeclaration type = new JClassDeclaration();
    TypeDeclarationSet typeSet = new TypeDeclarationSet();


    JaTSNode jNode = null;
    JInitializer jInit = null;
    JInitializerSet jInitSet = null;
    if (jj_2_26(2147483647)) {
      jInit = Initializer();
     body.addInitializer(jInit);
    } else if (jj_2_27(2147483647)) {
      jInit = InitializerVar();
     body.addInitializerVar(jInit);
    } else if (jj_2_28(2147483647)) {
      type = ClassVarDeclaration();
     body.addTypeVarDeclaration(type);
    } else if (jj_2_29(2147483647)) {
      type = InterfaceVarDeclaration();
     body.addTypeVarDeclaration(type);
    } else if (jj_2_30(2147483647)) {
      typeSet = ClassVarsDeclaration();
     body.addTypeVarsDeclaration(typeSet);
    } else if (jj_2_31(2147483647)) {
      typeSet = InterfaceVarsDeclaration();
     body.addTypeVarsDeclaration(typeSet);
    } else if (jj_2_32(2147483647)) {
      jInitSet = InitializerSetVar();
     body.addInitializerSetVar(jInitSet);
    } else if (jj_2_33(2147483647)) {
      type = NestedClassDeclaration();
      body.addTypeDeclaration(type);
    } else if (jj_2_34(2147483647)) {
      type = NestedInterfaceDeclaration();
      body.addTypeDeclaration(type);
    } else if (jj_2_35(2147483647)) {
      constructor = ConstructorVarDeclaration();
           body.addConstructorVarDeclaration(constructor);
    } else if (jj_2_36(2147483647)) {
      constructorSet = ConstructorsVarDeclaration();
           body.addConstructorsVarDeclaration(constructorSet);
    } else if (jj_2_37(2147483647)) {
      constructor = ConstructorDeclaration();
        body.addConstructorDeclaration(constructor);
    } else if (jj_2_38(2147483647)) {
      method = MethodVarDeclaration();
    body.addMethodVarDeclaration(method);
    } else if (jj_2_39(2147483647)) {
      methodSet = MethodsVarDeclaration();
    body.addMethodsVarDeclaration(methodSet);
    } else if (jj_2_40(2147483647)) {
      field = FieldVarDeclaration();
    body.addFieldVarDeclaration(field);
    } else if (jj_2_41(2147483647)) {
      fieldSet = FieldsVarDeclaration();
    body.addFieldsVarDeclaration(fieldSet);
    } else if (jj_2_42(2147483647)) {
      jNode = ClassBodyIterativeDeclaration(bodyOtherDecsSet);
     body.addIterativeDeclaration(jNode);
    } else if (jj_2_43(2147483647)) {
      jNode = ClassBodyConditionalDeclaration(bodyOtherDecsSet);
     bodyOtherDecsSet.addConditionalDeclaration(jNode);
    } else if (jj_2_44(2147483647)) {
      method = MethodDeclaration();
    body.addMethodDeclaration(method);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
      case FIELD_DECLARATION:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        field = FieldDeclaration();
    body.addFieldDeclaration(field);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[30] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * Declaracao de interface
 */
  static final public JInterfaceDeclaration InterfaceDeclaration() throws ParseException {
    JInterfaceDeclaration  retorno = new JInterfaceDeclaration();
    JModifierList mods = new JModifierList(JModifierList.INTERFACE_DECLARATION);
    Token first = null, last = null;
   first = getToken(1);
    if (jj_2_45(2147483647)) {
      mods = ModifierList(JModifierList.INTERFACE_DECLARATION);
    } else {
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case PUBLIC:
        case STRICTFP:
          ;
          break;
        default:
          jj_la1[31] = jj_gen;
          break label_7;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
          jj_consume_token(ABSTRACT);
                            mods.addModifier(JModifier.ABSTRACT);
          break;
        case PUBLIC:
          jj_consume_token(PUBLIC);
                          mods.addModifier(JModifier.PUBLIC);
          break;
        case STRICTFP:
          jj_consume_token(STRICTFP);
                            mods.addModifier(JModifier.STRICT);
          break;
        default:
          jj_la1[32] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
   last = getToken(0);
     retorno.setModifiers(mods);
    UnmodifiedInterfaceDeclaration(retorno);
     String comment = ParserHelper.generateSpecialTokenString(first,last);
     if (comment != null && comment.length() > 0) {
     retorno.setComment(new JComment(comment));
     }

     // Modificadores so adicionados aqui por no terem uma produo "s deles".
     addElement(mods);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de interface aninhada (inner-interface)
 */
  static final public JTypeDeclaration NestedInterfaceDeclaration() throws ParseException {
    JTypeDeclaration retorno = new JInterfaceDeclaration();
    JModifierList modList = new JModifierList(JModifierList.NESTED_TYPE_DECLARATION);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_8;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STATIC:
        jj_consume_token(STATIC);
                  modList.addModifier(JModifier.STATIC);
        break;
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                   modList.addModifier(JModifier.ABSTRACT);
        break;
      case FINAL:
        jj_consume_token(FINAL);
                modList.addModifier(JModifier.FINAL);
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                 modList.addModifier(JModifier.PUBLIC);
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                    modList.addModifier(JModifier.PROTECTED);
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                  modList.addModifier(JModifier.PRIVATE);
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                   modList.addModifier(JModifier.STRICT);
        break;
      default:
        jj_la1[34] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    UnmodifiedInterfaceDeclaration(new JInterfaceDeclaration());
     retorno.setModifiers(modList);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de interface sem modificadores
 */
  static final public void UnmodifiedInterfaceDeclaration(JInterfaceDeclaration iDec) throws ParseException {
     JNameList names1 = null;
    JNameList names2 = null;
    OrDeclaration or = new OrDeclaration();
    OrDeclaration or_nl = new OrDeclaration();

    JIdentifier id = new JIdentifier();
    JNameList interfaces = new JNameList();
    Token  first, last = null;
   first = getToken(1);
    jj_consume_token(INTERFACE);
   last = getToken(0);
    id = Identifier();
     iDec.setName(id);
    if (jj_2_48(2147483647)) {
      if (jj_2_46(2147483647)) {
        jj_consume_token(LOPTDEC);
        jj_consume_token(EXTENDS);
        jj_consume_token(LPAREN);
        names1 = NameList();
        jj_consume_token(BIT_OR);
        names2 = NameList();
        jj_consume_token(RPAREN);
        jj_consume_token(ROPTCDEC);
             interfaces = new JNameList();
                 interfaces.setOptional(true);
                 or.setChoice1(names1);
             or.setChoice2(names2);
             interfaces.setOrDeclaration(or);
             interfaces.setVariable(true);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOPTDEC:
          jj_consume_token(LOPTDEC);
          jj_consume_token(EXTENDS);
          interfaces = NameList();
          jj_consume_token(ROPTCDEC);
               interfaces.setOptional(true);
          break;
        default:
          jj_la1[35] = jj_gen;
          if (jj_2_47(2147483647)) {
            jj_consume_token(EXTENDS);
            jj_consume_token(LPAREN);
            names1 = NameList();
            jj_consume_token(BIT_OR);
            names2 = NameList();
            jj_consume_token(RPAREN);
             interfaces = new JNameList();
                 or.setChoice1(names1);
             or.setChoice2(names2);
             interfaces.setOrDeclaration(or);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case EXTENDS:
              jj_consume_token(EXTENDS);
              interfaces = NameList();
               interfaces.setOptional(false);
              break;
            default:
              jj_la1[36] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
    } else {
      ;
    }
     iDec.setInterfaces(interfaces);
    jj_consume_token(LBRACE);
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case CLASS:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case INTERFACE:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case ITERATIVE_DECLARATION:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[37] = jj_gen;
        break label_9;
      }
      InterfaceMemberDeclaration(iDec);
    }
    jj_consume_token(RBRACE);
     if (!iDec.hasComment()) {
          String comment = ParserHelper.generateSpecialTokenString(first,last);
          if (comment != null && comment.length() > 0) {
             iDec.setComment(new JComment(comment));
          }
     }
  }

/**
 *  Declaracoes de membros da interface (metodos e atributos (somente
 *  podendo ter os modificadores public static e final))
 */
  static final public void InterfaceMemberDeclaration(JInterfaceDeclaration interfaceDec) throws ParseException {
  JMethodDeclaration md = null;
  JMethodDeclaration varMd = null;
  JMethodDeclarationSet mds = null;

  JFieldDeclaration fd = null;
  JFieldDeclaration varFd = null;
  JFieldDeclarationSet fds = null;

  TypeBody body = interfaceDec.getBody();
  OtherDeclarationsSet bodyOtherDecsSet = body.getOtherDeclarationsSet();
  JaTSNode jnode = null;
    if (jj_2_49(2147483647)) {
      NestedClassDeclaration();
    } else if (jj_2_50(2147483647)) {
      NestedInterfaceDeclaration();
    } else if (jj_2_51(2147483647)) {
      jnode = InterfaceBodyIterativeDeclaration(interfaceDec);
      bodyOtherDecsSet.addIterativeDeclaration(jnode);
    } else if (jj_2_52(2147483647)) {
      jnode = InterfaceBodyConditionalDeclaration(interfaceDec);
      bodyOtherDecsSet.addConditionalDeclaration(jnode);
    } else if (jj_2_53(2147483647)) {
      varMd = MethodVarDeclaration();
                                  interfaceDec.addMethodVarDeclaration(varMd);
    } else if (jj_2_54(2147483647)) {
      mds = MethodsVarDeclaration();
                                 interfaceDec.addMethodsVarDeclaration(mds);
    } else if (jj_2_55(2147483647)) {
      md = MethodDeclaration();
     interfaceDec.addMethodDeclaration(md);
    } else if (jj_2_56(2147483647)) {
      varFd = FieldVarDeclaration();
                                  interfaceDec.addFieldVarDeclaration(varFd);
    } else if (jj_2_57(2147483647)) {
      fds = FieldsVarDeclaration();
                                 interfaceDec.addFieldsVarDeclaration(fds);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
      case FIELD_DECLARATION:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        fd = FieldDeclaration();
     interfaceDec.addFieldDeclaration(fd);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[38] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * Variavel ou expressao executavel correspondente a uma lista de
 * modificadores.
 */
  static final public JModifierList ModifierList(int pmods) throws ParseException {
    JModifierList retorno = new JModifierList(pmods);
    JExecutableDeclaration execDec = null;
    Token varName = null;
    jj_consume_token(MODIFIER_LIST);
    jj_consume_token(COLON);
    if (jj_2_58(2147483647)) {
      execDec = ExecutableDeclaration();
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.MODIFIER_LIST);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JIDENTIFIER:
        varName = jj_consume_token(JIDENTIFIER);
              retorno.setVariableName(varName.image);
              retorno.setVariableType(JaTSNode.MODIFIER_LIST);
        break;
      default:
        jj_la1[39] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      addElement(retorno);
          {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

// Esta produo de incio no ser chamada por nenhuma outra.
// ela est aqui, por uma razo simples: gerar o mtodo que faa
// o parsing correto de uma String contendo modificadores.
// Possivelmente, poderemos us-la nas demais produes onde 
// possvel termos modificadores, mas, por enquanto, ainda no
// poderemos, pois precisaramos saber fazer parsing condicional
// diferente do que se faz com o lookahead
  static final public JModifierList Modifiers() throws ParseException {
   JModifierList retorno = new JModifierList();
   int mod = 0;
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case FINAL:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOLATILE:
      case STRICTFP:
        ;
        break;
      default:
        jj_la1[40] = jj_gen;
        break label_10;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
        jj_consume_token(ABSTRACT);
                  retorno.addModifier(JModifier.ABSTRACT);
        break;
      case PUBLIC:
        jj_consume_token(PUBLIC);
                 retorno.addModifier(JModifier.PUBLIC);
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                    retorno.addModifier(JModifier.PROTECTED);
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                  retorno.addModifier(JModifier.PRIVATE);
        break;
      case STRICTFP:
        jj_consume_token(STRICTFP);
                   retorno.addModifier(JModifier.STRICT);
        break;
      case STATIC:
        jj_consume_token(STATIC);
                 retorno.addModifier(JModifier.STATIC);
        break;
      case FINAL:
        jj_consume_token(FINAL);
                retorno.addModifier(JModifier.FINAL);
        break;
      case TRANSIENT:
        jj_consume_token(TRANSIENT);
                    retorno.addModifier( JModifier.TRANSIENT);
        break;
      case VOLATILE:
        jj_consume_token(VOLATILE);
                   retorno.addModifier( JModifier.VOLATILE);
        break;
      case NATIVE:
        jj_consume_token(NATIVE);
                 retorno.addModifier( JModifier.NATIVE);
        break;
      case SYNCHRONIZED:
        jj_consume_token(SYNCHRONIZED);
                       retorno.addModifier( JModifier.SYNCHRONIZED);
        break;
      default:
        jj_la1[41] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao executavel. Pode ser uma declaracao do tipo
 * information-extracting, exemplo: [[#md.getName()]] ou do tipo
 * information-modifying, exemplo: [[#tmp = #md :: #tmp.addException("Exception")]]
 */
  static final public JExecutableDeclaration ExecutableDeclaration() throws ParseException {
    JExecutableDeclaration retorno = null;
    NodeList exps = new NodeList();
    Token t = null;
    Token u = null;
    JExpression tempExp = null;
    if (jj_2_60(2147483647)) {
      jj_consume_token(LEXECDEC);
      tempExp = Expression();
      jj_consume_token(REXECDEC);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEXECDEC:
        jj_consume_token(LEXECDEC);
        u = jj_consume_token(JIDENTIFIER);
        jj_consume_token(ASSIGN);
        t = jj_consume_token(JIDENTIFIER);
        jj_consume_token(EXECDECSEPARATOR);
        tempExp = Expression();
                                                                                             exps.addElement(tempExp);
        label_11:
        while (true) {
          if (jj_2_59(2147483647)) {
            ;
          } else {
            break label_11;
          }
          jj_consume_token(SEMICOLON);
          tempExp = Expression();
                                                                 exps.addElement(tempExp);
        }
        jj_consume_token(REXECDEC);
        break;
      default:
        jj_la1[42] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        if(t == null) {
            retorno = new JExecutableDeclaration(tempExp);
            retorno.setExpressionType(JExecutableDeclaration.INFORMATION_EXTRACTING);
        }
        else {
           JIdentifier refVar = new JIdentifier(t.image);
           JIdentifier resNode = new JIdentifier(u.image);
           retorno = new JExecutableDeclaration(refVar, resNode, exps);
           retorno.setExpressionType(JExecutableDeclaration.INFORMATION_MODIFYING);
        }

    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de atributo. Exemplo:
 *
 * private String numero;
 */
  static final public JFieldDeclaration FieldDeclaration() throws ParseException {
    // declaracao de atributo
    JFieldDeclaration retorno = new JFieldDeclaration();
    // lista de modificadores
    JModifierList modList = new JModifierList(JModifierList.FIELD_DECLARATION);
    // tipo do atributo
    JType t = null ;
    //declarador da variavel
    JVariableDeclarator tmp = null;
    retorno.setVariables(new JVariableDeclaratorSet());
    // declaracao executavel associada
    JExecutableDeclaration execDec = null;
    // tokens auxiliares, para o comentario
    Token first = null, last = null;
    first = getToken(1);
    if (jj_2_62(2147483647)) {
      jj_consume_token(FIELD_DECLARATION);
      jj_consume_token(COLON);
      execDec = ExecutableDeclaration();
      jj_consume_token(SEMICOLON);
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.FIELD_DECLARATION);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case TRANSIENT:
      case VOLATILE:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_61(2147483647)) {
          modList = ModifierList(JModifierList.FIELD_DECLARATION);
        } else {
          label_12:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case FINAL:
            case PRIVATE:
            case PROTECTED:
            case PUBLIC:
            case STATIC:
            case TRANSIENT:
            case VOLATILE:
              ;
              break;
            default:
              jj_la1[43] = jj_gen;
              break label_12;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PUBLIC:
              jj_consume_token(PUBLIC);
                   modList.addModifier(JModifier.PUBLIC);
              break;
            case PROTECTED:
              jj_consume_token(PROTECTED);
                          modList.addModifier(JModifier.PROTECTED);
              break;
            case PRIVATE:
              jj_consume_token(PRIVATE);
                        modList.addModifier(JModifier.PRIVATE);
              break;
            case STATIC:
              jj_consume_token(STATIC);
                       modList.addModifier(JModifier.STATIC);
              break;
            case FINAL:
              jj_consume_token(FINAL);
                      modList.addModifier(JModifier.FINAL);
              break;
            case TRANSIENT:
              jj_consume_token(TRANSIENT);
                          modList.addModifier( JModifier.TRANSIENT);
              break;
            case VOLATILE:
              jj_consume_token(VOLATILE);
                         modList.addModifier( JModifier.VOLATILE);
              break;
            default:
              jj_la1[44] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      last = getToken(0);
      // Modificadores so adicionados aqui por no terem uma produo "s deles".
      addElement(modList);
      retorno.setModifiers(modList);
        t = Type();
                 retorno.setType(t);
        tmp = VariableDeclarator();
                                retorno.addVariable(tmp);
        label_13:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[45] = jj_gen;
            break label_13;
          }
          jj_consume_token(COMMA);
          tmp = VariableDeclarator();
                                       retorno.addVariable(tmp);
        }
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[46] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    String comment = ParserHelper.generateSpecialTokenString(first, last);
    if (comment != null && comment.length() > 0) {
        retorno.setComment(new JComment(comment));
    }
    addElement(retorno);
    retorno.setLine(line);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Variavel do tipo Declaracao de atributo. Exemplo:
 *
 * #att:FieldDeclaration;
 */
  static final public JFieldDeclaration FieldVarDeclaration() throws ParseException {
    JFieldDeclaration retorno = new JFieldDeclaration();
    Token t = null;
    jj_consume_token(FIELD_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.FIELD_DECLARATION);
       addElement(retorno);
       retorno.setLine(line);
           {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Variavel do tipo Conjunto  Declaracao de atributo. Exemplo:
 *
 * #atts:FieldDeclarationSet;
 */
  static final public JFieldDeclarationSet FieldsVarDeclaration() throws ParseException {
    JFieldDeclarationSet retorno  = new JFieldDeclarationSet();
    Token t = null;
    jj_consume_token(FIELD_DECLARATION_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.FIELD_DECLARATION_SET);
       addElement(retorno);
       retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declarador da variavel. Consiste do nome da variavel, seguido de uma
 * possivel inicializacao. Exemplo:
 *
 * a = 2
 * x = a + b
 */
  static final public JVariableDeclarator VariableDeclarator() throws ParseException {
    JVariableDeclarator retorno = new JVariableDeclarator();
    JaTSNode init = null ;
    JIdentifier id = null;
    Token t = null;
    JExecutableDeclaration execDec = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VARIABLE_DECLARATOR:
      jj_consume_token(VARIABLE_DECLARATOR);
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JIDENTIFIER:
        t = jj_consume_token(JIDENTIFIER);
            retorno.setVariableName(t.image);
            retorno.setVariableType(JaTSNode.VARIABLE_DECLARATOR);
        break;
      default:
        jj_la1[47] = jj_gen;
        if (jj_2_63(2147483647)) {
          execDec = ExecutableDeclaration();
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.VARIABLE_DECLARATOR);
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    case ID:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LEXECDEC:
      id = VariableDeclaratorId(retorno);
           retorno.setIdentifier(id);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        init = VariableInitializer();
                                              retorno.setInitializer(init);
        break;
      default:
        jj_la1[48] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        addElement(retorno);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Identificador da variavel. Exemplo:
 * a
 * array[]
 */
  static final public JIdentifier VariableDeclaratorId(JVariableDeclarator varDec) throws ParseException {
    JIdentifier id = null;
    int colchetes = 0;
    id = Identifier();
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[50] = jj_gen;
        break label_14;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
                               colchetes++;
    }
    varDec.setDimensions(colchetes);
    {if (true) return id;}
    throw new Error("Missing return statement in function");
  }

/**
 * Inicializador da variavel - consiste de uma expressao qualquer
 * ou um inicializador de array
 */
  static final public JaTSNode VariableInitializer() throws ParseException {
    JaTSNode retorno = null;
    if (jj_2_64(2147483647)) {
      retorno = ArrayInitializer();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case ID:
      case LITERAL:
      case NAME:
      case TYPE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LEXECDEC:
      case BANG:
      case TILDE:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
        retorno = Expression();
        break;
      default:
        jj_la1[51] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JArrayInitializer ArrayInitializer() throws ParseException {
    JArrayInitializer aInit = new JArrayInitializer();
    JaTSNode node = null;
    jj_consume_token(LBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case ID:
    case LITERAL:
    case NAME:
    case TYPE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LPAREN:
    case LBRACE:
    case LEXECDEC:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
      node = VariableInitializer();
                                       aInit.addInitializer(node);
      label_15:
      while (true) {
        if (jj_2_65(2147483647)) {
          ;
        } else {
          break label_15;
        }
        jj_consume_token(COMMA);
        node = VariableInitializer();
                                                      aInit.addInitializer(node);
      }
      break;
    default:
      jj_la1[52] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[53] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
      addElement(aInit);
      {if (true) return aInit;}
    throw new Error("Missing return statement in function");
  }

/**
 * Varivel correspondente a uma declarao de mtodo. Algo como:
 *
 * #md:MethodDeclaration
 */
  static final public JMethodDeclaration MethodVarDeclaration() throws ParseException {
    JMethodDeclaration retorno = new JMethodDeclaration();
    Token t = null;
    jj_consume_token(METHOD_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.METHOD_DECLARATION);

           addElement(retorno);
           retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Varivel correspondente a um conjunto de declaraes de mtodo.
 * Algo como:
 *
 * #mds:MethodDeclarationSet
 */
  static final public JMethodDeclarationSet MethodsVarDeclaration() throws ParseException {
    Token t = null;
    JMethodDeclarationSet retorno = new JMethodDeclarationSet();
    jj_consume_token(METHOD_DECLARATION_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.METHOD_DECLARATION_SET);
       addElement(retorno);
           retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Esta produo serve apenas para determinar a produo de mtodo
 * em um LOOKAHEAD
 */
  static final public void MethodDeclarationLookahead() throws ParseException {
    if (jj_2_67(2147483647)) {
      jj_consume_token(METHOD_DECLARATION);
      jj_consume_token(COLON);
      ExecutableDeclaration();
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case VOID:
      case STRICTFP:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_66(2147483647)) {
          ModifierList(JModifierList.METHOD_DECLARATION);
        } else {
          label_16:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case ABSTRACT:
            case FINAL:
            case NATIVE:
            case PRIVATE:
            case PROTECTED:
            case PUBLIC:
            case STATIC:
            case SYNCHRONIZED:
            case STRICTFP:
              ;
              break;
            default:
              jj_la1[54] = jj_gen;
              break label_16;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PUBLIC:
              jj_consume_token(PUBLIC);
              break;
            case PROTECTED:
              jj_consume_token(PROTECTED);
              break;
            case PRIVATE:
              jj_consume_token(PRIVATE);
              break;
            case STATIC:
              jj_consume_token(STATIC);
              break;
            case ABSTRACT:
              jj_consume_token(ABSTRACT);
              break;
            case FINAL:
              jj_consume_token(FINAL);
              break;
            case NATIVE:
              jj_consume_token(NATIVE);
              break;
            case SYNCHRONIZED:
              jj_consume_token(SYNCHRONIZED);
              break;
            case STRICTFP:
              jj_consume_token(STRICTFP);
              break;
            default:
              jj_la1[55] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        ResultType();
        Identifier();
        jj_consume_token(LPAREN);
        break;
      default:
        jj_la1[56] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/**
 * Declarao de mtodo. Algo como:
 *
 * public void m(int p) {
 *    // faz alguma coisa
 * }
 */
  static final public JMethodDeclaration MethodDeclaration() throws ParseException {
    JMethodDeclaration retorno  = new JMethodDeclaration();
    JModifierList modList = new JModifierList(JModifierList.METHOD_DECLARATION);
    JIdentifier id = null;
    JParameterList parameters = null;
    int brackets = 0;
    JNameList exc = new JNameList();
    JNameList nl1 = null;
    JNameList nl2 = null;
    OrDeclaration or = new OrDeclaration();
    JType resType = new JType();
    JExecutableDeclaration execDec = null;
    JBlock mBody = null;
    Token first = null;
    Token last = null;
    String javadoc = "";
   first = getToken(1);
    if (jj_2_73(2147483647)) {
      jj_consume_token(METHOD_DECLARATION);
      jj_consume_token(COLON);
      execDec = ExecutableDeclaration();
      jj_consume_token(SEMICOLON);
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.METHOD_DECLARATION);
            retorno.setLine(line);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case VOID:
      case STRICTFP:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_68(2147483647)) {
          modList = ModifierList(JModifierList.METHOD_DECLARATION);
        } else {
          label_17:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case ABSTRACT:
            case FINAL:
            case NATIVE:
            case PRIVATE:
            case PROTECTED:
            case PUBLIC:
            case STATIC:
            case SYNCHRONIZED:
            case STRICTFP:
              ;
              break;
            default:
              jj_la1[57] = jj_gen;
              break label_17;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PUBLIC:
              jj_consume_token(PUBLIC);
                 modList.addModifier(JModifier.PUBLIC);
              break;
            case PROTECTED:
              jj_consume_token(PROTECTED);
                    modList.addModifier(JModifier.PROTECTED);
              break;
            case PRIVATE:
              jj_consume_token(PRIVATE);
                  modList.addModifier(JModifier.PRIVATE);
              break;
            case STATIC:
              jj_consume_token(STATIC);
                 modList.addModifier(JModifier.STATIC);
              break;
            case ABSTRACT:
              jj_consume_token(ABSTRACT);
                   modList.addModifier(JModifier.ABSTRACT);
              break;
            case FINAL:
              jj_consume_token(FINAL);
                modList.addModifier(JModifier.FINAL);
              break;
            case NATIVE:
              jj_consume_token(NATIVE);
                 modList.addModifier(JModifier.NATIVE);
              break;
            case SYNCHRONIZED:
              jj_consume_token(SYNCHRONIZED);
                       modList.addModifier(JModifier.SYNCHRONIZED);
              break;
            case STRICTFP:
              jj_consume_token(STRICTFP);
                   modList.addModifier(JModifier.STRICT);
              break;
            default:
              jj_la1[58] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
   last = getToken(0);
    // Modificadores so adicionados aqui por no terem uma produo "s deles".
    addElement(modList);
    retorno.setModifiers(modList);
    // seta a linha aqui, pra ficar igual com a linha do nome do mtodo e no
    // a linha de encerramento do mtodo
    retorno.setLine(line);
        resType = ResultType();
                           retorno.setResultType(resType);
        id = Identifier();
      try {
          retorno.setName(JName.unwrapName(id));
      }
      catch(InconsistentNodeException ex){
          {if (true) throw new IllegalArgumentException("InvalidName");}
      }
        parameters = FormalParameters();
                                    retorno.setParameters(parameters);
        label_18:
        while (true) {
          if (jj_2_69(2147483647)) {
            ;
          } else {
            break label_18;
          }
          jj_consume_token(LBRACKET);
          jj_consume_token(RBRACKET);
                                   brackets++;
        }
                                                     retorno.setDimensions(brackets);
        if (jj_2_72(2147483647)) {
          if (jj_2_70(2147483647)) {
            jj_consume_token(LOPTDEC);
            jj_consume_token(THROWS);
            jj_consume_token(LPAREN);
            nl1 = NameList();
            jj_consume_token(BIT_OR);
            nl2 = NameList();
            jj_consume_token(RPAREN);
            jj_consume_token(ROPTCDEC);
              exc.setOptional(true);
              or.setChoice1(nl1);
          or.setChoice2(nl2);
              exc.setOrDeclaration(or);
              retorno.setExceptions(exc);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LOPTDEC:
              jj_consume_token(LOPTDEC);
              jj_consume_token(THROWS);
              exc = NameList();
              jj_consume_token(ROPTCDEC);
              exc.setOptional(true);
              retorno.setExceptions(exc);
              break;
            default:
              jj_la1[59] = jj_gen;
              if (jj_2_71(2147483647)) {
                jj_consume_token(THROWS);
                jj_consume_token(LPAREN);
                nl1 = NameList();
                jj_consume_token(BIT_OR);
                nl2 = NameList();
                jj_consume_token(RPAREN);
              or.setChoice1(nl1);
          or.setChoice2(nl2);
              exc.setOrDeclaration(or);
              retorno.setExceptions(exc);
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case THROWS:
                  jj_consume_token(THROWS);
                  exc = NameList();
             retorno.setExceptions(exc);
                  break;
                default:
                  jj_la1[60] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
          }
        } else {
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BLOCK:
        case LBRACE:
          mBody = Block();
                  retorno.setBody(mBody);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[61] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[62] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
     javadoc = ParserHelper.generateSpecialTokenString(first, last);
     if (javadoc != null && javadoc.length() > 0) {
        retorno.setComment(new JComment(javadoc));
     }
         addElement(retorno);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JParameterList FormalParameters() throws ParseException {
    JParameterList retorno = new JParameterList();
    Token t = null;
    JFormalParameter tmp = null;
    IterativeDeclaration plid = null;
    JExecutableDeclaration execDec = null;
    jj_consume_token(LPAREN);
    if (jj_2_74(2147483647)) {
      plid = ParameterListIterativeDeclaration();
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(plid);
            retorno.setVariableType(JaTSNode.PARAMETER_LIST);
            plid.setParentNode(retorno);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PARAMETER_LIST:
        jj_consume_token(PARAMETER_LIST);
        jj_consume_token(COLON);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JIDENTIFIER:
          t = jj_consume_token(JIDENTIFIER);
             retorno.setVariableName(t.image);
             retorno.setVariableType(JaTSNode.PARAMETER_LIST);
          break;
        case LEXECDEC:
          execDec = ExecutableDeclaration();
             retorno.setExecutable(true);
             retorno.setExecutableDeclaration(execDec);
         retorno.setVariableType(JaTSNode.PARAMETER_LIST);
          break;
        default:
          jj_la1[63] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[66] = jj_gen;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case SHORT:
        case ID:
        case MODIFIER_LIST:
        case NAME:
        case PARAMETER:
        case TYPE:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          tmp = FormalParameter();
                                 retorno.add(tmp);
          label_19:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[64] = jj_gen;
              break label_19;
            }
            jj_consume_token(COMMA);
            tmp = FormalParameter();
                                        retorno.add(tmp);
          }
          break;
        default:
          jj_la1[65] = jj_gen;
          ;
        }
      }
    }
    jj_consume_token(RPAREN);
     addElement(retorno);
     retorno.setLine(line);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Representa um parametro numa declarao de mtodo ou numa
 * clusula catch
 */
  static final public JFormalParameter FormalParameter() throws ParseException {
    JType t= null;
    JIdentifier id= new JIdentifier();
    Token varName = null;
    JFormalParameter retorno = new JFormalParameter();
    JModifierList modList = new JModifierList(JModifierList.PARAMETER_DECLARATION);
    int mod = 0;
    JVariableDeclarator vd = new JVariableDeclarator();
    JExecutableDeclaration execDec = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PARAMETER:
      jj_consume_token(PARAMETER);
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEXECDEC:
        execDec = ExecutableDeclaration();
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.FORMAL_PARAMETER);
        break;
      case JIDENTIFIER:
        varName = jj_consume_token(JIDENTIFIER);
           retorno.setVariableName(varName.image);
           retorno.setVariableType(JaTSNode.FORMAL_PARAMETER);
        break;
      default:
        jj_la1[67] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FINAL:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case ID:
    case MODIFIER_LIST:
    case NAME:
    case TYPE:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LEXECDEC:
      if (jj_2_75(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case MODIFIER_LIST:
          modList = ModifierList(JModifierList.PARAMETER_DECLARATION);
              retorno.setModifiers(modList);
          break;
        case FINAL:
          jj_consume_token(FINAL);
                     mod = JModifier.FINAL; retorno.setModifiers(mod);
          break;
        default:
          jj_la1[68] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else {
        ;
      }
      t = Type();
                    retorno.setType(t);
      id = VariableDeclaratorId(vd);
           int dim = vd.getDimensions();
               retorno.setIdentifier(id);
               retorno.setDimensions(dim);
               retorno.setLine(line);
      break;
    default:
      jj_la1[69] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    addElement(retorno);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JConstructorDeclaration ConstructorVarDeclaration() throws ParseException {
    Token t = null;
    JConstructorDeclaration retorno  = new JConstructorDeclaration();
    jj_consume_token(CONSTRUCTOR_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.CONSTRUCTOR_DECLARATION);
       addElement(retorno);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JConstructorDeclarationSet ConstructorsVarDeclaration() throws ParseException {
    Token t = null;
    JConstructorDeclarationSet  retorno = new JConstructorDeclarationSet();
    jj_consume_token(CONSTRUCTOR_DECLARATION_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
       retorno.setVariableName(t.image);
       retorno.setVariableType(JaTSNode.CONSTRUCTOR_DECLARATION_SET);
       addElement(retorno);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Esta produo serve apenas para determinar a produo Construtor
 * em um LOOKAHEAD
 */
  static final public void ConstructorDeclarationLookahead() throws ParseException {
    if (jj_2_77(2147483647)) {
      jj_consume_token(CONSTRUCTOR_DECLARATION);
      jj_consume_token(COLON);
      ExecutableDeclaration();
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case ID:
      case MODIFIER_LIST:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_76(2147483647)) {
          ModifierList(JModifierList.CONSTRUCTOR_DECLARATION);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PRIVATE:
          case PROTECTED:
          case PUBLIC:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PUBLIC:
              jj_consume_token(PUBLIC);
              break;
            case PROTECTED:
              jj_consume_token(PROTECTED);
              break;
            case PRIVATE:
              jj_consume_token(PRIVATE);
              break;
            default:
              jj_la1[70] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            break;
          default:
            jj_la1[71] = jj_gen;
            ;
          }
        }
        Identifier();
        jj_consume_token(LPAREN);
        break;
      default:
        jj_la1[72] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  static final public JConstructorDeclaration ConstructorDeclaration() throws ParseException {
    JModifierList modList = new JModifierList(JModifierList.CONSTRUCTOR_DECLARATION);
    JIdentifier id = new JIdentifier();
    JParameterList params = new JParameterList();
    JNameList exc = new JNameList();
    JNameList nl1 = new JNameList();
    JNameList nl2 = new JNameList();
    OrDeclaration or = new OrDeclaration();

    JConstructorDeclaration retorno = new JConstructorDeclaration();
    JExecutableDeclaration execDec = null;
    JBlock cbody = null;
    String javadoc = null;
    Token first = null, last = null;
     first = getToken(1);
    if (jj_2_82(2147483647)) {
      jj_consume_token(CONSTRUCTOR_DECLARATION);
      jj_consume_token(COLON);
      execDec = ExecutableDeclaration();
      jj_consume_token(SEMICOLON);
            retorno.setExecutable(true);
            retorno.setExecutableDeclaration(execDec);
            retorno.setVariableType(JaTSNode.CONSTRUCTOR_DECLARATION);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case ID:
      case MODIFIER_LIST:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_78(2147483647)) {
          modList = ModifierList(JModifierList.CONSTRUCTOR_DECLARATION);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PRIVATE:
          case PROTECTED:
          case PUBLIC:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PUBLIC:
              jj_consume_token(PUBLIC);
                       modList.addModifier(JModifier.PUBLIC);
              break;
            case PROTECTED:
              jj_consume_token(PROTECTED);
                          modList.addModifier(JModifier.PROTECTED);
              break;
            case PRIVATE:
              jj_consume_token(PRIVATE);
                        modList.addModifier(JModifier.PRIVATE);
              break;
            default:
              jj_la1[73] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            break;
          default:
            jj_la1[74] = jj_gen;
            ;
          }
        }
       last = getToken(0);
         // Modificadores so adicionados aqui por no terem uma produo "s deles".
         addElement(modList);
         retorno.setModifiers(modList);
        id = Identifier();
          retorno.setName(id);
          retorno.setLine(line);
        params = FormalParameters();
                                   retorno.setParameters(params);
        if (jj_2_81(2147483647)) {
          if (jj_2_79(2147483647)) {
            jj_consume_token(LOPTDEC);
            jj_consume_token(THROWS);
            jj_consume_token(LPAREN);
            nl1 = NameList();
            jj_consume_token(BIT_OR);
            nl2 = NameList();
            jj_consume_token(RPAREN);
            jj_consume_token(ROPTCDEC);
              or.setChoice1(nl1);
          or.setChoice2(nl2);
              exc.setOrDeclaration(or);
              exc.setOptional(true);
              retorno.setExceptions(exc);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LOPTDEC:
              jj_consume_token(LOPTDEC);
              jj_consume_token(THROWS);
              exc = NameList();
              jj_consume_token(ROPTCDEC);
              exc.setOptional(true);
              retorno.setExceptions(exc);
              break;
            default:
              jj_la1[75] = jj_gen;
              if (jj_2_80(2147483647)) {
                jj_consume_token(THROWS);
                jj_consume_token(LPAREN);
                nl1 = NameList();
                jj_consume_token(BIT_OR);
                nl2 = NameList();
                jj_consume_token(RPAREN);
              or.setChoice1(nl1);
          or.setChoice2(nl2);
              exc.setOrDeclaration(or);
              retorno.setExceptions(exc);
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case THROWS:
                  jj_consume_token(THROWS);
                  exc = NameList();
             retorno.setExceptions(exc);
                  break;
                default:
                  jj_la1[76] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
          }
        } else {
          ;
        }
        cbody = Block();
             retorno.setBody(cbody);
        break;
      default:
        jj_la1[77] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
     javadoc = ParserHelper.generateSpecialTokenString(first, last);
     if (javadoc != null && javadoc.length() > 0){
         retorno.setComment(new JComment(javadoc));
     }
     addElement(retorno);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode ExplicitConstructorInvocation() throws ParseException {
  JNodeString node = null;
  Token first = null;
  Token last = null;
    if (jj_2_84(2147483647)) {
      jj_consume_token(THIS);
          first = getToken(0);
      Arguments();
                                             last = getToken(1);
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case ID:
      case LITERAL:
      case NAME:
      case TYPE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LEXECDEC:
   first = getToken(1);
        if (jj_2_83(2)) {
          PrimaryExpression();
          jj_consume_token(DOT);
        } else {
          ;
        }
        jj_consume_token(SUPER);
        Arguments();
                                                                last = getToken(1);
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[78] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
   node = new JNodeString();   //tem que criar a string aqui.
   node.setNodeValue(ParserHelper.generateString(first, last));
   {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public JInitializer Initializer() throws ParseException {
   JInitializer retorno = new JInitializer();
   JBlock block = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STATIC:
      jj_consume_token(STATIC);
      retorno.setStatic(true);
      break;
    default:
      jj_la1[79] = jj_gen;
      ;
    }
    block = Block();
     retorno.setBlock(block);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JInitializer InitializerVar() throws ParseException {
   JInitializer retorno = new JInitializer();
   Token t = null;
    jj_consume_token(INITIALIZER);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.INITIALIZER);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JInitializerSet InitializerSetVar() throws ParseException {
   JInitializerSet retorno = new JInitializerSet();
   Token t = null;
    jj_consume_token(INITIALIZER_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.INITIALIZER_SET);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JTypeDeclaration ClassVarDeclaration() throws ParseException {
   JClassDeclaration retorno = new JClassDeclaration();
   Token t = null;
    jj_consume_token(CLASS_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.CLASS_DECLARATION);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JTypeDeclaration InterfaceVarDeclaration() throws ParseException {
   JInterfaceDeclaration retorno = new JInterfaceDeclaration();
   Token t = null;
    jj_consume_token(INTERFACE_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.INTERFACE_DECLARATION);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeDeclarationSet ClassVarsDeclaration() throws ParseException {
   TypeDeclarationSet retorno = new TypeDeclarationSet();
   Token t = null;
    jj_consume_token(CLASS_DECLARATION);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.TYPE_DECLARATION_SET);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public TypeDeclarationSet InterfaceVarsDeclaration() throws ParseException {
   TypeDeclarationSet retorno = new TypeDeclarationSet();
   Token t = null;
    jj_consume_token(INTERFACE_DECLARATION_SET);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
     retorno.setVariableName(t.image);
     retorno.setVariableType(JaTSNode.TYPE_DECLARATION_SET);
     retorno.setLine(line);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/*
 * Type, name and expression syntax follows.
 */
  static final public JType Type() throws ParseException {
    JType retorno = null;
    JName nome = null;
    int colchetes = 0;
    Token t = null;
    JExecutableDeclaration execDec = null;
    if (jj_2_86(2147483647)) {
      execDec = ExecutableDeclaration();
               retorno = new JType();
               retorno.setExecutable(true);
               retorno.setExecutableDeclaration(execDec);
               retorno.setVariableType(JaTSNode.TYPE);
    } else if (jj_2_87(2147483647)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYPE:
        jj_consume_token(TYPE);
        jj_consume_token(COLON);
        t = jj_consume_token(JIDENTIFIER);
        break;
      case JIDENTIFIER:
        t = jj_consume_token(JIDENTIFIER);
        break;
      default:
        jj_la1[80] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
           retorno = new JType();
           JName typeName = new JName();
               typeName.setVariableName(t.image);
               typeName.setVariableType(JaTSNode.TYPE);
               retorno.setName(typeName);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case ID:
      case NAME:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        if (jj_2_85(2147483647)) {
          nome = PrimitiveType();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ID:
          case NAME:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LEXECDEC:
            nome = Name();
            break;
          default:
            jj_la1[81] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
            retorno = new JType();
            retorno.setName(nome);
        break;
      default:
        jj_la1[82] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[83] = jj_gen;
        break label_20;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
                 colchetes++;
    }
     retorno.setNumberOfDimensions(colchetes);
     addElement(retorno);
     retorno.setLine(line);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Tipo primitivo boolean, byte, char, short, int, long, float, double
 */
  static final public JName PrimitiveType() throws ParseException {
    JName retorno = null;
    Token tk = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
      tk = jj_consume_token(BOOLEAN);
      break;
    case CHAR:
      tk = jj_consume_token(CHAR);
      break;
    case BYTE:
      tk = jj_consume_token(BYTE);
      break;
    case SHORT:
      tk = jj_consume_token(SHORT);
      break;
    case INT:
      tk = jj_consume_token(INT);
      break;
    case LONG:
      tk = jj_consume_token(LONG);
      break;
    case FLOAT:
      tk = jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      tk = jj_consume_token(DOUBLE);
      break;
    default:
      jj_la1[84] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
     retorno = new JName(tk.image);
     addElement(retorno);
     retorno.setLine(line);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Tipo de retorno de mtodos: void ou ento um Type
 */
  static final public JType ResultType() throws ParseException {
    JType retorno = new JType();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VOID:
      jj_consume_token(VOID);
           retorno = new JType ( new JName ("void"));
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case ID:
    case NAME:
    case TYPE:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LEXECDEC:
      retorno = Type();
      break;
    default:
      jj_la1[85] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    addElement(retorno);
    retorno.setLine(line);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JName Name() throws ParseException {
  JIdentifier id = null;
  JName nome = new JName();
  Token t = null;
  JaTSNode execDec = null;
    if (jj_2_89(2147483647)) {
      execDec = ExecutableDeclaration();
        nome.setExecutable(true);
        nome.setExecutableDeclaration(execDec);
        nome.setVariableType(JaTSNode.NAME);
    } else if (jj_2_90(2147483647)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAME:
        jj_consume_token(NAME);
        jj_consume_token(COLON);
        t = jj_consume_token(JIDENTIFIER);
        break;
      case JIDENTIFIER:
        t = jj_consume_token(JIDENTIFIER);
        break;
      default:
        jj_la1[86] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
     nome.setVariableName(t.image);
     nome.setVariableType(JaTSNode.NAME);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        id = Identifier();
                      nome.addIdentifier(id);
        label_21:
        while (true) {
          if (jj_2_88(2147483647)) {
            ;
          } else {
            break label_21;
          }
          jj_consume_token(DOT);
          id = Identifier();
         nome.addIdentifier(id);
        }
        break;
      default:
        jj_la1[87] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    addElement(nome);
    nome.setLine(line);
    {if (true) return nome;}
    throw new Error("Missing return statement in function");
  }

  static final public PrefixedIdentifier PrefixedIdentifier() throws ParseException {
    PrefixedIdentifier retorno = null;
    Token t = null, jid = null;
    JIdentifier rootId = null;
    JExecutableDeclaration execDec = null;
    t = jj_consume_token(IDENTIFIER);
    jj_consume_token(EXECDECSEPARATOR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JIDENTIFIER:
      jid = jj_consume_token(JIDENTIFIER);
            rootId = new JIdentifier(jid.image);
            rootId.setVariableType(JaTSNode.IDENTIFIER);
            rootId.setVariableName(jid.image);
            addElement(rootId);
      break;
    case LEXECDEC:
      execDec = ExecutableDeclaration();
            rootId = new JIdentifier();
            rootId.setExecutable(true);
            rootId.setExecutableDeclaration(execDec);
            rootId.setVariableType(JaTSNode.IDENTIFIER);
      break;
    default:
      jj_la1[88] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        retorno = new PrefixedIdentifier();
        retorno.setRootId(rootId);
        retorno.setPrefix(t.image);
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JIdentifier Identifier() throws ParseException {
  Token t = null;
  JIdentifier retorno = null;
  JExecutableDeclaration execDec = null;
  Token first = null, last = null;
    if (jj_2_91(2147483647)) {
      execDec = ExecutableDeclaration();
    retorno = new JIdentifier();
    retorno.setExecutable(true);
    retorno.setExecutableDeclaration(execDec);
    retorno.setVariableType(JaTSNode.IDENTIFIER);
    } else if (jj_2_92(2147483647)) {
      retorno = PrefixedIdentifier();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case JIDENTIFIER:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ID:
          jj_consume_token(ID);
          jj_consume_token(COLON);
          t = jj_consume_token(JIDENTIFIER);
          break;
        case JIDENTIFIER:
          t = jj_consume_token(JIDENTIFIER);
          break;
        default:
          jj_la1[89] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        retorno = new JIdentifier(t.image);
        retorno.setVariableType(JaTSNode.IDENTIFIER);
        retorno.setVariableName(t.image);
        break;
      case IDENTIFIER:
        t = jj_consume_token(IDENTIFIER);
        retorno = new JIdentifier(t.image);
        break;
      default:
        jj_la1[90] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
       addElement(retorno);
       retorno.setLine(line);
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JNameList NameList() throws ParseException {
    JNameList names = new JNameList();
    JName tempName = null;
    IterativeDeclaration nlid = null;
    JExecutableDeclaration execDec = null;
    Token t = null;
    if (jj_2_93(2147483647)) {
      nlid = NameListIterativeDeclaration();
            names.setExecutable(true);
            names.setExecutableDeclaration(nlid);
            names.setVariableType(JaTSNode.NAME_LIST);
            nlid.setParentNode(names);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAME_LIST:
        jj_consume_token(NAME_LIST);
        jj_consume_token(COLON);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JIDENTIFIER:
          t = jj_consume_token(JIDENTIFIER);
          names.setVariableName(t.image);
              names.setVariableType(JaTSNode.NAME_LIST);
          break;
        case LEXECDEC:
          execDec = ExecutableDeclaration();
               names.setExecutable(true);
           names.setExecutableDeclaration(execDec);
               names.setVariableType(JaTSNode.NAME_LIST);
          break;
        default:
          jj_la1[91] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      case ID:
      case NAME:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        tempName = Name();
            names.add(tempName);
        label_22:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[92] = jj_gen;
            break label_22;
          }
          jj_consume_token(COMMA);
          tempName = Name();
                                  names.add(tempName);
        }
        break;
      default:
        jj_la1[93] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      addElement(names);
      names.setLine(line);
      {if (true) return names;}
    throw new Error("Missing return statement in function");
  }

  static final public IterativeDeclaration NameListIterativeDeclaration() throws ParseException {
    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JName tempName = null;
    Token r = null;
    Token s = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    s = jj_consume_token(JIDENTIFIER);
    jj_consume_token(LBRACE);
    label_23:
    while (true) {
      tempName = Name();
                              decSet.addElement(tempName);
      jj_consume_token(SEMICOLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case NAME:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[94] = jj_gen;
        break label_23;
      }
    }
    jj_consume_token(RBRACE);
        iterSet = new JIdentifier(s.image);
        placeholder = new JIdentifier(r.image);
        retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
        retorno.setDeclarationSet(decSet);

        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public IterativeDeclaration ParameterListIterativeDeclaration() throws ParseException {
    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JFormalParameter tempParameter = null;
    Token r = null;
    Token s = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    s = jj_consume_token(JIDENTIFIER);
    jj_consume_token(LBRACE);
    label_24:
    while (true) {
      tempParameter = FormalParameter();
                                              decSet.addElement(tempParameter);
      jj_consume_token(COMMA);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case ID:
      case MODIFIER_LIST:
      case NAME:
      case PARAMETER:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[95] = jj_gen;
        break label_24;
      }
    }
    jj_consume_token(RBRACE);
        iterSet = new JIdentifier(s.image);
        placeholder = new JIdentifier(r.image);
        retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
        retorno.setDeclarationSet(decSet);

        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public IterativeDeclaration VariableDeclaratorIterativeDeclaration() throws ParseException {
    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JVariableDeclarator tempVarDec = null;
    Token r = null;
    Token s = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    s = jj_consume_token(JIDENTIFIER);
    jj_consume_token(LBRACE);
    label_25:
    while (true) {
      tempVarDec = VariableDeclarator();
                                              decSet.addElement(tempVarDec);
      jj_consume_token(SEMICOLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
      case VARIABLE_DECLARATOR:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[96] = jj_gen;
        break label_25;
      }
    }
    jj_consume_token(RBRACE);
            iterSet = new JIdentifier(s.image);
        placeholder = new JIdentifier(r.image);
            retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
            retorno.setDeclarationSet(decSet);
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JConditionalDeclaration ClassBodyConditionalDeclaration(JaTSNode parent) throws ParseException {
    NodeList trueDecSet = new NodeList();
    NodeList falseDecSet = new NodeList();
    JExpression cond = null;
    JConditionalDeclaration retorno = new JConditionalDeclaration();
    JaTSNode tempNode = null;
    jj_consume_token(CONDITIONAL);
    jj_consume_token(LPAREN);
    cond = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_26:
    while (true) {
      if (jj_2_94(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_95(2147483647)) {
        tempNode = ClassBodyIterativeDeclaration(retorno);
      } else if (jj_2_96(2147483647)) {
        tempNode = FieldDeclaration();
      } else if (jj_2_97(2147483647)) {
        tempNode = FieldVarDeclaration();
      } else if (jj_2_98(2147483647)) {
        tempNode = FieldsVarDeclaration();
      } else if (jj_2_99(2147483647)) {
        tempNode = MethodVarDeclaration();
      } else if (jj_2_100(2147483647)) {
        tempNode = MethodsVarDeclaration();
      } else if (jj_2_101(2147483647)) {
        tempNode = ClassBodyConditionalDeclaration(retorno);
      } else if (jj_2_102(2147483647)) {
        tempNode = ConstructorDeclaration();
      } else if (jj_2_103(2147483647)) {
        tempNode = ConstructorVarDeclaration();
      } else if (jj_2_104(2147483647)) {
        tempNode = ConstructorsVarDeclaration();
      } else if (jj_2_105(2147483647)) {
        tempNode = Initializer();
      } else if (jj_2_106(2147483647)) {
        tempNode = InitializerVar();
      } else if (jj_2_107(2147483647)) {
        tempNode = InitializerSetVar();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case VOID:
        case STRICTFP:
        case ID:
        case METHOD_DECLARATION:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          tempNode = MethodDeclaration();
          break;
        default:
          jj_la1[97] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
             trueDecSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case BLOCK:
      case CONSTRUCTOR_DECLARATION:
      case CONSTRUCTOR_DECLARATION_SET:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case INITIALIZER:
      case INITIALIZER_SET:
      case ITERATIVE_DECLARATION:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LBRACE:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[98] = jj_gen;
        break label_26;
      }
    }
    jj_consume_token(RBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
      jj_consume_token(LBRACE);
      label_27:
      while (true) {
        if (jj_2_108(2147483647)) {
          tempNode = ExecutableDeclaration();
          jj_consume_token(SEMICOLON);
        } else if (jj_2_109(2147483647)) {
          tempNode = ClassBodyIterativeDeclaration(retorno);
        } else if (jj_2_110(2147483647)) {
          tempNode = FieldDeclaration();
        } else if (jj_2_111(2147483647)) {
          tempNode = FieldVarDeclaration();
        } else if (jj_2_112(2147483647)) {
          tempNode = MethodVarDeclaration();
        } else if (jj_2_113(2147483647)) {
          tempNode = MethodsVarDeclaration();
        } else if (jj_2_114(2147483647)) {
          tempNode = FieldsVarDeclaration();
        } else if (jj_2_115(2147483647)) {
          tempNode = ClassBodyConditionalDeclaration(retorno);
        } else if (jj_2_116(2147483647)) {
          tempNode = ConstructorDeclaration();
        } else if (jj_2_117(2147483647)) {
          tempNode = ConstructorVarDeclaration();
        } else if (jj_2_118(2147483647)) {
          tempNode = ConstructorsVarDeclaration();
        } else if (jj_2_119(2147483647)) {
          tempNode = Initializer();
        } else if (jj_2_120(2147483647)) {
          tempNode = InitializerVar();
        } else if (jj_2_121(2147483647)) {
          tempNode = InitializerSetVar();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ABSTRACT:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case DOUBLE:
          case FINAL:
          case FLOAT:
          case INT:
          case LONG:
          case NATIVE:
          case PRIVATE:
          case PROTECTED:
          case PUBLIC:
          case SHORT:
          case STATIC:
          case SYNCHRONIZED:
          case VOID:
          case STRICTFP:
          case ID:
          case METHOD_DECLARATION:
          case MODIFIER_LIST:
          case NAME:
          case TYPE:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LEXECDEC:
            tempNode = MethodDeclaration();
            break;
          default:
            jj_la1[99] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
             falseDecSet.addElement(tempNode);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case TRANSIENT:
        case VOID:
        case VOLATILE:
        case STRICTFP:
        case BLOCK:
        case CONSTRUCTOR_DECLARATION:
        case CONSTRUCTOR_DECLARATION_SET:
        case FIELD_DECLARATION:
        case FIELD_DECLARATION_SET:
        case ID:
        case INITIALIZER:
        case INITIALIZER_SET:
        case ITERATIVE_DECLARATION:
        case METHOD_DECLARATION:
        case METHOD_DECLARATION_SET:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LBRACE:
        case LEXECDEC:
          ;
          break;
        default:
          jj_la1[100] = jj_gen;
          break label_27;
        }
      }
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[101] = jj_gen;
      ;
    }
        if(falseDecSet.size() > 0) {
            retorno = new JConditionalDeclaration(cond, trueDecSet, falseDecSet, parent);
        }
        else {
            retorno = new JConditionalDeclaration(cond, trueDecSet, parent);
        }

        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JConditionalDeclaration InterfaceBodyConditionalDeclaration(JaTSNode parent) throws ParseException {
    NodeList trueDecSet = new NodeList();
    NodeList falseDecSet = new NodeList();
    JExpression cond = null;
    JConditionalDeclaration retorno = new JConditionalDeclaration();
    JaTSNode tempNode = null;
    jj_consume_token(CONDITIONAL);
    jj_consume_token(LPAREN);
    cond = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_28:
    while (true) {
      if (jj_2_122(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_123(2147483647)) {
        tempNode = InterfaceBodyIterativeDeclaration(retorno);
      } else if (jj_2_124(2147483647)) {
        tempNode = FieldDeclaration();
      } else if (jj_2_125(2147483647)) {
        tempNode = FieldVarDeclaration();
      } else if (jj_2_126(2147483647)) {
        tempNode = MethodVarDeclaration();
      } else if (jj_2_127(2147483647)) {
        tempNode = MethodsVarDeclaration();
      } else if (jj_2_128(2147483647)) {
        tempNode = FieldsVarDeclaration();
      } else if (jj_2_129(2147483647)) {
        tempNode = InterfaceBodyConditionalDeclaration(retorno);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case VOID:
        case STRICTFP:
        case ID:
        case METHOD_DECLARATION:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          tempNode = MethodDeclaration();
          break;
        default:
          jj_la1[102] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
             trueDecSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case ITERATIVE_DECLARATION:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[103] = jj_gen;
        break label_28;
      }
    }
    jj_consume_token(RBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
      jj_consume_token(LBRACE);
      label_29:
      while (true) {
        if (jj_2_130(2147483647)) {
          tempNode = ExecutableDeclaration();
          jj_consume_token(SEMICOLON);
        } else if (jj_2_131(2147483647)) {
          tempNode = InterfaceBodyIterativeDeclaration(retorno);
        } else if (jj_2_132(2147483647)) {
          tempNode = FieldDeclaration();
        } else if (jj_2_133(2147483647)) {
          tempNode = FieldVarDeclaration();
        } else if (jj_2_134(2147483647)) {
          tempNode = MethodVarDeclaration();
        } else if (jj_2_135(2147483647)) {
          tempNode = MethodsVarDeclaration();
        } else if (jj_2_136(2147483647)) {
          tempNode = FieldsVarDeclaration();
        } else if (jj_2_137(2147483647)) {
          tempNode = InterfaceBodyConditionalDeclaration(retorno);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ABSTRACT:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case DOUBLE:
          case FINAL:
          case FLOAT:
          case INT:
          case LONG:
          case NATIVE:
          case PRIVATE:
          case PROTECTED:
          case PUBLIC:
          case SHORT:
          case STATIC:
          case SYNCHRONIZED:
          case VOID:
          case STRICTFP:
          case ID:
          case METHOD_DECLARATION:
          case MODIFIER_LIST:
          case NAME:
          case TYPE:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LEXECDEC:
            tempNode = MethodDeclaration();
            break;
          default:
            jj_la1[104] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
             falseDecSet.addElement(tempNode);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case TRANSIENT:
        case VOID:
        case VOLATILE:
        case STRICTFP:
        case FIELD_DECLARATION:
        case FIELD_DECLARATION_SET:
        case ID:
        case ITERATIVE_DECLARATION:
        case METHOD_DECLARATION:
        case METHOD_DECLARATION_SET:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          ;
          break;
        default:
          jj_la1[105] = jj_gen;
          break label_29;
        }
      }
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[106] = jj_gen;
      ;
    }
        if(falseDecSet.size() > 0) {
            retorno = new JConditionalDeclaration(cond, trueDecSet, falseDecSet, parent);
        }
        else {
            retorno = new JConditionalDeclaration(cond, trueDecSet, parent);
        }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao condicional dentro de corpo de metodos.
 *
 */
  static final public JConditionalDeclaration MethodBodyConditionalDeclaration(JaTSNode parent) throws ParseException {
    NodeList trueDecSet = new NodeList();
    NodeList falseDecSet = new NodeList();
    JExpression cond = null;
    JConditionalDeclaration retorno = new JConditionalDeclaration();
    JaTSNode tempNode = null;
    jj_consume_token(CONDITIONAL);
    jj_consume_token(LPAREN);
    cond = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_30:
    while (true) {
      if (jj_2_138(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_139(2147483647)) {
        tempNode = MethodBodyIterativeDeclaration(retorno);
      } else if (jj_2_140(2147483647)) {
        tempNode = MethodBodyConditionalDeclaration(retorno);
      } else if (jj_2_141(2147483647)) {
        tempNode = LocalVariableDeclaration();
        jj_consume_token(SEMICOLON);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case CONTEXT_DEC:
        case STM_LIST:
        case BLOCK:
        case ID:
        case ITERATIVE_DECLARATION:
        case LITERAL:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case LEXECDEC:
        case SEMICOLON:
        case INCR:
        case DECR:
          tempNode = Statement(retorno);
          break;
        default:
          jj_la1[107] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
              if (tempNode != null) trueDecSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case CONTEXT_DEC:
      case STM_LIST:
      case BLOCK:
      case ID:
      case ITERATIVE_DECLARATION:
      case LITERAL:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
      case INCR:
      case DECR:
        ;
        break;
      default:
        jj_la1[108] = jj_gen;
        break label_30;
      }
    }
    jj_consume_token(RBRACE);
    if (jj_2_146(2147483647)) {
      jj_consume_token(ELSE);
      jj_consume_token(LBRACE);
      label_31:
      while (true) {
        if (jj_2_142(2147483647)) {
          tempNode = ExecutableDeclaration();
          jj_consume_token(SEMICOLON);
        } else if (jj_2_143(2147483647)) {
          tempNode = MethodBodyIterativeDeclaration(retorno);
        } else if (jj_2_144(2147483647)) {
          tempNode = MethodBodyConditionalDeclaration(retorno);
        } else if (jj_2_145(2147483647)) {
          tempNode = LocalVariableDeclaration();
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSERT:
          case BOOLEAN:
          case BREAK:
          case BYTE:
          case CHAR:
          case CONTINUE:
          case DO:
          case DOUBLE:
          case FALSE:
          case FLOAT:
          case FOR:
          case IF:
          case INT:
          case LONG:
          case NEW:
          case NULL:
          case RETURN:
          case SHORT:
          case SUPER:
          case SWITCH:
          case SYNCHRONIZED:
          case THIS:
          case THROW:
          case TRUE:
          case TRY:
          case VOID:
          case WHILE:
          case CONTEXT_DEC:
          case STM_LIST:
          case BLOCK:
          case ID:
          case ITERATIVE_DECLARATION:
          case LITERAL:
          case NAME:
          case TYPE:
          case CONDITIONAL:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LPAREN:
          case LBRACE:
          case LEXECDEC:
          case SEMICOLON:
          case INCR:
          case DECR:
            tempNode = Statement(retorno);
            break;
          default:
            jj_la1[109] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
              if (tempNode != null) falseDecSet.addElement(tempNode);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case CONTEXT_DEC:
        case STM_LIST:
        case BLOCK:
        case ID:
        case ITERATIVE_DECLARATION:
        case LITERAL:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case LEXECDEC:
        case SEMICOLON:
        case INCR:
        case DECR:
          ;
          break;
        default:
          jj_la1[110] = jj_gen;
          break label_31;
        }
      }
      jj_consume_token(RBRACE);
    } else {
      ;
    }
        if(falseDecSet.size() > 0) {
            retorno = new JConditionalDeclaration(cond, trueDecSet, falseDecSet, parent);
        }
        else {
            retorno = new JConditionalDeclaration(cond, trueDecSet, parent);
        }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public IterativeDeclaration ClassBodyIterativeDeclaration(JaTSNode parent) throws ParseException {
    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JaTSNode tempNode = null;
    Token r = null;
    Token s = null;
    JaTSNode execDec = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JIDENTIFIER:
      s = jj_consume_token(JIDENTIFIER);
      break;
    case LEXECDEC:
      execDec = ExecutableDeclaration();
      break;
    default:
      jj_la1[111] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LBRACE);
    label_32:
    while (true) {
      if (jj_2_147(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_148(2147483647)) {
        tempNode = ClassBodyIterativeDeclaration(retorno);
      } else if (jj_2_149(2147483647)) {
        tempNode = FieldDeclaration();
      } else if (jj_2_150(2147483647)) {
        tempNode = FieldVarDeclaration();
      } else if (jj_2_151(2147483647)) {
        tempNode = MethodVarDeclaration();
      } else if (jj_2_152(2147483647)) {
        tempNode = MethodsVarDeclaration();
      } else if (jj_2_153(2147483647)) {
        tempNode = FieldsVarDeclaration();
      } else if (jj_2_154(2147483647)) {
        tempNode = ClassBodyConditionalDeclaration(retorno);
      } else if (jj_2_155(2147483647)) {
        tempNode = ConstructorDeclaration();
      } else if (jj_2_156(2147483647)) {
        tempNode = ConstructorVarDeclaration();
      } else if (jj_2_157(2147483647)) {
        tempNode = ConstructorsVarDeclaration();
      } else if (jj_2_158(2147483647)) {
        tempNode = Initializer();
      } else if (jj_2_159(2147483647)) {
        tempNode = InitializerVar();
      } else if (jj_2_160(2147483647)) {
        tempNode = InitializerSetVar();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case VOID:
        case STRICTFP:
        case ID:
        case METHOD_DECLARATION:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          tempNode = MethodDeclaration();
          break;
        default:
          jj_la1[112] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
              decSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case BLOCK:
      case CONSTRUCTOR_DECLARATION:
      case CONSTRUCTOR_DECLARATION_SET:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case INITIALIZER:
      case INITIALIZER_SET:
      case ITERATIVE_DECLARATION:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LBRACE:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[113] = jj_gen;
        break label_32;
      }
    }
    jj_consume_token(RBRACE);
        if (s != null){
           iterSet = new JIdentifier(s.image);
        }
        else if (execDec != null){
           iterSet = execDec;
        }
        placeholder = new JIdentifier(r.image);
            retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
        retorno.setDeclarationSet(decSet);
        retorno.setParentNode(parent);

        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public IterativeDeclaration InterfaceBodyIterativeDeclaration(JaTSNode parent) throws ParseException {
    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JaTSNode tempNode = null;
    Token r = null;
    Token s = null;
    JaTSNode execDec = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JIDENTIFIER:
      s = jj_consume_token(JIDENTIFIER);
      break;
    case LEXECDEC:
      execDec = ExecutableDeclaration();
      break;
    default:
      jj_la1[114] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LBRACE);
    label_33:
    while (true) {
      if (jj_2_161(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_162(2147483647)) {
        tempNode = InterfaceBodyIterativeDeclaration(retorno);
      } else if (jj_2_163(2147483647)) {
        tempNode = FieldDeclaration();
      } else if (jj_2_164(2147483647)) {
        tempNode = FieldVarDeclaration();
      } else if (jj_2_165(2147483647)) {
        tempNode = MethodVarDeclaration();
      } else if (jj_2_166(2147483647)) {
        tempNode = MethodsVarDeclaration();
      } else if (jj_2_167(2147483647)) {
        tempNode = FieldsVarDeclaration();
      } else if (jj_2_168(2147483647)) {
        tempNode = InterfaceBodyConditionalDeclaration(retorno);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case SYNCHRONIZED:
        case VOID:
        case STRICTFP:
        case ID:
        case METHOD_DECLARATION:
        case MODIFIER_LIST:
        case NAME:
        case TYPE:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LEXECDEC:
          tempNode = MethodDeclaration();
          break;
        default:
          jj_la1[115] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
              decSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case TRANSIENT:
      case VOID:
      case VOLATILE:
      case STRICTFP:
      case FIELD_DECLARATION:
      case FIELD_DECLARATION_SET:
      case ID:
      case ITERATIVE_DECLARATION:
      case METHOD_DECLARATION:
      case METHOD_DECLARATION_SET:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        ;
        break;
      default:
        jj_la1[116] = jj_gen;
        break label_33;
      }
    }
    jj_consume_token(RBRACE);
    if (s != null){
       iterSet = new JIdentifier(s.image);
    }
    else if (execDec != null){
       iterSet = execDec;
    }

        placeholder = new JIdentifier(r.image);
        retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
        retorno.setDeclarationSet(decSet);
        retorno.setParentNode(parent);
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao iterativa dentro de corpo de metodos
 *
 */
  static final public IterativeDeclaration MethodBodyIterativeDeclaration(JaTSNode parent) throws ParseException {
   //tem que revisar pra ver se precisa mesmo de todas essas variaveis

    JaTSNode iterSet = null;
    JaTSNode placeholder = null;
    NodeList decSet = new NodeList();
    IterativeDeclaration retorno = new IterativeDeclaration();
    JaTSNode tempNode = null;
    Token r = null;
    Token s = null;
    JaTSNode execDec = null;
    jj_consume_token(ITERATIVE_DECLARATION);
    r = jj_consume_token(JIDENTIFIER);
    jj_consume_token(IN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JIDENTIFIER:
      s = jj_consume_token(JIDENTIFIER);
      break;
    case LEXECDEC:
      execDec = ExecutableDeclaration();
      break;
    default:
      jj_la1[117] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LBRACE);
    label_34:
    while (true) {
      if (jj_2_169(2147483647)) {
        tempNode = ExecutableDeclaration();
        jj_consume_token(SEMICOLON);
      } else if (jj_2_170(2147483647)) {
        tempNode = MethodBodyIterativeDeclaration(retorno);
      } else if (jj_2_171(2147483647)) {
        tempNode = MethodBodyConditionalDeclaration(retorno);
      } else if (jj_2_172(2147483647)) {
        tempNode = LocalVariableDeclaration();
        jj_consume_token(SEMICOLON);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case CONTEXT_DEC:
        case STM_LIST:
        case BLOCK:
        case ID:
        case ITERATIVE_DECLARATION:
        case LITERAL:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case LEXECDEC:
        case SEMICOLON:
        case INCR:
        case DECR:
          tempNode = Statement(retorno);
          break;
        default:
          jj_la1[118] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
              if (tempNode != null) decSet.addElement(tempNode);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case CONTEXT_DEC:
      case STM_LIST:
      case BLOCK:
      case ID:
      case ITERATIVE_DECLARATION:
      case LITERAL:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
      case INCR:
      case DECR:
        ;
        break;
      default:
        jj_la1[119] = jj_gen;
        break label_34;
      }
    }
    jj_consume_token(RBRACE);
        if (s != null) {
                iterSet = new JIdentifier(s.image);
            }
            else  if (execDec != null){
                iterSet = execDec;
            }


        placeholder = new JIdentifier(r.image);
        retorno.setIterationSet(iterSet);
        retorno.setPlaceholder(placeholder);
        retorno.setDeclarationSet(decSet);
        retorno.setParentNode(parent);
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/*
 * Expression syntax follows.
 */
  static final public JExpression Expression() throws ParseException {
    JExpression retorno = null;
    JExpression exp1 = null;
    int oper = 0;
    JExpression exp2 = null;
    exp1 = ConditionalExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
    case PLUSASSIGN:
    case MINUSASSIGN:
    case STARASSIGN:
    case SLASHASSIGN:
    case ANDASSIGN:
    case ORASSIGN:
    case XORASSIGN:
    case REMASSIGN:
    case LSHIFTASSIGN:
    case RSIGNEDSHIFTASSIGN:
    case RUNSIGNEDSHIFTASSIGN:
      oper = AssignmentOperator();
      exp2 = Expression();
           retorno = new JAssignmentExpression(oper/*JBinaryExpression.ASSIGN*/, exp1, exp2 );
      break;
    default:
      jj_la1[120] = jj_gen;
      ;
    }
       if (exp2 == null) {
           retorno = exp1;
       }
       {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public int AssignmentOperator() throws ParseException {
   int retorno = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
       retorno = JBinaryExpression.ASSIGN;
      break;
    case STARASSIGN:
      jj_consume_token(STARASSIGN);
        retorno = JBinaryExpression.TIMES_ASSIGN;
      break;
    case SLASHASSIGN:
      jj_consume_token(SLASHASSIGN);
        retorno = JBinaryExpression.DIVIDE_ASSIGN;
      break;
    case REMASSIGN:
      jj_consume_token(REMASSIGN);
        retorno = JBinaryExpression.REM_ASSIGN;
      break;
    case PLUSASSIGN:
      jj_consume_token(PLUSASSIGN);
        retorno = JBinaryExpression.PLUS_ASSIGN;
      break;
    case MINUSASSIGN:
      jj_consume_token(MINUSASSIGN);
        retorno = JBinaryExpression.MINUS_ASSIGN;
      break;
    case LSHIFTASSIGN:
      jj_consume_token(LSHIFTASSIGN);
         retorno = JBinaryExpression.LSHIFT_ASSIGN;
      break;
    case RSIGNEDSHIFTASSIGN:
      jj_consume_token(RSIGNEDSHIFTASSIGN);
         retorno = JBinaryExpression.RSIGNED_SHIFT_ASSIGN;
      break;
    case RUNSIGNEDSHIFTASSIGN:
      jj_consume_token(RUNSIGNEDSHIFTASSIGN);
          retorno = JBinaryExpression.RUNSIGNED_SHIFT_ASSIGN;
      break;
    case ANDASSIGN:
      jj_consume_token(ANDASSIGN);
         retorno = JBinaryExpression.AND_ASSIGN;
      break;
    case XORASSIGN:
      jj_consume_token(XORASSIGN);
         retorno = JBinaryExpression.XOR_ASSIGN;
      break;
    case ORASSIGN:
      jj_consume_token(ORASSIGN);
         retorno = JBinaryExpression.OR_ASSIGN;
      break;
    default:
      jj_la1[121] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression ConditionalExpression() throws ParseException {
  JExpression exp1 = null;
  JExpression exp2 = null;
  JExpression exp3 = null;
  JExpression retorno = null;
    exp1 = ConditionalOrExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HOOK:
      jj_consume_token(HOOK);
      exp2 = Expression();
      jj_consume_token(COLON);
      exp3 = ConditionalExpression();
      break;
    default:
      jj_la1[122] = jj_gen;
      ;
    }
      if(exp1!=null && exp2!= null && exp3!=null) {
              retorno = new JTernaryExpression(exp1, exp2, exp3);
      }
      else {
              retorno = exp1;
      }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression ConditionalOrExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = ConditionalAndExpression();
    label_35:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_OR:
        ;
        break;
      default:
        jj_la1[123] = jj_gen;
        break label_35;
      }
      jj_consume_token(SC_OR);
                                             operators.addElement(new Integer(JBinaryExpression.CONDITIONAL_OR_OPERATOR));
      exp2 = ConditionalAndExpression();
                                                                          leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression ConditionalAndExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = InclusiveOrExpression();
    label_36:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_AND:
        ;
        break;
      default:
        jj_la1[124] = jj_gen;
        break label_36;
      }
      jj_consume_token(SC_AND);
                                          operators.addElement(new Integer(JBinaryExpression.CONDITIONAL_AND_OPERATOR));
      exp2 = InclusiveOrExpression();
                                                                    leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression InclusiveOrExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = ExclusiveOrExpression();
    label_37:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_OR:
        ;
        break;
      default:
        jj_la1[125] = jj_gen;
        break label_37;
      }
      jj_consume_token(BIT_OR);
                                         operators.addElement(new Integer(JBinaryExpression.INCLUSIVE_OR_OPERATOR));
      exp2 = ExclusiveOrExpression();
                                                                    leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression ExclusiveOrExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
   Vector operators = new Vector();
    exp1 = AndExpression();
    label_38:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XOR:
        ;
        break;
      default:
        jj_la1[126] = jj_gen;
        break label_38;
      }
      jj_consume_token(XOR);
                                 operators.addElement(new Integer(JBinaryExpression.EXCLUSIVE_OR_OPERATOR));
      exp2 = AndExpression();
                                                    leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression AndExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = EqualityExpression();
    label_39:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_AND:
        ;
        break;
      default:
        jj_la1[127] = jj_gen;
        break label_39;
      }
      jj_consume_token(BIT_AND);
                                       operators.addElement(new Integer(JBinaryExpression.AND_OPERATOR));
      exp2 = EqualityExpression();
                                      leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression EqualityExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = InstanceOfExpression();
    label_40:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
      case NE:
        ;
        break;
      default:
        jj_la1[128] = jj_gen;
        break label_40;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        jj_consume_token(EQ);
                                           operators.addElement(new Integer(JBinaryExpression.EQUALITY_OPERATOR));
        break;
      case NE:
        jj_consume_token(NE);
                                    operators.addElement(new Integer(JBinaryExpression.INEQUALITY_OPERATOR));
        break;
      default:
        jj_la1[129] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp2 = InstanceOfExpression();
                                                           leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression InstanceOfExpression() throws ParseException {
    JExpression exp1 = null;
    JType tipo = null;
    exp1 = RelationalExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INSTANCEOF:
      jj_consume_token(INSTANCEOF);
      tipo = Type();
      break;
    default:
      jj_la1[130] = jj_gen;
      ;
    }
      JExpression retorno = null;

      if(tipo != null) {
              retorno = new InstanceOfExpression(exp1,tipo);
      }
      else {
              retorno = exp1;
      }

      addElement(retorno);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression RelationalExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = ShiftExpression();
    label_41:
    while (true) {
      if (jj_2_173(2147483647)) {
        ;
      } else {
        break label_41;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
               operators.addElement(new Integer(JBinaryExpression.LESSER_THAN_OPERATOR));
        break;
      case GT:
        jj_consume_token(GT);
                   operators.addElement(new Integer(JBinaryExpression.GREATER_THAN_OPERATOR));
        break;
      case LE:
        jj_consume_token(LE);
                    operators.addElement(new Integer(JBinaryExpression.LESSER_OR_EQUAL_TO_OPERATOR));
        break;
      case GE:
        jj_consume_token(GE);
                    operators.addElement(new Integer(JBinaryExpression.GREATER_OR_EQUAL_TO_OPERATOR));
        break;
      default:
        jj_la1[131] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp2 = ShiftExpression();
                                    leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression ShiftExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = AdditiveExpression();
    label_42:
    while (true) {
      if (jj_2_174(2147483647)) {
        ;
      } else {
        break label_42;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LSHIFT:
        jj_consume_token(LSHIFT);
                         operators.addElement(new Integer(JBinaryExpression.LEFT_SHIFT_OPERATOR));
        break;
      case RSIGNEDSHIFT:
        jj_consume_token(RSIGNEDSHIFT);
                                         operators.addElement(new Integer(JBinaryExpression.RIGHT_SHIFT_OPERATOR));
        break;
      case RUNSIGNEDSHIFT:
        jj_consume_token(RUNSIGNEDSHIFT);
                                          operators.addElement(new Integer(JBinaryExpression.UNSIGNED_RIGHT_SHIFT_OPERATOR));
        break;
      default:
        jj_la1[132] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp2 = AdditiveExpression();
                                                              leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression AdditiveExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = MultiplicativeExpression();
    label_43:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[133] = jj_gen;
        break label_43;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
                                            operators.addElement(new Integer(JBinaryExpression.ADDITION_OPERATOR));
        break;
      case MINUS:
        jj_consume_token(MINUS);
                                            operators.addElement(new Integer(JBinaryExpression.SUBTRACTION_OPERATOR));
        break;
      default:
        jj_la1[134] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp2 = MultiplicativeExpression();
                                                                        leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression MultiplicativeExpression() throws ParseException {
  JExpression exp1 = null;
  Vector leftHandExpressions = new Vector();
  JExpression exp2 = null;
  Vector operators = new Vector();
    exp1 = UnaryExpression();
    label_44:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[135] = jj_gen;
        break label_44;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
                                   operators.addElement(new Integer(JBinaryExpression.MULTIPLICATION_OPERATOR));
        break;
      case SLASH:
        jj_consume_token(SLASH);
                                   operators.addElement(new Integer(JBinaryExpression.DIVISION_OPERATOR));
        break;
      case REM:
        jj_consume_token(REM);
                                   operators.addElement(new Integer(JBinaryExpression.REMAINDER_OPERATOR));
        break;
      default:
        jj_la1[136] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp2 = UnaryExpression();
                                                      leftHandExpressions.addElement(exp2);
    }
      {if (true) return ParserHelper.makeBinaryExpressionTree(operators, exp1, leftHandExpressions);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression UnaryExpression() throws ParseException {
    int theOperator = 0;
    JExpression exp1 = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PLUS:
    case MINUS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
           theOperator = JUnaryExpression.UNARYPLUSOPERATOR;
        break;
      case MINUS:
        jj_consume_token(MINUS);
           theOperator = JUnaryExpression.UNARYMINUSOPERATOR;
        break;
      default:
        jj_la1[137] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp1 = UnaryExpression();
      break;
    case INCR:
      exp1 = PreIncrementExpression();
      break;
    case DECR:
      exp1 = PreDecrementExpression();
      break;
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case ID:
    case LITERAL:
    case NAME:
    case TYPE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LPAREN:
    case LEXECDEC:
    case BANG:
    case TILDE:
      exp1 = UnaryExpressionNotPlusMinus();
      break;
    default:
      jj_la1[138] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    JExpression retorno=null;

    if(theOperator!=0) {
            retorno = new JUnaryExpression(theOperator, exp1);
    }
    else {
        retorno = exp1;
    }

    addElement(retorno);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression PreIncrementExpression() throws ParseException {
    JExpression exp1 = null;
    jj_consume_token(INCR);
    exp1 = PrimaryExpression();
    {if (true) return new JUnaryExpression(JUnaryExpression.PREFIXINCREMENTOPERATOR, exp1);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression PreDecrementExpression() throws ParseException {
    JExpression exp1 = null;
    jj_consume_token(DECR);
    exp1 = PrimaryExpression();
    {if (true) return new JUnaryExpression(JUnaryExpression.PREFIXDECREMENTOPERATOR, exp1);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression UnaryExpressionNotPlusMinus() throws ParseException {
    JExpression exp1 = null;
    int theOperator = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BANG:
    case TILDE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TILDE:
        jj_consume_token(TILDE);
           theOperator = JUnaryExpression.NOTOPERATOR;
        break;
      case BANG:
        jj_consume_token(BANG);
           theOperator = JUnaryExpression.CONDITIONALNOTOPERATOR;
        break;
      default:
        jj_la1[139] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      exp1 = UnaryExpression();
      break;
    default:
      jj_la1[140] = jj_gen;
      if (jj_2_175(2147483647)) {
        exp1 = CastExpression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case ID:
        case LITERAL:
        case NAME:
        case TYPE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LEXECDEC:
          exp1 = PostfixExpression();
          break;
        default:
          jj_la1[141] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    JExpression retorno = null;

    if(theOperator != 0) {
            retorno = new JUnaryExpression(theOperator, exp1);
    }
    else {
            retorno = exp1;
    }

    addElement(retorno);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

// This production is to determine lookahead only.  The LOOKAHEAD specifications
// below are not used, but they are there just to indicate that we know about
// this.
// Alterado em 16/06/2004, para suportar a construo: "(type) exp"
  static final public void CastLookahead() throws ParseException {
    if (jj_2_178(2147483647)) {
      jj_consume_token(LPAREN);
      PrimitiveType();
    } else if (jj_2_179(2147483647)) {
      jj_consume_token(LPAREN);
      Name();
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        Type();
        jj_consume_token(RPAREN);
        if (jj_2_176(2147483647)) {
          Identifier();
        } else if (jj_2_177(2147483647)) {
          Expression();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case TILDE:
            jj_consume_token(TILDE);
            break;
          case BANG:
            jj_consume_token(BANG);
            break;
          case RPAREN:
            jj_consume_token(RPAREN);
            break;
          case THIS:
            jj_consume_token(THIS);
            break;
          case SUPER:
            jj_consume_token(SUPER);
            break;
          case NEW:
            jj_consume_token(NEW);
            break;
          case FALSE:
          case NULL:
          case TRUE:
          case LITERAL:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
            Literal();
            break;
          default:
            jj_la1[142] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[143] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  static final public JExpression PostfixExpression() throws ParseException {
    int theOperator=0;
    JExpression exp1 = null;
    //  LOOKAHEAD(PrimaryExpression() ("++" | "--"))
    //  LOOKAHEAD(2)
    //  (
      exp1 = PrimaryExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCR:
    case DECR:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCR:
        jj_consume_token(INCR);
                                      theOperator = JUnaryExpression.POSTFIXINCREMENTOPERATOR;
        break;
      case DECR:
        jj_consume_token(DECR);
                                      theOperator = JUnaryExpression.POSTFIXDECREMENTOPERATOR;
        break;
      default:
        jj_la1[144] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[145] = jj_gen;
      ;
    }
      JExpression retorno = null;

      if(theOperator!=0) {
          retorno = new JUnaryExpression(theOperator, exp1);
      }
      else {
              retorno = exp1;
      }

      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression CastExpression() throws ParseException {
    JType tipo = null;
    JExpression exp1 = null;
    if (jj_2_180(2147483647)) {
      jj_consume_token(LPAREN);
      tipo = Type();
      jj_consume_token(RPAREN);
      exp1 = UnaryExpression();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        tipo = Type();
        jj_consume_token(RPAREN);
        exp1 = UnaryExpressionNotPlusMinus();
        break;
      default:
        jj_la1[146] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    JExpression retorno = new CastExpression(tipo, exp1);
    addElement(retorno);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression PrimaryExpression() throws ParseException {
    JaTSNode prefix = null;
    NodeList suffixes = new NodeList();
    JaTSNode suffix = null;
    JExpression retorno = null;
    Token first= null, last = null;
     first = getToken(0);
    prefix = PrimaryPrefix();
     last = getToken(1);
    label_45:
    while (true) {
      if (jj_2_181(2)) {
        ;
      } else {
        break label_45;
      }
      suffix = PrimarySuffix();
                                              suffixes.addElement(suffix);
    }
        String doc = ParserHelper.generateSpecialTokenString(first, last);
        if (doc != null && doc.length() > 0) {
           first = null;
           last = null;
        }

        // Sem sufixo
        if (suffix == null) {

            if (!(prefix instanceof JName) && (prefix instanceof JExpression)) {
                retorno = (JExpression) prefix;
            }
            // se cair aqui ou o cara eh um name. pois se ele for
            // instancia de JName, tb , necessariamente de JExpression
            // o retorno, , necessariamente, um acesso a atributo
            else {
                JName name = (JName) prefix;
                int tam = name.size();

                // se tem mais de um identificador, ja podemos gerar o
                // JFieldAccess a partir deste nome.
                if (tam > 1) {
                     retorno = name.toFieldAccess();
                }
                else {
                    retorno = (JName) prefix;
                }
            }
        }
        // Tratamento uniforme para invocaes de mtodos e acessos a atributos
        // e acesso a array.
        else {

            // Se o primeiro n for um Name os identificadores que dele
            // fazem parte sero adicionados  lista de sufixos, pra um
            // tratamento uniforme
            if (prefix instanceof JName) {
                JName tmpName = (JName) prefix;
                NodeList ids = tmpName.toNodeList();
                suffixes = ids.concat(suffixes);

            } else {
                suffixes.insertElementAt(prefix, 0);
            }
            try {
                retorno = ParserHelper.getPrimaryExpression(suffixes);
            }
            catch(InconsistentNodeException e){
                {if (true) throw new IllegalArgumentException("Erro ao criar o noh referente aa PExp");}
            }


            if (retorno == null) {
                if (!(prefix instanceof JExpression)) {
                    {if (true) throw new ParseException();}
                }
                retorno = (JExpression) prefix;
            }
        }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode PrimaryPrefix() throws ParseException {
    JaTSNode node = null;
    JExpression exp1 = null;
    JName name = null;
    JIdentifier id = new JIdentifier();
    JType t = null;
    Token tk = null;
    if (jj_2_182(2147483647)) {
      node = Literal();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case THIS:
        jj_consume_token(THIS);
              node = new JIdentifier("this");
        break;
      case SUPER:
        jj_consume_token(SUPER);
        jj_consume_token(DOT);
        id = Identifier();
       node = new JName("super"); ((JName)node).addIdentifier(id);
        break;
      case LPAREN:
        jj_consume_token(LPAREN);
        exp1 = Expression();
        jj_consume_token(RPAREN);
          node = new JUnaryExpression(JUnaryExpression.PARENTHESIZEDEXPRESSION, exp1);
        break;
      default:
        jj_la1[147] = jj_gen;
        if (jj_2_183(2147483647)) {
          node = AllocationExpression();
        } else if (jj_2_184(2147483647)) {
          t = ResultType();
          jj_consume_token(DOT);
          tk = jj_consume_token(CLASS);
        JFieldAccess  retorno = new JFieldAccess();
        retorno.setReferencedObject(t);
        retorno.setFieldName(new JIdentifier("class"));
        node = retorno;
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ID:
          case NAME:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LEXECDEC:
            node = Name();
            break;
          default:
            jj_la1[148] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
      {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode PrimarySuffix() throws ParseException {
    JaTSNode node = null;
    JIdentifier id = null;
    if (jj_2_185(2)) {
      jj_consume_token(DOT);
      jj_consume_token(THIS);
                node = new JIdentifier("this");
    } else if (jj_2_186(2)) {
      jj_consume_token(DOT);
      jj_consume_token(SUPER);
                node = new JIdentifier("super");
    } else if (jj_2_187(2)) {
      jj_consume_token(DOT);
      node = AllocationExpression();
    } else if (jj_2_188(2147483647)) {
      node = ArrayIndexers();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        jj_consume_token(DOT);
        id = Identifier();
                        node = id;
        break;
      case LPAREN:
        node = Arguments();
        break;
      default:
        jj_la1[149] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

/**
 * Lista dos indexadores de um array.
 */
  static final public JExpressionList ArrayIndexers() throws ParseException {
   JExpressionList retorno = new JExpressionList(JExpressionList.ARRAY_INDEXERS);
   JExpression tmpExpression = null;
    jj_consume_token(LBRACKET);
    tmpExpression = Expression();
          retorno.addExpression(tmpExpression);
    jj_consume_token(RBRACKET);
    label_46:
    while (true) {
      if (jj_2_189(2147483647)) {
        ;
      } else {
        break label_46;
      }
      jj_consume_token(LBRACKET);
      tmpExpression = Expression();
      jj_consume_token(RBRACKET);
         retorno.addExpression(tmpExpression);
    }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression Literal() throws ParseException {
    JExpression exp1 = null;
    JExpression retorno = null;
    Token tk = null;
    int litType = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LITERAL:
      jj_consume_token(LITERAL);
      jj_consume_token(COLON);
      tk = jj_consume_token(JIDENTIFIER);
            exp1 = new JLiteral();
        exp1.setVariableName(tk.image);
        exp1.setVariableType(JaTSNode.LITERAL);
      break;
    case FALSE:
    case NULL:
    case TRUE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        tk = jj_consume_token(INTEGER_LITERAL);
        if (tk.image.endsWith("L") || tk.image.endsWith("l")) {
            litType = JLiteral.LONG_LITERAL;
        }
        else {
            litType = JLiteral.INTEGER_LITERAL;
        }
        break;
      case FLOATING_POINT_LITERAL:
        tk = jj_consume_token(FLOATING_POINT_LITERAL);
                                   litType = JLiteral.FLOATING_POINT_LITERAL;
        break;
      case CHARACTER_LITERAL:
        tk = jj_consume_token(CHARACTER_LITERAL);
                              litType = JLiteral.CHARACTER_LITERAL;
        break;
      case STRING_LITERAL:
        tk = jj_consume_token(STRING_LITERAL);
                           litType = JLiteral.STRING_LITERAL;
        break;
      case FALSE:
      case TRUE:
        exp1 = BooleanLiteral();
        break;
      case NULL:
        exp1 = NullLiteral();
        break;
      default:
        jj_la1[150] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[151] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      if(exp1 == null) {
                retorno = new JLiteral(litType, tk.image);
      }
      else {
                  retorno = exp1;
      }
      retorno.setLine(line);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression BooleanLiteral() throws ParseException {
    Token tk = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      tk = jj_consume_token(TRUE);
      break;
    case FALSE:
      tk = jj_consume_token(FALSE);
      break;
    default:
      jj_la1[152] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return new JLiteral(JLiteral.BOOLEAN_LITERAL, tk.image);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression NullLiteral() throws ParseException {
    Token tk = null;
    tk = jj_consume_token(NULL);
        {if (true) return new JLiteral(JLiteral.NULL_LITERAL, tk.image);}
    throw new Error("Missing return statement in function");
  }

  static final public JExpressionList Arguments() throws ParseException {
    JExpressionList args = new JExpressionList(JExpressionList.ARGUMENTS);
    JExecutableDeclaration execDec;
    Token t = null;
    jj_consume_token(LPAREN);
    if (jj_2_190(2147483647)) {
      jj_consume_token(EXPRESSION_LIST);
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JIDENTIFIER:
        t = jj_consume_token(JIDENTIFIER);
        args.setVariableName(t.image);
        args.setVariableType(JaTSNode.EXPRESSION_LIST);
        break;
      case LEXECDEC:
        execDec = ExecutableDeclaration();
            args.setExecutable(true);
        args.setExecutableDeclaration(execDec);
            args.setVariableType(JaTSNode.NAME_LIST);
        break;
      default:
        jj_la1[153] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case ID:
      case LITERAL:
      case NAME:
      case TYPE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LEXECDEC:
      case BANG:
      case TILDE:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
        ExpressionList(args);
        break;
      default:
        jj_la1[154] = jj_gen;
        ;
      }
    }
    jj_consume_token(RPAREN);
      // removi a adio na tabela
      //addElement(args);
      {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpressionList ExpressionList(JExpressionList args) throws ParseException {
    JExpression exp1 = null;
    JExpression exp2 = null;
    exp1 = Expression();
                        args.addExpression(exp1);
    label_47:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[155] = jj_gen;
        break label_47;
      }
      jj_consume_token(COMMA);
      exp2 = Expression();
                              args.addExpression(exp2);
    }
      {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

  static final public JExpression AllocationExpression() throws ParseException {
    JName nome = null;
    JArrayDimsAndInits adi = null;
    JExpressionList argList = null;
    int allocationType = 0;
    JClassDeclaration jclass = new JClassDeclaration();
    TypeBody body = null;
    if (jj_2_192(2)) {
      jj_consume_token(NEW);
      nome = PrimitiveType();
      adi = ArrayDimsAndInits();
        allocationType = JAllocationExpression.PRIMITIVETYPEARRAYALLOCATION;
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        nome = Name();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          adi = ArrayDimsAndInits();
          allocationType = JAllocationExpression.OBJECTARRAYALLOCATION;
          break;
        case LPAREN:
          argList = Arguments();
          if (jj_2_191(2147483647)) {
            body = ClassBody(jclass);
          } else {
            ;
          }
          allocationType = JAllocationExpression.OBJECTALLOCATION;
          break;
        default:
          jj_la1[156] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[157] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      JAllocationExpression retorno =  new JAllocationExpression(nome, allocationType, argList, adi);
      if (body != null){
          retorno.setInternalClassBody(body);
      }

      addElement(retorno);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/*
 * The second LOOKAHEAD specification below is to parse to PrimarySuffix
 * if there is an expression between the "[...]".
 */
  static final public JArrayDimsAndInits ArrayDimsAndInits() throws ParseException {
    NodeList sizeExps = new NodeList();
    int numDimensions = 0;
    JExpression exp1 = null;
    JArrayInitializer aInit = null;
    if (jj_2_195(2)) {
      label_48:
      while (true) {
        jj_consume_token(LBRACKET);
        exp1 = Expression();
        jj_consume_token(RBRACKET);
        sizeExps.addElement(exp1); numDimensions++;
        if (jj_2_193(2)) {
          ;
        } else {
          break label_48;
        }
      }
      label_49:
      while (true) {
        if (jj_2_194(2)) {
          ;
        } else {
          break label_49;
        }
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
                           numDimensions++;
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        label_50:
        while (true) {
          jj_consume_token(LBRACKET);
          jj_consume_token(RBRACKET);
              numDimensions++;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            ;
            break;
          default:
            jj_la1[158] = jj_gen;
            break label_50;
          }
        }
        aInit = ArrayInitializer();
        break;
      default:
        jj_la1[159] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    JArrayDimsAndInits retorno = new JArrayDimsAndInits(numDimensions, sizeExps, aInit);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/*
 * Statement syntax follows.
 *
 * gas: retorno de um valor para uso em declaracoes iterativas
 */
  static final public JaTSNode Statement(JaTSNode parent) throws ParseException {
  JaTSNode retorno = null ;
  JExpression exp = null;
  Token first = null, last = null;
    if (jj_2_196(2147483647)) {
      retorno = LabeledStatement(parent);
    } else if (jj_2_197(2147483647)) {
      retorno = Block();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        retorno = EmptyStatement();
        break;
      default:
        jj_la1[160] = jj_gen;
        if (jj_2_198(2147483647)) {
          exp = StatementExpression();
          jj_consume_token(SEMICOLON);
     retorno = new JStatementExpression(exp);
        } else if (jj_2_199(2147483647)) {
          retorno = SwitchStatement();
        } else if (jj_2_200(2147483647)) {
          retorno = IfStatement();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case WHILE:
            retorno = WhileStatement();
            break;
          case DO:
            retorno = DoStatement();
            break;
          case FOR:
            retorno = ForStatement();
            break;
          case BREAK:
            retorno = BreakStatement();
            break;
          case CONTINUE:
            retorno = ContinueStatement();
            break;
          case RETURN:
            retorno = ReturnStatement();
            break;
          case THROW:
            retorno = ThrowStatement();
            break;
          case SYNCHRONIZED:
            retorno = SynchronizedStatement();
            break;
          case TRY:
            retorno = TryStatement();
            break;
          default:
            jj_la1[161] = jj_gen;
            if (jj_2_201(2147483647)) {
              retorno = MethodBodyConditionalDeclaration(parent);
            } else if (jj_2_202(2147483647)) {
              retorno = MethodBodyIterativeDeclaration(parent);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case STM_LIST:
                retorno = StatementListDeclaration();
                break;
              case CONTEXT_DEC:
                retorno = ContextDeclaration();
                break;
              case ASSERT:
                // added by Andrea Gini
                  retorno = AssertStatement();
                break;
              default:
                jj_la1[162] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
        }
      }
    }
//     String javadoc = ParserHelper.generateSpecialTokenString(first, last);
//     if (javadoc != null && javadoc.length() > 0) {
//        ((JStatement)retorno).setComment(new JComment(javadoc));
//     }

  {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode StatementListDeclaration() throws ParseException {
    JStatementList retorno = new JStatementList();
    Token t = null;
    jj_consume_token(STM_LIST);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(SEMICOLON);
          retorno.setVariable(true);
          retorno.setVariableName(t.image);
          retorno.setVariableType(JaTSNode.STATEMENT_LIST);
          addElement(retorno);
                {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode LabeledStatement(JaTSNode parent) throws ParseException {
    Token first = null;
    Token last = null;
    JNodeString node = null;
     first = getToken(1);
    Identifier();
    jj_consume_token(COLON);
    Statement(parent);
     last = getToken(0);
    node = new JNodeString(ParserHelper.generateString(first, last));
    {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public JBlock Block() throws ParseException {
    JBlock retorno = new JBlock();
    NodeList statements = retorno.getStatements().getStatements();
    JaTSNode temp = null;
    Token t = null, first = null, last = null;
    if (jj_2_204(2147483647)) {
      jj_consume_token(BLOCK);
      jj_consume_token(COLON);
      t = jj_consume_token(JIDENTIFIER);
      jj_consume_token(SEMICOLON);
              retorno.setVariableName(t.image);
              retorno.setVariableType(JaTSNode.BLOCK);
              addElement(retorno);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
              first = getToken(1);
        jj_consume_token(LBRACE);
              last = getToken(0);
        if (jj_2_203(2147483647)) {
          temp = ExplicitConstructorInvocation();
                 statements.addElement(temp);
        } else {
          ;
        }
        label_51:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSERT:
          case BOOLEAN:
          case BREAK:
          case BYTE:
          case CHAR:
          case CLASS:
          case CONTINUE:
          case DO:
          case DOUBLE:
          case FALSE:
          case FINAL:
          case FLOAT:
          case FOR:
          case IF:
          case INT:
          case INTERFACE:
          case LONG:
          case NEW:
          case NULL:
          case RETURN:
          case SHORT:
          case SUPER:
          case SWITCH:
          case SYNCHRONIZED:
          case THIS:
          case THROW:
          case TRUE:
          case TRY:
          case VOID:
          case WHILE:
          case CONTEXT_DEC:
          case STM_LIST:
          case BLOCK:
          case ID:
          case ITERATIVE_DECLARATION:
          case LITERAL:
          case NAME:
          case TYPE:
          case CONDITIONAL:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case JIDENTIFIER:
          case IDENTIFIER:
          case LPAREN:
          case LBRACE:
          case LEXECDEC:
          case SEMICOLON:
          case INCR:
          case DECR:
            ;
            break;
          default:
            jj_la1[163] = jj_gen;
            break label_51;
          }
          temp = BlockStatement(retorno);
                       statements.addElement(temp);
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[164] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
     String javadoc = ParserHelper.generateSpecialTokenString(first, last);
     if (javadoc != null && javadoc.length() > 0) {
        retorno.setComment(new JComment(javadoc));
     }
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Statements que constituem um bloco.
 * Modificado em 02/12/2004, por Adeline
 * para dar suporte a modificador final em innerclasses ou inner interfaces 
 */
  static final public JaTSNode BlockStatement(JaTSNode parent) throws ParseException {
  JaTSNode retorno = null;
  Token tk = null;
  JClassDeclaration jclass = new JClassDeclaration();
  JInterfaceDeclaration jinterface = new JInterfaceDeclaration();
  JModifierList modList = new JModifierList();
    if (jj_2_205(2147483647)) {
      retorno = LocalVariableDeclaration();
      jj_consume_token(SEMICOLON);
    } else if (jj_2_206(2147483647)) {
      jj_consume_token(BLOCK);
      jj_consume_token(COLON);
      tk = jj_consume_token(JIDENTIFIER);
      jj_consume_token(SEMICOLON);
      retorno = new JBlock();
      retorno.setVariableName(tk.image);
      retorno.setVariableType(JaTSNode.BLOCK);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case CONTEXT_DEC:
      case STM_LIST:
      case BLOCK:
      case ID:
      case ITERATIVE_DECLARATION:
      case LITERAL:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
      case INCR:
      case DECR:
        // statement qualquer : if, for, try-catch
          retorno = Statement(parent);
        break;
      default:
        jj_la1[167] = jj_gen;
        if (jj_2_207(2147483647)) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FINAL:
            jj_consume_token(FINAL);
        modList.setPossibleModifiers(JModifierList.CLASS_DECLARATION);
        modList.addModifier(JModifier.FINAL);
            break;
          default:
            jj_la1[165] = jj_gen;
            ;
          }
          UnmodifiedClassDeclaration(jclass);
      jclass.setModifiers(modList);
      retorno = jclass;
        } else if (jj_2_208(2147483647)) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FINAL:
            jj_consume_token(FINAL);
        modList.setPossibleModifiers(JModifierList.INTERFACE_DECLARATION);
        modList.addModifier(JModifier.FINAL);
            break;
          default:
            jj_la1[166] = jj_gen;
            ;
          }
          UnmodifiedInterfaceDeclaration(jinterface);
      jinterface.setModifiers(modList);
      retorno = jinterface;
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Declaracao de variaveis locais a corpo de metodo
 *
 */
  static final public JLocalVariableDeclaration LocalVariableDeclaration() throws ParseException {
  JModifierList modList = new JModifierList(JModifierList.LOCAL_VARIABLE_DECLARATION);
  JLocalVariableDeclaration retorno = new JLocalVariableDeclaration();
  JVariableDeclarator tmpVarDec = null;
  JVariableDeclaratorSet varDecs = new JVariableDeclaratorSet();
  JType type = null;
  Token first= null, last = null;
      first = getToken(0);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINAL:
      jj_consume_token(FINAL);
          modList.addModifier(JModifier.FINAL);
          retorno.setModifiers(modList);
      break;
    default:
      jj_la1[168] = jj_gen;
      ;
    }
    type = Type();
         last = getToken(0);
         retorno.setType(type);
    tmpVarDec = VariableDeclarator();
         varDecs.add(tmpVarDec);
    label_52:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[169] = jj_gen;
        break label_52;
      }
      jj_consume_token(COMMA);
      tmpVarDec = VariableDeclarator();
                                              varDecs.add(tmpVarDec);
    }
    String javadoc = ParserHelper.generateSpecialTokenString(first, last);
     if (javadoc != null && javadoc.length() > 0) {
        retorno.setComment(new JComment(javadoc));
     }
    retorno.setVariables(varDecs);
    retorno.setModifiers(modList);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JaTSNode EmptyStatement() throws ParseException {
  JNodeString node = new JNodeString(";");
    jj_consume_token(SEMICOLON);
   {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

/**
 * Relativo a uma expressao com ";" no final
 *
 */
  static final public JExpression StatementExpression() throws ParseException {
   JExpression retorno = null;
   JExpression exp1 = null;
   JExpression exp2 = null;
   int assOp = 0;
   int op = 0;

   Token first = null;
   Token last = null;
  first = getToken(1);
    if (jj_2_209(2147483647)) {
      exp1 = PreIncrementExpression();
    } else if (jj_2_210(2147483647)) {
      exp1 = PreDecrementExpression();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case ID:
      case LITERAL:
      case NAME:
      case TYPE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LEXECDEC:
        exp1 = PrimaryExpression();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
        case INCR:
        case DECR:
        case PLUSASSIGN:
        case MINUSASSIGN:
        case STARASSIGN:
        case SLASHASSIGN:
        case ANDASSIGN:
        case ORASSIGN:
        case XORASSIGN:
        case REMASSIGN:
        case LSHIFTASSIGN:
        case RSIGNEDSHIFTASSIGN:
        case RUNSIGNEDSHIFTASSIGN:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INCR:
            jj_consume_token(INCR);
       op = JUnaryExpression.POSTFIXINCREMENTOPERATOR ;
            break;
          case DECR:
            jj_consume_token(DECR);
       op = JUnaryExpression.POSTFIXDECREMENTOPERATOR ;
            break;
          case ASSIGN:
          case PLUSASSIGN:
          case MINUSASSIGN:
          case STARASSIGN:
          case SLASHASSIGN:
          case ANDASSIGN:
          case ORASSIGN:
          case XORASSIGN:
          case REMASSIGN:
          case LSHIFTASSIGN:
          case RSIGNEDSHIFTASSIGN:
          case RUNSIGNEDSHIFTASSIGN:
            assOp = AssignmentOperator();
            exp2 = Expression();
            break;
          default:
            jj_la1[170] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[171] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[172] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  last = getToken(0);
  //se for uma expressao de atribuicao, eh tratado como binaryExpression
  // entretanto, no  avaliado pelo evalutation visitor
  if (exp2 != null) {

      retorno = new JAssignmentStatement(assOp,exp1,exp2);
  }
  else if( op != 0){
      retorno = new JUnaryExpression(op, exp1);
  }
  else {
      retorno = exp1;
  }


  {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JSwitchStatement SwitchStatement() throws ParseException {
    JSwitchStatement retorno = new JSwitchStatement();
    JExpression expr = null;
    JSwitchPair tmpPair = null;
    JSwitchLabel tmpLabel = null;
    JaTSNode tmpStatement = null;
    NodeList statements = null;
    NodeList labels = new NodeList();
    jj_consume_token(SWITCH);
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_53:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case _DEFAULT:
        ;
        break;
      default:
        jj_la1[173] = jj_gen;
        break label_53;
      }
      tmpLabel = SwitchLabel();
           tmpPair = new JSwitchPair();
           tmpPair.setLabel(tmpLabel);
           statements = new NodeList();
      label_54:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CLASS:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case INTERFACE:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case CONTEXT_DEC:
        case STM_LIST:
        case BLOCK:
        case ID:
        case ITERATIVE_DECLARATION:
        case LITERAL:
        case NAME:
        case TYPE:
        case CONDITIONAL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case LEXECDEC:
        case SEMICOLON:
        case INCR:
        case DECR:
          ;
          break;
        default:
          jj_la1[174] = jj_gen;
          break label_54;
        }
        tmpStatement = BlockStatement(retorno);
             statements.addElement(tmpStatement);
      }
           tmpPair.setStatements(statements);
           labels.addElement(tmpPair);
    }
       retorno.setExpression(expr);
       retorno.setCases(labels);
    jj_consume_token(RBRACE);
    {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JSwitchLabel SwitchLabel() throws ParseException {
   JSwitchLabel retorno = new JSwitchLabel();
   JExpression expr = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CASE:
      jj_consume_token(CASE);
      expr = Expression();
      jj_consume_token(COLON);
        retorno.setType(JSwitchLabel.CASE);
        retorno.setExpression(expr);
      break;
    case _DEFAULT:
      jj_consume_token(_DEFAULT);
      jj_consume_token(COLON);
       retorno.setType(JSwitchLabel.DEFAULT);
      break;
    default:
      jj_la1[175] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JIfStatement IfStatement() throws ParseException {
   JIfStatement retorno = new JIfStatement();
   JExpression exp = null;
   JaTSNode ifStmt = null;
   JaTSNode elseStmt = null;
   Token first = null, last = null, first2 = null, last2 = null;
  first = getToken(1);
    jj_consume_token(IF);
   last = getToken(0);
    jj_consume_token(LPAREN);
    exp = Expression();
    jj_consume_token(RPAREN);
      retorno.setExpression(exp);
    ifStmt = Statement(retorno);
      retorno.setIfStatement(ifStmt);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
                  first2 = getToken(1);
      jj_consume_token(ELSE);
                                                 last2 = getToken(0);
      elseStmt = Statement(retorno);
          retorno.setElseStatement(elseStmt);
      break;
    default:
      jj_la1[176] = jj_gen;
      ;
    }
   String ifdoc = ParserHelper.generateSpecialTokenString(first, last);
   String elsedoc = ParserHelper.generateSpecialTokenString(first2, last2);

   if (Util.checkString(ifdoc)) {
       retorno.setIfComment(ifdoc);
   }
   if (Util.checkString(elsedoc)) {
       retorno.setElseComment(elsedoc);
   }

   {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * While
 *
 * Um statement do tipo:
 *
 *  while (condition) {
 *      cmd1;
 *      cmd2;
 *  }
 *
 */
  static final public JWhileStatement WhileStatement() throws ParseException {
    JWhileStatement retorno = new JWhileStatement();
    retorno.setType(JWhileStatement.WHILE);
    JExpression exp = null;
    JaTSNode stmt = null;
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    exp = Expression();
    jj_consume_token(RPAREN);
       retorno.setExpression(exp);
    stmt = Statement(retorno);
      retorno.setStatement(stmt);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Do-While
 *
 * Um statement do tipo:
 *
 *  do {
 *      cmd1;
 *      cmd2;
 *  } 
 *  while(condition);
 *
 */
  static final public JWhileStatement DoStatement() throws ParseException {
    JWhileStatement retorno = new JWhileStatement();
    retorno.setType(JWhileStatement.DO);
    JExpression exp = null;
    JaTSNode stmt = null;
    jj_consume_token(DO);
    stmt = Statement(retorno);
       retorno.setStatement(stmt);
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    exp = Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
       retorno.setExpression(exp);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * ForStatement
 *
 * Um statement do tipo:
 *
 *   for (int i = 0; i< size; i++) {
 *       // doFor();
 *   }
 *
 */
  static final public JStatement ForStatement() throws ParseException {
  JForStatement retorno = new JForStatement();
  // inicializacao do for: int i = 0
  JaTSNode forInit = null;
  // condicao de parada do for: i < size
  JExpression exp = null;
  // atualizacao da variavel do for: i++
  JExpressionList forUpdate = null;
  // statement associado (o que o for vai fazer ) : doFor();
  JaTSNode statement = null;
    jj_consume_token(FOR);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FINAL:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case ID:
    case LITERAL:
    case NAME:
    case TYPE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LPAREN:
    case LEXECDEC:
    case INCR:
    case DECR:
      forInit = ForInit();
                              retorno.setForInit(forInit);
      break;
    default:
      jj_la1[177] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case ID:
    case LITERAL:
    case NAME:
    case TYPE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LPAREN:
    case LEXECDEC:
    case BANG:
    case TILDE:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
      exp = Expression();
                             retorno.setExpression(exp);
      break;
    default:
      jj_la1[178] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FALSE:
    case FLOAT:
    case INT:
    case LONG:
    case NEW:
    case NULL:
    case SHORT:
    case SUPER:
    case THIS:
    case TRUE:
    case VOID:
    case ID:
    case LITERAL:
    case NAME:
    case TYPE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LPAREN:
    case LEXECDEC:
    case INCR:
    case DECR:
      forUpdate = ForUpdate();
                                  retorno.setForUpdate(forUpdate);
      break;
    default:
      jj_la1[179] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    statement = Statement(retorno);
                                        retorno.setStatement(statement);
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 *  Inicializacao do for, exemplo:
 *
 *  int i = 0;
 */
  static final public JaTSNode ForInit() throws ParseException {
    JaTSNode retorno = null;
    if (jj_2_211(2147483647)) {
      retorno = LocalVariableDeclaration();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case ID:
      case LITERAL:
      case NAME:
      case TYPE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LEXECDEC:
      case INCR:
      case DECR:
        retorno = StatementExpressionList();
        break;
      default:
        jj_la1[180] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 *  Condio de parada do for, exemplo:
 *
 *  i < size
 */
  static final public JExpressionList StatementExpressionList() throws ParseException {
    JExpressionList retorno = new JExpressionList(JExpressionList.ARGUMENTS);
    JExpression tmpExp = null;
    tmpExp = StatementExpression();
                                      retorno.addExpression(tmpExp);
    label_55:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[181] = jj_gen;
        break label_55;
      }
      jj_consume_token(COMMA);
      tmpExp = StatementExpression();
                                            retorno.addExpression(tmpExp);
    }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 *  Incremento do for , exemplo:
 *
 *  i++
 */
  static final public JExpressionList ForUpdate() throws ParseException {
   JExpressionList retorno  = null;
    retorno = StatementExpressionList();
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

/**
 * Statement break:
 *
 *  break;
 *   ou
 *  break label;
 *
 */
  static final public JStatement BreakStatement() throws ParseException {
  Token first = null;
  Token last = null;
  JNodeString node = null;
     first = getToken(1);
    jj_consume_token(BREAK);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LEXECDEC:
      Identifier();
      break;
    default:
      jj_la1[182] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
     last = getToken(0);
     node = new JNodeString(ParserHelper.generateString(first, last));
     {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

/**
 * Statement continue:
 *
 *  continue;
 *   ou
 *  continue label;
 *
 */
  static final public JStatement ContinueStatement() throws ParseException {
  Token first = null;
  Token last = null;
  JNodeString node = null;
     first = getToken(1);
    jj_consume_token(CONTINUE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
    case JIDENTIFIER:
    case IDENTIFIER:
    case LEXECDEC:
      Identifier();
      break;
    default:
      jj_la1[183] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
     last = getToken(0);
     node = new JNodeString(ParserHelper.generateString(first, last));
     {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public JResultStatement ReturnStatement() throws ParseException {
  JResultStatement retorno = new JResultStatement();
  retorno.setType(JResultStatement.RETURN);
  JExpression exp = null;
  Token first = null, last = null;
    if (jj_2_212(2147483647)) {
       first = getToken(1);
      jj_consume_token(RETURN);
       last = getToken(0);
      exp = Name();
      jj_consume_token(SEMICOLON);
          retorno.setExpression(exp);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RETURN:
       first = getToken(1);
        jj_consume_token(RETURN);
       last = getToken(0);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case ID:
        case LITERAL:
        case NAME:
        case TYPE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case JIDENTIFIER:
        case IDENTIFIER:
        case LPAREN:
        case LEXECDEC:
        case BANG:
        case TILDE:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
          exp = Expression();
              retorno.setExpression(exp);
          break;
        default:
          jj_la1[184] = jj_gen;
          ;
        }
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[185] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
     String doc = ParserHelper.generateSpecialTokenString(first, last);
     if (doc != null && doc.length() > 0) {
        retorno.setComment(new JComment(doc));
     }
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JResultStatement ThrowStatement() throws ParseException {
  JResultStatement retorno = new JResultStatement();
  retorno.setType(JResultStatement.THROW);
  JExpression exp = null;
  Token first = null, last = null;
   first = getToken(1);
    jj_consume_token(THROW);
   last = getToken(0);
    exp = Expression();
    jj_consume_token(SEMICOLON);
     String doc = ParserHelper.generateSpecialTokenString(first, last);
     if (doc != null && doc.length() > 0) {
        retorno.setComment(new JComment(doc));
     }
     retorno.setExpression(exp);
     {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public JStatement SynchronizedStatement() throws ParseException {
  //Token first = null;
  //Token last = null;
  //JNodeString node = null;
  JExpression exp = null;
  JBlock block = null;
  JSynchronizedStatement result = new JSynchronizedStatement();
    jj_consume_token(SYNCHRONIZED);
    jj_consume_token(LPAREN);
    exp = Expression();
    jj_consume_token(RPAREN);
    block = Block();
        result.setLockedObject(exp);
        result.setStatement(block);
        {if (true) return result;}
   //node = new JNodeString(ParserHelper.generateString(first, last));
   //return node;

    throw new Error("Missing return statement in function");
  }

  static final public JTryStatement TryStatement() throws ParseException {
   JTryStatement retorno = new JTryStatement();
   JBlock tBlock = null;
   JBlock fBlock = null;
   NodeList catchList = new NodeList();
   JCatchClause tmpCatch = null;
   JFormalParameter param = null;
   JBlock catchBlock = null;
   Token first= null, last= null;
   String doc = null;
   first = getToken(1);
    jj_consume_token(TRY);
   last = getToken(0);
    tBlock = Block();
      retorno.setTryBlock(tBlock);
      doc = ParserHelper.generateSpecialTokenString(first, last);
      if (doc != null && doc.length() > 0) {
          retorno.setTryComment(doc);
      }
      doc = null;
      first = null;
      last = null;
    label_56:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CATCH:
        ;
        break;
      default:
        jj_la1[186] = jj_gen;
        break label_56;
      }
       first = getToken(1);
      jj_consume_token(CATCH);
       last = getToken(0);
      jj_consume_token(LPAREN);
      param = FormalParameter();
      jj_consume_token(RPAREN);
      catchBlock = Block();
          tmpCatch = new JCatchClause();
          tmpCatch.setParameter(param);
          tmpCatch.setBlock(catchBlock);
          doc = ParserHelper.generateSpecialTokenString(first, last);
          if (doc != null && doc.length() > 0) {
             tmpCatch.setComment(doc);
          }
          doc = null;
          first = null;
          last = null;
          catchList.addElement(tmpCatch);
    }
      retorno.setCatchlist(catchList);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINALLY:
      first = getToken(1);
      jj_consume_token(FINALLY);
      last = getToken(0);
      fBlock = Block();
         retorno.setFinallyBlock(fBlock);
         doc = ParserHelper.generateSpecialTokenString(first, last);
         if (doc != null && doc.length() > 0) {
            retorno.setFinallyComment(doc);
         }
         doc = null;
         first = null;
         last = null;
      break;
    default:
      jj_la1[187] = jj_gen;
      ;
    }
      {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

// added by Andrea Gini
  static final public JaTSNode AssertStatement() throws ParseException {
  Token first = null;
  Token last = null;
  JNodeString node = null;
      first = getToken(1);
    jj_consume_token(ASSERT);
    Expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      Expression();
      break;
    default:
      jj_la1[188] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
       last = getToken(0);
      node = new JNodeString(ParserHelper.generateString(first, last));
      {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public JStatementList StatementList() throws ParseException {
        JStatementList statements = new JStatementList();
        JaTSNode temp = null;
    label_57:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
      case BOOLEAN:
      case BREAK:
      case BYTE:
      case CHAR:
      case CLASS:
      case CONTINUE:
      case DO:
      case DOUBLE:
      case FALSE:
      case FINAL:
      case FLOAT:
      case FOR:
      case IF:
      case INT:
      case INTERFACE:
      case LONG:
      case NEW:
      case NULL:
      case RETURN:
      case SHORT:
      case SUPER:
      case SWITCH:
      case SYNCHRONIZED:
      case THIS:
      case THROW:
      case TRUE:
      case TRY:
      case VOID:
      case WHILE:
      case CONTEXT_DEC:
      case STM_LIST:
      case BLOCK:
      case ID:
      case ITERATIVE_DECLARATION:
      case LITERAL:
      case NAME:
      case TYPE:
      case CONDITIONAL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case LEXECDEC:
      case SEMICOLON:
      case INCR:
      case DECR:
        ;
        break;
      default:
        jj_la1[189] = jj_gen;
        break label_57;
      }
      temp = BlockStatement(statements);
              statements.add(temp);
    }
        {if (true) return statements;}
    throw new Error("Missing return statement in function");
  }

  static final public ContextDeclaration ContextDeclaration() throws ParseException {
        ContextDeclaration node = new ContextDeclaration();
    Token contCodeVar = null;
    JStatementList cont = null, code = null;
    Token t = null;
    jj_consume_token(CONTEXT_DEC);
    jj_consume_token(COLON);
    t = jj_consume_token(JIDENTIFIER);
    jj_consume_token(LBRACE);
    contCodeVar = jj_consume_token(JIDENTIFIER);
    jj_consume_token(RBRACE);
    jj_consume_token(SEMICOLON);
                        cont = new JStatementList();
                        cont.setVariableName(t.image);
                        cont.setVariableType(JaTSNode.STATEMENT_LIST);

                        code = new JStatementList();
                        code.setVariableName(contCodeVar.image);
                        code.setVariableType(JaTSNode.STATEMENT_LIST);

                        node = new ContextDeclaration(cont, code);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  static final public ExploreDeclaration ExploreDeclaration() throws ParseException {
    ExploreDeclaration node = new ExploreDeclaration();
    JIdentifier id = null;
    INode where = null;
    jj_consume_token(EXPLORE);
    id = Identifier();
    jj_consume_token(LBRACE);
    label_58:
    while (true) {
      where = WhereClause();
                                         node.addWhereClause(where);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WHERE:
        ;
        break;
      default:
        jj_la1[190] = jj_gen;
        break label_58;
      }
    }
    jj_consume_token(RBRACE);
                node.setBaseNode(id);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public WhereClause WhereClause() throws ParseException {
    WhereClause whereClause = new WhereClause();
    MicroTransformationNode transf = null;
    Class type = null;
    jj_consume_token(WHERE);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXPRESSION:
      jj_consume_token(EXPRESSION);
                                 type = JExpression.class;
      break;
    case ASSIGNMENT_STATEMENT:
      jj_consume_token(ASSIGNMENT_STATEMENT);
                                             type = JAssignmentStatement.class;
      break;
    case ASSIGNMENT_EXPRESSION:
      jj_consume_token(ASSIGNMENT_EXPRESSION);
                                              type = JAssignmentExpression.class;
      break;
    case UNARY_EXPRESSION:
      jj_consume_token(UNARY_EXPRESSION);
                                         type = JUnaryExpression.class;
      break;
    case BINARY_EXPRESSION:
      jj_consume_token(BINARY_EXPRESSION);
                                          type = JBinaryExpression.class;
      break;
    case FIELD_DECLARATION:
      jj_consume_token(FIELD_DECLARATION);
                                          type = JFieldDeclaration.class;
      break;
    case PARAMETER:
      jj_consume_token(PARAMETER);
                                  type = JFormalParameter.class;
      break;
    case LOCAL_DECLARATION:
      jj_consume_token(LOCAL_DECLARATION);
                                          type = JLocalVariableDeclaration.class;
      break;
    case METHOD_DECLARATION:
      jj_consume_token(METHOD_DECLARATION);
                                           type = JMethodDeclaration.class;
      break;
    case TYPE:
      jj_consume_token(TYPE);
                             type = JType.class;
      break;
    default:
      jj_la1[191] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    transf = MicroTransformation();
                whereClause.addTransformationNode(transf);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 182:
      label_59:
      while (true) {
        jj_consume_token(182);
        transf = MicroTransformation();
                      whereClause.addTransformationNode(transf);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 182:
          ;
          break;
        default:
          jj_la1[192] = jj_gen;
          break label_59;
        }
      }
      break;
    default:
      jj_la1[193] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
                whereClause.setClauseType(type);
                {if (true) return whereClause;}
    throw new Error("Missing return statement in function");
  }

  static final public MicroTransformationNode MicroTransformation() throws ParseException {
    MicroTransformationNode node = new MicroTransformationNode();
    MicroTransformation transf = null;
    JPreconditionDeclaration pre = null;
    INode left = null;
    INode right = null;
    left = LHSMicroPattern();
    jj_consume_token(179);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 180:
      pre = PreconditionDeclaration();
      break;
    default:
      jj_la1[194] = jj_gen;
      ;
    }
    right = RHSMicroPattern();
                transf = new MicroTransformation(left, right);
                transf.setPrecondition(pre);
                node.setTransformation(transf);
                {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  static final public INode LHSMicroPattern() throws ParseException {
    INode retorno = null;
    if (jj_2_213(2147483647)) {
      retorno = Type();
    } else if (jj_2_214(2147483647)) {
      retorno = Expression();
    } else if (jj_2_215(2147483647)) {
      retorno = Statement(null);
    } else if (jj_2_216(2147483647)) {
      retorno = FormalParameter();
    } else if (jj_2_217(2147483647)) {
      retorno = LocalVariableDeclaration();
      jj_consume_token(SEMICOLON);
    } else if (jj_2_218(2147483647)) {
      retorno = FieldDeclaration();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case VOID:
      case STRICTFP:
      case ID:
      case METHOD_DECLARATION:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        retorno = MethodDeclaration();
        break;
      default:
        jj_la1[195] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

  static final public INode RHSMicroPattern() throws ParseException {
    INode retorno = null;
    if (jj_2_219(2147483647)) {
      retorno = Type();
    } else if (jj_2_220(2147483647)) {
      retorno = Expression();
    } else if (jj_2_221(2147483647)) {
      retorno = Statement(null);
    } else if (jj_2_222(2147483647)) {
      retorno = FormalParameter();
    } else if (jj_2_223(2147483647)) {
      retorno = LocalVariableDeclaration();
      jj_consume_token(SEMICOLON);
    } else if (jj_2_224(2147483647)) {
      retorno = FieldDeclaration();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case NATIVE:
      case PRIVATE:
      case PROTECTED:
      case PUBLIC:
      case SHORT:
      case STATIC:
      case SYNCHRONIZED:
      case VOID:
      case STRICTFP:
      case ID:
      case METHOD_DECLARATION:
      case MODIFIER_LIST:
      case NAME:
      case TYPE:
      case JIDENTIFIER:
      case IDENTIFIER:
      case LEXECDEC:
        retorno = MethodDeclaration();
        break;
      default:
        jj_la1[196] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return retorno;}
    throw new Error("Missing return statement in function");
  }

//#####################################################################
//Expression language
//#####################################################################
  static final public TraverseMetaOperator TraverseOperator() throws ParseException {
        TraverseMetaOperator op = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSIGNEDSHIFT:
      jj_consume_token(RSIGNEDSHIFT);
               op = new TraverseMetaOperator(TraverseMetaOperator.DIRECT_PARENT_OP);
      break;
    case 183:
      jj_consume_token(183);
                op = new TraverseMetaOperator(TraverseMetaOperator.PARENT_OP);
      break;
    case LSHIFT:
      jj_consume_token(LSHIFT);
               op = new TraverseMetaOperator(TraverseMetaOperator.DIRECT_CHILD_OP);
      break;
    case 184:
      jj_consume_token(184);
                op = new TraverseMetaOperator(TraverseMetaOperator.CHILD_OP);
      break;
    case 185:
      jj_consume_token(185);
               op = new TraverseMetaOperator(TraverseMetaOperator.DIRECT_SUCC_OP);
      break;
    case 186:
      jj_consume_token(186);
                op = new TraverseMetaOperator(TraverseMetaOperator.SUCC_OP);
      break;
    case 187:
      jj_consume_token(187);
               op = new TraverseMetaOperator(TraverseMetaOperator.DIRECT_PRED_OP);
      break;
    case 188:
      jj_consume_token(188);
                op = new TraverseMetaOperator(TraverseMetaOperator.PRED_OP);
      break;
    case 189:
      jj_consume_token(189);
                  op = new TraverseMetaOperator(TraverseMetaOperator.DEC_OP);
      break;
    default:
      jj_la1[197] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  static final public LogicMetaOperator LogicOperator() throws ParseException {
        LogicMetaOperator op = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SC_AND:
      jj_consume_token(SC_AND);
          op = new LogicMetaOperator(LogicMetaOperator.AND_OP);
      break;
    case SC_OR:
      jj_consume_token(SC_OR);
          op = new LogicMetaOperator(LogicMetaOperator.OR_OP);
      break;
    default:
      jj_la1[198] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  static final public MatchingMetaExpression MatchingExpression() throws ParseException {
        MatchingMetaExpression result = null;
        List variables = null;
        INode id = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACKET:
      jj_consume_token(LBRACKET);
      variables = MatchingExpressionList();
      jj_consume_token(RBRACKET);
      break;
    case JIDENTIFIER:
    case IDENTIFIER:
      id = MetaVariable();
            variables  = new ArrayList();
            variables.add(id);
      break;
    default:
      jj_la1[199] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                result = new MatchingMetaExpression(variables);
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public List MatchingExpressionList() throws ParseException {
        List vars = new ArrayList();
        INode id = null;
    id = MetaVariable();
            vars.add(id);
    label_60:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_OR:
        ;
        break;
      default:
        jj_la1[200] = jj_gen;
        break label_60;
      }
      jj_consume_token(BIT_OR);
      MetaVariable();
                                vars.add(id);
    }
                {if (true) return vars;}
    throw new Error("Missing return statement in function");
  }

  static final public MetaVariable MetaVariable() throws ParseException {
        MetaVariable result = null;
        Token id = null, jid = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id = jj_consume_token(IDENTIFIER);
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[201] = jj_gen;
      ;
    }
    jid = jj_consume_token(JIDENTIFIER);
                String jatsVar = jid.image;
                if (id != null) {
                        jatsVar = id.image+":"+jatsVar;
                }
                result = new MetaVariable(jatsVar);
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MetaExpression TraverseExpression() throws ParseException {
        TraverseMetaExpression result = null;
        List operands = new ArrayList();
        List operators = new ArrayList();
        MetaExpression tempExp = null;
        TraverseMetaOperator tempOp = null;
    tempExp = MatchingExpression();
          operands.add(tempExp);
    label_61:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LSHIFT:
      case RSIGNEDSHIFT:
      case 183:
      case 184:
      case 185:
      case 186:
      case 187:
      case 188:
      case 189:
        ;
        break;
      default:
        jj_la1[202] = jj_gen;
        break label_61;
      }
      tempOp = TraverseOperator();
            operators.add(tempOp);
      tempExp = MatchingExpression();
            operands.add(tempExp);
    }
                result = new TraverseMetaExpression(operands, operators);
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MetaExpression BinaryMetaExpression() throws ParseException {
        MetaExpression result = null;
        MetaExpression temp1 = null, temp2 = null;
        LogicMetaOperator op = null;
    temp1 = TraverseExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SC_OR:
    case SC_AND:
      op = LogicOperator();
      temp2 = MetaExpression();
      break;
    default:
      jj_la1[203] = jj_gen;
      ;
    }
                if (temp2 == null) {
                        result = temp1;
                } else {
                        result = new BinaryMetaExpression(temp1, temp2, op);
                }
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public MetaExpression MetaExpression() throws ParseException {
        MetaExpression result = null;
        MetaExpression temp = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      temp = MetaExpression();
      jj_consume_token(RPAREN);
            result = new UnaryMetaExpression(temp);
      break;
    case JIDENTIFIER:
    case IDENTIFIER:
    case LBRACKET:
      result = BinaryMetaExpression();
      break;
    default:
      jj_la1[204] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  static final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  static final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  static final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  static final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  static final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  static final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  static final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  static final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  static final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  static final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  static final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  static final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  static final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  static final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  static final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  static final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  static final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  static final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  static final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_37(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(36, xla); }
  }

  static final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_38(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(37, xla); }
  }

  static final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_39(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(38, xla); }
  }

  static final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_40(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(39, xla); }
  }

  static final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_41(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(40, xla); }
  }

  static final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_42(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(41, xla); }
  }

  static final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_43(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(42, xla); }
  }

  static final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_44(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(43, xla); }
  }

  static final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_45(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(44, xla); }
  }

  static final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_46(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(45, xla); }
  }

  static final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_47(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(46, xla); }
  }

  static final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_48(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(47, xla); }
  }

  static final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_49(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(48, xla); }
  }

  static final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_50(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(49, xla); }
  }

  static final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_51(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(50, xla); }
  }

  static final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_52(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(51, xla); }
  }

  static final private boolean jj_2_53(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_53(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(52, xla); }
  }

  static final private boolean jj_2_54(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_54(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(53, xla); }
  }

  static final private boolean jj_2_55(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_55(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(54, xla); }
  }

  static final private boolean jj_2_56(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_56(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(55, xla); }
  }

  static final private boolean jj_2_57(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_57(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(56, xla); }
  }

  static final private boolean jj_2_58(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_58(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(57, xla); }
  }

  static final private boolean jj_2_59(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_59(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(58, xla); }
  }

  static final private boolean jj_2_60(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_60(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(59, xla); }
  }

  static final private boolean jj_2_61(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_61(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(60, xla); }
  }

  static final private boolean jj_2_62(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_62(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(61, xla); }
  }

  static final private boolean jj_2_63(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_63(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(62, xla); }
  }

  static final private boolean jj_2_64(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_64(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(63, xla); }
  }

  static final private boolean jj_2_65(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_65(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(64, xla); }
  }

  static final private boolean jj_2_66(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_66(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(65, xla); }
  }

  static final private boolean jj_2_67(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_67(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(66, xla); }
  }

  static final private boolean jj_2_68(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_68(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(67, xla); }
  }

  static final private boolean jj_2_69(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_69(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(68, xla); }
  }

  static final private boolean jj_2_70(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_70(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(69, xla); }
  }

  static final private boolean jj_2_71(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_71(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(70, xla); }
  }

  static final private boolean jj_2_72(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_72(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(71, xla); }
  }

  static final private boolean jj_2_73(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_73(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(72, xla); }
  }

  static final private boolean jj_2_74(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_74(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(73, xla); }
  }

  static final private boolean jj_2_75(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_75(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(74, xla); }
  }

  static final private boolean jj_2_76(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_76(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(75, xla); }
  }

  static final private boolean jj_2_77(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_77(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(76, xla); }
  }

  static final private boolean jj_2_78(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_78(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(77, xla); }
  }

  static final private boolean jj_2_79(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_79(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(78, xla); }
  }

  static final private boolean jj_2_80(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_80(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(79, xla); }
  }

  static final private boolean jj_2_81(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_81(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(80, xla); }
  }

  static final private boolean jj_2_82(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_82(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(81, xla); }
  }

  static final private boolean jj_2_83(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_83(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(82, xla); }
  }

  static final private boolean jj_2_84(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_84(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(83, xla); }
  }

  static final private boolean jj_2_85(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_85(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(84, xla); }
  }

  static final private boolean jj_2_86(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_86(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(85, xla); }
  }

  static final private boolean jj_2_87(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_87(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(86, xla); }
  }

  static final private boolean jj_2_88(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_88(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(87, xla); }
  }

  static final private boolean jj_2_89(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_89(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(88, xla); }
  }

  static final private boolean jj_2_90(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_90(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(89, xla); }
  }

  static final private boolean jj_2_91(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_91(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(90, xla); }
  }

  static final private boolean jj_2_92(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_92(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(91, xla); }
  }

  static final private boolean jj_2_93(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_93(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(92, xla); }
  }

  static final private boolean jj_2_94(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_94(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(93, xla); }
  }

  static final private boolean jj_2_95(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_95(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(94, xla); }
  }

  static final private boolean jj_2_96(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_96(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(95, xla); }
  }

  static final private boolean jj_2_97(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_97(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(96, xla); }
  }

  static final private boolean jj_2_98(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_98(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(97, xla); }
  }

  static final private boolean jj_2_99(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_99(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(98, xla); }
  }

  static final private boolean jj_2_100(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_100(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(99, xla); }
  }

  static final private boolean jj_2_101(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_101(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(100, xla); }
  }

  static final private boolean jj_2_102(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_102(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(101, xla); }
  }

  static final private boolean jj_2_103(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_103(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(102, xla); }
  }

  static final private boolean jj_2_104(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_104(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(103, xla); }
  }

  static final private boolean jj_2_105(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_105(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(104, xla); }
  }

  static final private boolean jj_2_106(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_106(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(105, xla); }
  }

  static final private boolean jj_2_107(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_107(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(106, xla); }
  }

  static final private boolean jj_2_108(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_108(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(107, xla); }
  }

  static final private boolean jj_2_109(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_109(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(108, xla); }
  }

  static final private boolean jj_2_110(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_110(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(109, xla); }
  }

  static final private boolean jj_2_111(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_111(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(110, xla); }
  }

  static final private boolean jj_2_112(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_112(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(111, xla); }
  }

  static final private boolean jj_2_113(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_113(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(112, xla); }
  }

  static final private boolean jj_2_114(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_114(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(113, xla); }
  }

  static final private boolean jj_2_115(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_115(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(114, xla); }
  }

  static final private boolean jj_2_116(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_116(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(115, xla); }
  }

  static final private boolean jj_2_117(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_117(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(116, xla); }
  }

  static final private boolean jj_2_118(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_118(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(117, xla); }
  }

  static final private boolean jj_2_119(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_119(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(118, xla); }
  }

  static final private boolean jj_2_120(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_120(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(119, xla); }
  }

  static final private boolean jj_2_121(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_121(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(120, xla); }
  }

  static final private boolean jj_2_122(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_122(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(121, xla); }
  }

  static final private boolean jj_2_123(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_123(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(122, xla); }
  }

  static final private boolean jj_2_124(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_124(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(123, xla); }
  }

  static final private boolean jj_2_125(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_125(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(124, xla); }
  }

  static final private boolean jj_2_126(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_126(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(125, xla); }
  }

  static final private boolean jj_2_127(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_127(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(126, xla); }
  }

  static final private boolean jj_2_128(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_128(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(127, xla); }
  }

  static final private boolean jj_2_129(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_129(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(128, xla); }
  }

  static final private boolean jj_2_130(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_130(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(129, xla); }
  }

  static final private boolean jj_2_131(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_131(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(130, xla); }
  }

  static final private boolean jj_2_132(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_132(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(131, xla); }
  }

  static final private boolean jj_2_133(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_133(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(132, xla); }
  }

  static final private boolean jj_2_134(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_134(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(133, xla); }
  }

  static final private boolean jj_2_135(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_135(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(134, xla); }
  }

  static final private boolean jj_2_136(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_136(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(135, xla); }
  }

  static final private boolean jj_2_137(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_137(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(136, xla); }
  }

  static final private boolean jj_2_138(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_138(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(137, xla); }
  }

  static final private boolean jj_2_139(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_139(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(138, xla); }
  }

  static final private boolean jj_2_140(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_140(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(139, xla); }
  }

  static final private boolean jj_2_141(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_141(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(140, xla); }
  }

  static final private boolean jj_2_142(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_142(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(141, xla); }
  }

  static final private boolean jj_2_143(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_143(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(142, xla); }
  }

  static final private boolean jj_2_144(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_144(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(143, xla); }
  }

  static final private boolean jj_2_145(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_145(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(144, xla); }
  }

  static final private boolean jj_2_146(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_146(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(145, xla); }
  }

  static final private boolean jj_2_147(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_147(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(146, xla); }
  }

  static final private boolean jj_2_148(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_148(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(147, xla); }
  }

  static final private boolean jj_2_149(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_149(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(148, xla); }
  }

  static final private boolean jj_2_150(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_150(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(149, xla); }
  }

  static final private boolean jj_2_151(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_151(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(150, xla); }
  }

  static final private boolean jj_2_152(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_152(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(151, xla); }
  }

  static final private boolean jj_2_153(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_153(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(152, xla); }
  }

  static final private boolean jj_2_154(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_154(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(153, xla); }
  }

  static final private boolean jj_2_155(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_155(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(154, xla); }
  }

  static final private boolean jj_2_156(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_156(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(155, xla); }
  }

  static final private boolean jj_2_157(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_157(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(156, xla); }
  }

  static final private boolean jj_2_158(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_158(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(157, xla); }
  }

  static final private boolean jj_2_159(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_159(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(158, xla); }
  }

  static final private boolean jj_2_160(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_160(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(159, xla); }
  }

  static final private boolean jj_2_161(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_161(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(160, xla); }
  }

  static final private boolean jj_2_162(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_162(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(161, xla); }
  }

  static final private boolean jj_2_163(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_163(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(162, xla); }
  }

  static final private boolean jj_2_164(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_164(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(163, xla); }
  }

  static final private boolean jj_2_165(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_165(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(164, xla); }
  }

  static final private boolean jj_2_166(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_166(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(165, xla); }
  }

  static final private boolean jj_2_167(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_167(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(166, xla); }
  }

  static final private boolean jj_2_168(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_168(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(167, xla); }
  }

  static final private boolean jj_2_169(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_169(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(168, xla); }
  }

  static final private boolean jj_2_170(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_170(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(169, xla); }
  }

  static final private boolean jj_2_171(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_171(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(170, xla); }
  }

  static final private boolean jj_2_172(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_172(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(171, xla); }
  }

  static final private boolean jj_2_173(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_173(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(172, xla); }
  }

  static final private boolean jj_2_174(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_174(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(173, xla); }
  }

  static final private boolean jj_2_175(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_175(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(174, xla); }
  }

  static final private boolean jj_2_176(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_176(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(175, xla); }
  }

  static final private boolean jj_2_177(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_177(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(176, xla); }
  }

  static final private boolean jj_2_178(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_178(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(177, xla); }
  }

  static final private boolean jj_2_179(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_179(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(178, xla); }
  }

  static final private boolean jj_2_180(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_180(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(179, xla); }
  }

  static final private boolean jj_2_181(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_181(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(180, xla); }
  }

  static final private boolean jj_2_182(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_182(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(181, xla); }
  }

  static final private boolean jj_2_183(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_183(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(182, xla); }
  }

  static final private boolean jj_2_184(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_184(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(183, xla); }
  }

  static final private boolean jj_2_185(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_185(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(184, xla); }
  }

  static final private boolean jj_2_186(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_186(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(185, xla); }
  }

  static final private boolean jj_2_187(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_187(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(186, xla); }
  }

  static final private boolean jj_2_188(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_188(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(187, xla); }
  }

  static final private boolean jj_2_189(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_189(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(188, xla); }
  }

  static final private boolean jj_2_190(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_190(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(189, xla); }
  }

  static final private boolean jj_2_191(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_191(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(190, xla); }
  }

  static final private boolean jj_2_192(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_192(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(191, xla); }
  }

  static final private boolean jj_2_193(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_193(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(192, xla); }
  }

  static final private boolean jj_2_194(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_194(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(193, xla); }
  }

  static final private boolean jj_2_195(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_195(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(194, xla); }
  }

  static final private boolean jj_2_196(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_196(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(195, xla); }
  }

  static final private boolean jj_2_197(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_197(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(196, xla); }
  }

  static final private boolean jj_2_198(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_198(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(197, xla); }
  }

  static final private boolean jj_2_199(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_199(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(198, xla); }
  }

  static final private boolean jj_2_200(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_200(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(199, xla); }
  }

  static final private boolean jj_2_201(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_201(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(200, xla); }
  }

  static final private boolean jj_2_202(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_202(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(201, xla); }
  }

  static final private boolean jj_2_203(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_203(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(202, xla); }
  }

  static final private boolean jj_2_204(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_204(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(203, xla); }
  }

  static final private boolean jj_2_205(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_205(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(204, xla); }
  }

  static final private boolean jj_2_206(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_206(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(205, xla); }
  }

  static final private boolean jj_2_207(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_207(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(206, xla); }
  }

  static final private boolean jj_2_208(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_208(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(207, xla); }
  }

  static final private boolean jj_2_209(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_209(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(208, xla); }
  }

  static final private boolean jj_2_210(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_210(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(209, xla); }
  }

  static final private boolean jj_2_211(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_211(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(210, xla); }
  }

  static final private boolean jj_2_212(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_212(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(211, xla); }
  }

  static final private boolean jj_2_213(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_213(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(212, xla); }
  }

  static final private boolean jj_2_214(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_214(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(213, xla); }
  }

  static final private boolean jj_2_215(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_215(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(214, xla); }
  }

  static final private boolean jj_2_216(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_216(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(215, xla); }
  }

  static final private boolean jj_2_217(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_217(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(216, xla); }
  }

  static final private boolean jj_2_218(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_218(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(217, xla); }
  }

  static final private boolean jj_2_219(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_219(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(218, xla); }
  }

  static final private boolean jj_2_220(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_220(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(219, xla); }
  }

  static final private boolean jj_2_221(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_221(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(220, xla); }
  }

  static final private boolean jj_2_222(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_222(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(221, xla); }
  }

  static final private boolean jj_2_223(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_223(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(222, xla); }
  }

  static final private boolean jj_2_224(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_224(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(223, xla); }
  }

  static final private boolean jj_3R_170() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_252()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_253()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3_204() {
    if (jj_scan_token(BLOCK)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_486() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_485() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_484() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_483() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_482() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_169() {
    if (jj_scan_token(BLOCK)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_481() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_480() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_438() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_480()) {
    jj_scanpos = xsp;
    if (jj_3R_481()) {
    jj_scanpos = xsp;
    if (jj_3R_482()) {
    jj_scanpos = xsp;
    if (jj_3R_483()) {
    jj_scanpos = xsp;
    if (jj_3R_484()) {
    jj_scanpos = xsp;
    if (jj_3R_485()) {
    jj_scanpos = xsp;
    if (jj_3R_486()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_111() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_169()) {
    jj_scanpos = xsp;
    if (jj_3R_170()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_397() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_438()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_439()) return true;
    return false;
  }

  static final private boolean jj_3R_426() {
    if (jj_3R_114()) return true;
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  static final private boolean jj_3R_371() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_426()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_426()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_254() {
    if (jj_3R_71()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_45() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_526() {
    if (jj_3R_105()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_270() {
    if (jj_scan_token(STM_LIST)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_461() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_526()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_526()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_464() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_105()) return true;
    return false;
  }

  static final private boolean jj_3_202() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3_44() {
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_192() {
    if (jj_3R_272()) return true;
    return false;
  }

  static final private boolean jj_3_201() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_430() {
    if (jj_3R_105()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_464()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_339() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_191() {
    if (jj_3R_271()) return true;
    return false;
  }

  static final private boolean jj_3R_463() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_43() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_190() {
    if (jj_3R_270()) return true;
    return false;
  }

  static final private boolean jj_3R_189() {
    if (jj_3R_269()) return true;
    return false;
  }

  static final private boolean jj_3R_338() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_42() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_188() {
    if (jj_3R_268()) return true;
    return false;
  }

  static final private boolean jj_3R_462() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_187() {
    if (jj_3R_267()) return true;
    return false;
  }

  static final private boolean jj_3R_337() {
    if (jj_3R_402()) return true;
    return false;
  }

  static final private boolean jj_3R_186() {
    if (jj_3R_266()) return true;
    return false;
  }

  static final private boolean jj_3_41() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_185() {
    if (jj_3R_265()) return true;
    return false;
  }

  static final private boolean jj_3R_429() {
    if (jj_scan_token(NAME_LIST)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_462()) {
    jj_scanpos = xsp;
    if (jj_3R_463()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_184() {
    if (jj_3R_264()) return true;
    return false;
  }

  static final private boolean jj_3R_336() {
    if (jj_3R_401()) return true;
    return false;
  }

  static final private boolean jj_3_93() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_183() {
    if (jj_3R_263()) return true;
    return false;
  }

  static final private boolean jj_3_200() {
    if (jj_scan_token(IF)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_40() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_182() {
    if (jj_3R_262()) return true;
    return false;
  }

  static final private boolean jj_3_199() {
    if (jj_scan_token(SWITCH)) return true;
    return false;
  }

  static final private boolean jj_3R_181() {
    if (jj_3R_261()) return true;
    return false;
  }

  static final private boolean jj_3R_335() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3R_180() {
    if (jj_3R_260()) return true;
    return false;
  }

  static final private boolean jj_3_39() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_179() {
    if (jj_3R_259()) return true;
    return false;
  }

  static final private boolean jj_3R_428() {
    if (jj_3R_461()) return true;
    return false;
  }

  static final private boolean jj_3_198() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_178() {
    if (jj_3R_258()) return true;
    return false;
  }

  static final private boolean jj_3R_334() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3_38() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_177() {
    if (jj_3R_257()) return true;
    return false;
  }

  static final private boolean jj_3R_375() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_428()) {
    jj_scanpos = xsp;
    if (jj_3R_429()) {
    jj_scanpos = xsp;
    if (jj_3R_430()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_197() {
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_333() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_196() {
    if (jj_3R_71()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  static final private boolean jj_3R_176() {
    if (jj_3R_256()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_37() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_175() {
    if (jj_3R_255()) return true;
    return false;
  }

  static final private boolean jj_3R_332() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3R_174() {
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3_36() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_173() {
    if (jj_3R_254()) return true;
    return false;
  }

  static final private boolean jj_3R_113() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_173()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) {
    jj_scanpos = xsp;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) {
    jj_scanpos = xsp;
    if (jj_3R_187()) {
    jj_scanpos = xsp;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) {
    jj_scanpos = xsp;
    if (jj_3R_192()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_331() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3_35() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_330() {
    if (jj_3R_398()) return true;
    return false;
  }

  static final private boolean jj_3R_128() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_34() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_81()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3R_210() {
    if (jj_scan_token(ID)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_329() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3_92() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(EXECDECSEPARATOR)) return true;
    return false;
  }

  static final private boolean jj_3R_80() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_191() {
    if (jj_3R_110()) return true;
    return false;
  }

  static final private boolean jj_3_33() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_80()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_604() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_597() {
    Token xsp;
    if (jj_3R_604()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_604()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_89()) return true;
    return false;
  }

  static final private boolean jj_3R_127() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) return true;
    }
    return false;
  }

  static final private boolean jj_3_194() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_328() {
    if (jj_3R_397()) return true;
    return false;
  }

  static final private boolean jj_3_193() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3_91() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_126() {
    if (jj_3R_209()) return true;
    return false;
  }

  static final private boolean jj_3_195() {
    Token xsp;
    if (jj_3_193()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_193()) { jj_scanpos = xsp; break; }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_194()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_598() {
    if (jj_3R_110()) return true;
    return false;
  }

  static final private boolean jj_3R_588() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_195()) {
    jj_scanpos = xsp;
    if (jj_3R_597()) return true;
    }
    return false;
  }

  static final private boolean jj_3_32() {
    if (jj_scan_token(INITIALIZER_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_327() {
    if (jj_3R_396()) return true;
    return false;
  }

  static final private boolean jj_3R_125() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_31() {
    if (jj_scan_token(INTERFACE_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_326() {
    if (jj_3R_395()) return true;
    return false;
  }

  static final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_30() {
    if (jj_scan_token(CLASS_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_325() {
    if (jj_3R_394()) return true;
    return false;
  }

  static final private boolean jj_3R_590() {
    if (jj_3R_94()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_598()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_29() {
    if (jj_scan_token(INTERFACE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_589() {
    if (jj_3R_588()) return true;
    return false;
  }

  static final private boolean jj_3R_324() {
    if (jj_3R_393()) return true;
    return false;
  }

  static final private boolean jj_3R_285() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_28() {
    if (jj_scan_token(CLASS_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_166() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_105()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_589()) {
    jj_scanpos = xsp;
    if (jj_3R_590()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_323() {
    if (jj_3R_392()) return true;
    return false;
  }

  static final private boolean jj_3_192() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_95()) return true;
    if (jj_3R_588()) return true;
    return false;
  }

  static final private boolean jj_3_27() {
    if (jj_scan_token(INITIALIZER)) return true;
    return false;
  }

  static final private boolean jj_3R_284() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_108() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_192()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_322() {
    if (jj_3R_391()) return true;
    return false;
  }

  static final private boolean jj_3_26() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3R_209() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(EXECDECSEPARATOR)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_284()) {
    jj_scanpos = xsp;
    if (jj_3R_285()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_321() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3R_378() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_251() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_320()) {
    jj_scanpos = xsp;
    if (jj_3R_321()) {
    jj_scanpos = xsp;
    if (jj_3R_322()) {
    jj_scanpos = xsp;
    if (jj_3R_323()) {
    jj_scanpos = xsp;
    if (jj_3R_324()) {
    jj_scanpos = xsp;
    if (jj_3R_325()) {
    jj_scanpos = xsp;
    if (jj_3R_326()) {
    jj_scanpos = xsp;
    if (jj_3R_327()) {
    jj_scanpos = xsp;
    if (jj_3R_328()) {
    jj_scanpos = xsp;
    if (jj_3R_329()) {
    jj_scanpos = xsp;
    if (jj_3R_330()) {
    jj_scanpos = xsp;
    if (jj_3R_331()) {
    jj_scanpos = xsp;
    if (jj_3R_332()) {
    jj_scanpos = xsp;
    if (jj_3R_333()) {
    jj_scanpos = xsp;
    if (jj_3R_334()) {
    jj_scanpos = xsp;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) {
    jj_scanpos = xsp;
    if (jj_3R_338()) {
    jj_scanpos = xsp;
    if (jj_3R_339()) {
    jj_scanpos = xsp;
    if (jj_scan_token(136)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_320() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3R_311() {
    if (jj_3R_87()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_378()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_232() {
    if (jj_3R_311()) return true;
    return false;
  }

  static final private boolean jj_3R_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_232()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_477() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_476() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_475() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3_88() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_474() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_473() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_472() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_471() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_436() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_471()) {
    jj_scanpos = xsp;
    if (jj_3R_472()) {
    jj_scanpos = xsp;
    if (jj_3R_473()) {
    jj_scanpos = xsp;
    if (jj_3R_474()) {
    jj_scanpos = xsp;
    if (jj_3R_475()) {
    jj_scanpos = xsp;
    if (jj_3R_476()) {
    jj_scanpos = xsp;
    if (jj_3R_477()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_396() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_436()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_437()) return true;
    return false;
  }

  static final private boolean jj_3_190() {
    if (jj_scan_token(EXPRESSION_LIST)) return true;
    return false;
  }

  static final private boolean jj_3R_250() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_231() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(102)) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_230() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_160() {
    if (jj_3R_71()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_250()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_144() {
    if (jj_scan_token(EXPRESSION_LIST)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_249() {
    if (jj_scan_token(NAME)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_168() {
    if (jj_3R_251()) return true;
    return false;
  }

  static final private boolean jj_3R_94() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_144()) {
    jj_scanpos = xsp;
    if (jj_3R_145()) return true;
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_159() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_249()) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) return true;
    }
    return false;
  }

  static final private boolean jj_3_89() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_110() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_168()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_158() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_105() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_158()) {
    jj_scanpos = xsp;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_283() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  static final private boolean jj_3R_282() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(59)) {
    jj_scanpos = xsp;
    if (jj_scan_token(29)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_165() {
    if (jj_3R_101()) return true;
    return false;
  }

  static final private boolean jj_3R_539() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_3R_375()) return true;
    return false;
  }

  static final private boolean jj_3_24() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_164() {
    if (jj_scan_token(VOID)) return true;
    return false;
  }

  static final private boolean jj_3R_107() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_538() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_537() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_208() {
    if (jj_3R_283()) return true;
    return false;
  }

  static final private boolean jj_3R_207() {
    if (jj_3R_282()) return true;
    return false;
  }

  static final private boolean jj_3_23() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_206() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_205() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_204() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3R_78() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(IMPLEMENTS)) return true;
    return false;
  }

  static final private boolean jj_3_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_536() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_535() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_105()) return true;
    return false;
  }

  static final private boolean jj_3R_203() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  static final private boolean jj_3_21() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_479() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_536()) {
    jj_scanpos = xsp;
    if (jj_3R_537()) {
    jj_scanpos = xsp;
    if (jj_3R_538()) {
    jj_scanpos = xsp;
    if (jj_3R_539()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(15)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(50)) {
    jj_scanpos = xsp;
    if (jj_scan_token(39)) {
    jj_scanpos = xsp;
    if (jj_scan_token(41)) {
    jj_scanpos = xsp;
    if (jj_scan_token(32)) {
    jj_scanpos = xsp;
    if (jj_scan_token(26)) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_124() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_203()) {
    jj_scanpos = xsp;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) {
    jj_scanpos = xsp;
    if (jj_3R_208()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_533() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_534() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_20() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_123() {
    if (jj_scan_token(LITERAL)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3_85() {
    if (jj_3R_95()) return true;
    return false;
  }

  static final private boolean jj_3R_70() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_151() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_238() {
    if (jj_3R_105()) return true;
    return false;
  }

  static final private boolean jj_3_189() {
    if (jj_scan_token(LBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_532() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_77() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    return false;
  }

  static final private boolean jj_3_22() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_scan_token(28)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_237() {
    if (jj_3R_95()) return true;
    return false;
  }

  static final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_237()) {
    jj_scanpos = xsp;
    if (jj_3R_238()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_167() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_478() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_532()) {
    jj_scanpos = xsp;
    if (jj_3R_533()) {
    jj_scanpos = xsp;
    if (jj_3R_534()) {
    jj_scanpos = xsp;
    if (jj_3R_535()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_87() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(109)) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_236() {
    if (jj_scan_token(TYPE)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_437() {
    if (jj_scan_token(CLASS)) return true;
    if (jj_3R_71()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_478()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_479()) jj_scanpos = xsp;
    if (jj_3R_110()) return true;
    return false;
  }

  static final private boolean jj_3R_109() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_167()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_86() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_149() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_236()) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_148() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_101() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_148()) {
    jj_scanpos = xsp;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) return true;
    }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_151()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_188() {
    if (jj_3R_109()) return true;
    return false;
  }

  static final private boolean jj_3R_163() {
    if (jj_3R_94()) return true;
    return false;
  }

  static final private boolean jj_3R_162() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_161() {
    if (jj_3R_109()) return true;
    return false;
  }

  static final private boolean jj_3_19() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3_187() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_108()) return true;
    return false;
  }

  static final private boolean jj_3_186() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(SUPER)) return true;
    return false;
  }

  static final private boolean jj_3_185() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  static final private boolean jj_3R_394() {
    if (jj_scan_token(INTERFACE_DECLARATION_SET)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_106() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_185()) {
    jj_scanpos = xsp;
    if (jj_3_186()) {
    jj_scanpos = xsp;
    if (jj_3_187()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_130() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_75() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_130()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_129() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_184() {
    if (jj_3R_107()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_229() {
    if (jj_3R_105()) return true;
    return false;
  }

  static final private boolean jj_3R_73() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_129()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_183() {
    if (jj_scan_token(NEW)) return true;
    return false;
  }

  static final private boolean jj_3R_393() {
    if (jj_scan_token(CLASS_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_228() {
    if (jj_3R_107()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_74() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_227() {
    if (jj_3R_108()) return true;
    return false;
  }

  static final private boolean jj_3_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) return true;
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3_182() {
    if (jj_3R_70()) return true;
    return false;
  }

  static final private boolean jj_3R_72() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_392() {
    if (jj_scan_token(INTERFACE_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_226() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_17() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) return true;
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_225() {
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_224() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  static final private boolean jj_3R_223() {
    if (jj_3R_70()) return true;
    return false;
  }

  static final private boolean jj_3R_143() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_223()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) {
    jj_scanpos = xsp;
    if (jj_3R_225()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) {
    jj_scanpos = xsp;
    if (jj_3R_227()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) {
    jj_scanpos = xsp;
    if (jj_3R_229()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_391() {
    if (jj_scan_token(CLASS_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_395() {
    if (jj_scan_token(INITIALIZER_SET)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_100() {
    if (jj_scan_token(INITIALIZER)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_69() {
    if (jj_scan_token(IMPORT_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_133() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_79() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_133()) jj_scanpos = xsp;
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3_84() {
    if (jj_scan_token(THIS)) return true;
    if (jj_3R_94()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_83() {
    if (jj_3R_93()) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  static final private boolean jj_3_181() {
    if (jj_3R_106()) return true;
    return false;
  }

  static final private boolean jj_3R_172() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_83()) jj_scanpos = xsp;
    if (jj_scan_token(SUPER)) return true;
    if (jj_3R_94()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_171() {
    if (jj_scan_token(THIS)) return true;
    if (jj_3R_94()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_93() {
    if (jj_3R_143()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_181()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_112() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_171()) {
    jj_scanpos = xsp;
    if (jj_3R_172()) return true;
    }
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3_180() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    return false;
  }

  static final private boolean jj_3R_367() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  static final private boolean jj_3R_281() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_366()) {
    jj_scanpos = xsp;
    if (jj_3R_367()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_366() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3_224() {
    if (jj_3R_96()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3_223() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_530() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_101()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_390()) return true;
    return false;
  }

  static final private boolean jj_3R_568() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  static final private boolean jj_3R_567() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  static final private boolean jj_3R_531() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_567()) {
    jj_scanpos = xsp;
    if (jj_3R_568()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_529() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_101()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_242()) return true;
    return false;
  }

  static final private boolean jj_3_222() {
    if (jj_3R_114()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_469() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_529()) {
    jj_scanpos = xsp;
    if (jj_3R_530()) return true;
    }
    return false;
  }

  static final private boolean jj_3_221() {
    if (jj_3R_113()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3_220() {
    if (jj_3R_87()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3_219() {
    if (jj_3R_101()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_202() {
    if (jj_scan_token(IMPORT)) return true;
    if (jj_3R_105()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_281()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_293() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_375()) return true;
    return false;
  }

  static final private boolean jj_3_80() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_201() {
    if (jj_scan_token(IMPORT_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_122() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_201()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_292() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_218() {
    if (jj_3R_96()) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3R_470() {
    if (jj_3R_93()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_531()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_291() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3_217() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3_79() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_216() {
    if (jj_3R_114()) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3R_92() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    return false;
  }

  static final private boolean jj_3_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) return true;
    }
    return false;
  }

  static final private boolean jj_3_215() {
    if (jj_3R_113()) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3_214() {
    if (jj_3R_87()) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3R_248() {
    if (jj_3R_70()) return true;
    return false;
  }

  static final private boolean jj_3_213() {
    if (jj_3R_101()) return true;
    if (jj_scan_token(179)) return true;
    return false;
  }

  static final private boolean jj_3R_290() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_214() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_290()) {
    jj_scanpos = xsp;
    if (jj_3R_291()) {
    jj_scanpos = xsp;
    if (jj_3R_292()) {
    jj_scanpos = xsp;
    if (jj_3R_293()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_177() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3_176() {
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_200() {
    if (jj_scan_token(PACKAGE)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_280() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_247() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_scan_token(LEXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3_78() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_370() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3_179() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(LBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_369() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_286() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_368()) {
    jj_scanpos = xsp;
    if (jj_3R_369()) {
    jj_scanpos = xsp;
    if (jj_3R_370()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_368() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_246() {
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3_178() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    return false;
  }

  static final private boolean jj_3R_212() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_286()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_157() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_101()) return true;
    if (jj_scan_token(RPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_246()) {
    jj_scanpos = xsp;
    if (jj_3R_247()) {
    jj_scanpos = xsp;
    if (jj_scan_token(144)) {
    jj_scanpos = xsp;
    if (jj_scan_token(143)) {
    jj_scanpos = xsp;
    if (jj_scan_token(127)) {
    jj_scanpos = xsp;
    if (jj_scan_token(55)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(43)) {
    jj_scanpos = xsp;
    if (jj_3R_248()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_279() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_211() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_156() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_199() {
    if (jj_scan_token(PACKAGE_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_279()) {
    jj_scanpos = xsp;
    if (jj_3R_280()) return true;
    }
    return false;
  }

  static final private boolean jj_3_82() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_155() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_95()) return true;
    return false;
  }

  static final private boolean jj_3R_135() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) return true;
    }
    if (jj_3R_71()) return true;
    if (jj_3R_213()) return true;
    xsp = jj_scanpos;
    if (jj_3R_214()) jj_scanpos = xsp;
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_121() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_199()) {
    jj_scanpos = xsp;
    if (jj_3R_200()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_134() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_82() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_134()) {
    jj_scanpos = xsp;
    if (jj_3R_135()) return true;
    }
    return false;
  }

  static final private boolean jj_3_175() {
    if (jj_3R_104()) return true;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(180)) return true;
    if (jj_3R_70()) return true;
    if (jj_scan_token(181)) return true;
    return false;
  }

  static final private boolean jj_3R_435() {
    if (jj_3R_470()) return true;
    return false;
  }

  static final private boolean jj_3R_468() {
    if (jj_scan_token(BANG)) return true;
    return false;
  }

  static final private boolean jj_3R_434() {
    if (jj_3R_469()) return true;
    return false;
  }

  static final private boolean jj_3R_467() {
    if (jj_scan_token(TILDE)) return true;
    return false;
  }

  static final private boolean jj_3_76() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_433() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_467()) {
    jj_scanpos = xsp;
    if (jj_3R_468()) return true;
    }
    if (jj_3R_242()) return true;
    return false;
  }

  static final private boolean jj_3R_390() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_433()) {
    jj_scanpos = xsp;
    if (jj_3R_434()) {
    jj_scanpos = xsp;
    if (jj_3R_435()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_77() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_389() {
    if (jj_scan_token(DECR)) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  static final private boolean jj_3R_388() {
    if (jj_scan_token(INCR)) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  static final private boolean jj_3R_67() {
    if (jj_3R_121()) return true;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(IMPORT_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_398() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION_SET)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_3R_69()) return true;
    return false;
  }

  static final private boolean jj_3R_319() {
    if (jj_scan_token(REM)) return true;
    return false;
  }

  static final private boolean jj_3R_318() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  static final private boolean jj_3R_317() {
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  static final private boolean jj_3R_243() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_317()) {
    jj_scanpos = xsp;
    if (jj_3R_318()) {
    jj_scanpos = xsp;
    if (jj_3R_319()) return true;
    }
    }
    if (jj_3R_242()) return true;
    return false;
  }

  static final private boolean jj_3R_316() {
    if (jj_3R_390()) return true;
    return false;
  }

  static final private boolean jj_3R_99() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_245() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  static final private boolean jj_3R_315() {
    if (jj_3R_389()) return true;
    return false;
  }

  static final private boolean jj_3R_244() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  static final private boolean jj_3R_314() {
    if (jj_3R_388()) return true;
    return false;
  }

  static final private boolean jj_3R_387() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  static final private boolean jj_3R_154() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_244()) {
    jj_scanpos = xsp;
    if (jj_3R_245()) return true;
    }
    if (jj_3R_153()) return true;
    return false;
  }

  static final private boolean jj_3R_386() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  static final private boolean jj_3R_68() {
    if (jj_3R_122()) return true;
    return false;
  }

  static final private boolean jj_3_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_scan_token(93)) {
    jj_scanpos = xsp;
    if (jj_scan_token(94)) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_313() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_386()) {
    jj_scanpos = xsp;
    if (jj_3R_387()) return true;
    }
    if (jj_3R_242()) return true;
    return false;
  }

  static final private boolean jj_3R_242() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_313()) {
    jj_scanpos = xsp;
    if (jj_3R_314()) {
    jj_scanpos = xsp;
    if (jj_3R_315()) {
    jj_scanpos = xsp;
    if (jj_3R_316()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_174() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(163)) {
    jj_scanpos = xsp;
    if (jj_scan_token(164)) {
    jj_scanpos = xsp;
    if (jj_scan_token(165)) return true;
    }
    }
    if (jj_3R_103()) return true;
    return false;
  }

  static final private boolean jj_3R_271() {
    if (jj_scan_token(CONTEXT_DEC)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_241() {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_153() {
    if (jj_3R_242()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_243()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_240() {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_66() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_3R_121()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3_10() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_361() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_91() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3_75() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_152() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) {
    jj_scanpos = xsp;
    if (jj_3R_241()) return true;
    }
    }
    if (jj_3R_103()) return true;
    return false;
  }

  static final private boolean jj_3R_360() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_359() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_275() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_360()) {
    jj_scanpos = xsp;
    if (jj_3R_361()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_103() {
    if (jj_3R_153()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_154()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_194() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_275()) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_276()) return true;
    return false;
  }

  static final private boolean jj_3R_239() {
    if (jj_scan_token(LSHIFT)) return true;
    return false;
  }

  static final private boolean jj_3R_274() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_273() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_193() {
    if (jj_scan_token(PARAMETER)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_273()) {
    jj_scanpos = xsp;
    if (jj_3R_274()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_102() {
    if (jj_3R_103()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_152()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_114() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_608() {
    if (jj_scan_token(GE)) return true;
    return false;
  }

  static final private boolean jj_3R_272() {
    if (jj_scan_token(ASSERT)) return true;
    if (jj_3R_87()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_359()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_607() {
    if (jj_scan_token(LE)) return true;
    return false;
  }

  static final private boolean jj_3R_606() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  static final private boolean jj_3_173() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(142)) {
    jj_scanpos = xsp;
    if (jj_scan_token(141)) {
    jj_scanpos = xsp;
    if (jj_scan_token(148)) {
    jj_scanpos = xsp;
    if (jj_scan_token(149)) return true;
    }
    }
    }
    if (jj_3R_102()) return true;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_scan_token(EXPLORE)) return true;
    return false;
  }

  static final private boolean jj_3R_605() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  static final private boolean jj_3R_599() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_605()) {
    jj_scanpos = xsp;
    if (jj_3R_606()) {
    jj_scanpos = xsp;
    if (jj_3R_607()) {
    jj_scanpos = xsp;
    if (jj_3R_608()) return true;
    }
    }
    }
    if (jj_3R_102()) return true;
    return false;
  }

  static final private boolean jj_3R_592() {
    if (jj_scan_token(INSTANCEOF)) return true;
    if (jj_3R_101()) return true;
    return false;
  }

  static final private boolean jj_3R_427() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_114()) return true;
    return false;
  }

  static final private boolean jj_3R_591() {
    if (jj_3R_102()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_599()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_374() {
    if (jj_3R_114()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_427()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_289() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_374()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_593() {
    if (jj_scan_token(EQ)) return true;
    return false;
  }

  static final private boolean jj_3R_373() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_566() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_593()) {
    jj_scanpos = xsp;
    if (jj_3R_594()) return true;
    }
    if (jj_3R_565()) return true;
    return false;
  }

  static final private boolean jj_3R_354() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_594() {
    if (jj_scan_token(NE)) return true;
    return false;
  }

  static final private boolean jj_3R_372() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3_74() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_288() {
    if (jj_scan_token(PARAMETER_LIST)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_372()) {
    jj_scanpos = xsp;
    if (jj_3R_373()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_565() {
    if (jj_3R_591()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_592()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_528() {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_3R_527()) return true;
    return false;
  }

  static final private boolean jj_3R_63() {
    if (jj_scan_token(TRANSFORMATION)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_287() {
    if (jj_3R_371()) return true;
    return false;
  }

  static final private boolean jj_3R_213() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) {
    jj_scanpos = xsp;
    if (jj_3R_289()) return true;
    }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_353() {
    if (jj_scan_token(CATCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_114()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_527() {
    if (jj_3R_565()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_566()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_466() {
    if (jj_scan_token(XOR)) return true;
    if (jj_3R_465()) return true;
    return false;
  }

  static final private boolean jj_3R_432() {
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_431()) return true;
    return false;
  }

  static final private boolean jj_3R_465() {
    if (jj_3R_527()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_528()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_524() {
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_267() {
    if (jj_scan_token(TRY)) return true;
    if (jj_3R_111()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_353()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_354()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_564() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_375()) return true;
    return false;
  }

  static final private boolean jj_3_8() {
    if (jj_scan_token(LOAD)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_71() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_64() {
    if (jj_scan_token(CODE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_377() {
    if (jj_scan_token(SC_AND)) return true;
    if (jj_3R_376()) return true;
    return false;
  }

  static final private boolean jj_3R_431() {
    if (jj_3R_465()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_466()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_563() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_562() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3_70() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_7() {
    if (jj_scan_token(RESULT_TYPE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_296() {
    if (jj_scan_token(SC_OR)) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  static final private boolean jj_3R_90() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    return false;
  }

  static final private boolean jj_3_72() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) return true;
    }
    return false;
  }

  static final private boolean jj_3_69() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_120() {
    if (jj_scan_token(NAME)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_scan_token(MODIFIER_LIST)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_376() {
    if (jj_3R_431()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_432()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_561() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(THROWS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_119() {
    if (jj_scan_token(RESULT_TYPE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3_5() {
    if (jj_scan_token(STM_LIST)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_266() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_111()) return true;
    return false;
  }

  static final private boolean jj_3R_523() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_561()) {
    jj_scanpos = xsp;
    if (jj_3R_562()) {
    jj_scanpos = xsp;
    if (jj_3R_563()) {
    jj_scanpos = xsp;
    if (jj_3R_564()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_522() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_118() {
    if (jj_scan_token(MODIFIER_LIST)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_117() {
    if (jj_scan_token(STM_LIST)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    return false;
  }

  static final private boolean jj_3R_295() {
    if (jj_3R_376()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_377()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_218() {
    if (jj_scan_token(HOOK)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_138()) return true;
    return false;
  }

  static final private boolean jj_3R_65() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_265() {
    if (jj_scan_token(THROW)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_217() {
    if (jj_3R_295()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_296()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_587() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  static final private boolean jj_3R_586() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    return false;
  }

  static final private boolean jj_3_68() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_585() {
    if (jj_scan_token(NATIVE)) return true;
    return false;
  }

  static final private boolean jj_3R_584() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_583() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  static final private boolean jj_3R_582() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_581() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_580() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_579() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_560() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_579()) {
    jj_scanpos = xsp;
    if (jj_3R_580()) {
    jj_scanpos = xsp;
    if (jj_3R_581()) {
    jj_scanpos = xsp;
    if (jj_3R_582()) {
    jj_scanpos = xsp;
    if (jj_3R_583()) {
    jj_scanpos = xsp;
    if (jj_3R_584()) {
    jj_scanpos = xsp;
    if (jj_3R_585()) {
    jj_scanpos = xsp;
    if (jj_3R_586()) {
    jj_scanpos = xsp;
    if (jj_3R_587()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_521() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_560()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_198() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(177)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_520() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_414() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_445() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_520()) {
    jj_scanpos = xsp;
    if (jj_3R_521()) return true;
    }
    if (jj_3R_107()) return true;
    if (jj_3R_71()) return true;
    if (jj_3R_213()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_522()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_523()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_524()) {
    jj_scanpos = xsp;
    if (jj_scan_token(136)) return true;
    }
    return false;
  }

  static final private boolean jj_3_73() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_138() {
    if (jj_3R_217()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_218()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_116() {
    if (jj_3R_198()) return true;
    return false;
  }

  static final private boolean jj_3_4() {
    if (jj_3R_65()) return true;
    return false;
  }

  static final private boolean jj_3_212() {
    if (jj_scan_token(RETURN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_352() {
    if (jj_scan_token(RETURN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_414()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_444() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_3R_64()) return true;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_63()) return true;
    return false;
  }

  static final private boolean jj_3R_403() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_444()) {
    jj_scanpos = xsp;
    if (jj_3R_445()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_62() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_308() {
    if (jj_scan_token(ORASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_307() {
    if (jj_scan_token(XORASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_351() {
    if (jj_scan_token(RETURN)) return true;
    if (jj_3R_105()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_306() {
    if (jj_scan_token(ANDASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_264() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_351()) {
    jj_scanpos = xsp;
    if (jj_3R_352()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_305() {
    if (jj_scan_token(RUNSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_304() {
    if (jj_scan_token(RSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_350() {
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_303() {
    if (jj_scan_token(LSHIFTASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_302() {
    if (jj_scan_token(MINUSASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_301() {
    if (jj_scan_token(PLUSASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_300() {
    if (jj_scan_token(REMASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_299() {
    if (jj_scan_token(SLASHASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_298() {
    if (jj_scan_token(STARASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3_66() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_297() {
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  static final private boolean jj_3R_219() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_297()) {
    jj_scanpos = xsp;
    if (jj_3R_298()) {
    jj_scanpos = xsp;
    if (jj_3R_299()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) {
    jj_scanpos = xsp;
    if (jj_3R_301()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) {
    jj_scanpos = xsp;
    if (jj_3R_304()) {
    jj_scanpos = xsp;
    if (jj_3R_305()) {
    jj_scanpos = xsp;
    if (jj_3R_306()) {
    jj_scanpos = xsp;
    if (jj_3R_307()) {
    jj_scanpos = xsp;
    if (jj_3R_308()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_263() {
    if (jj_scan_token(CONTINUE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_350()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_3R_62()) return true;
    return false;
  }

  static final private boolean jj_3R_294() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(42)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_216() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_294()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_67() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_215() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_139() {
    if (jj_3R_219()) return true;
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_137() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_215()) {
    jj_scanpos = xsp;
    if (jj_3R_216()) return true;
    }
    if (jj_3R_107()) return true;
    if (jj_3R_71()) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3R_349() {
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_136() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_87() {
    if (jj_3R_138()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_139()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_262() {
    if (jj_scan_token(BREAK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_349()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_399() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_357() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_413() {
    if (jj_3R_455()) return true;
    return false;
  }

  static final private boolean jj_3_172() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_98() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_425() {
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_171() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_525() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_256()) return true;
    return false;
  }

  static final private boolean jj_3R_424() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_170() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3_169() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_455() {
    if (jj_3R_256()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_525()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_423() {
    if (jj_3R_268()) return true;
    return false;
  }

  static final private boolean jj_3_65() {
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  static final private boolean jj_3R_422() {
    if (jj_3R_269()) return true;
    return false;
  }

  static final private boolean jj_3R_421() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_211() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_142() {
    if (jj_3R_221()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_222()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_358() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_421()) {
    jj_scanpos = xsp;
    if (jj_3R_422()) {
    jj_scanpos = xsp;
    if (jj_3R_423()) {
    jj_scanpos = xsp;
    if (jj_3R_424()) {
    jj_scanpos = xsp;
    if (jj_3R_425()) return true;
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_222() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_221()) return true;
    return false;
  }

  static final private boolean jj_3R_89() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_142()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(137)) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_454() {
    if (jj_3R_455()) return true;
    return false;
  }

  static final private boolean jj_3_64() {
    if (jj_3R_89()) return true;
    return false;
  }

  static final private boolean jj_3R_453() {
    if (jj_3R_115()) return true;
    return false;
  }

  static final private boolean jj_3R_310() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_269() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_3R_357()) return true;
    }
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_358()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_358()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_412() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_453()) {
    jj_scanpos = xsp;
    if (jj_3R_454()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_309() {
    if (jj_3R_89()) return true;
    return false;
  }

  static final private boolean jj_3R_362() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  static final private boolean jj_3R_221() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_309()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_348() {
    if (jj_3R_413()) return true;
    return false;
  }

  static final private boolean jj_3R_347() {
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_346() {
    if (jj_3R_412()) return true;
    return false;
  }

  static final private boolean jj_3R_600() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_276() {
    if (jj_3R_71()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_362()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_261() {
    if (jj_scan_token(FOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_346()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_347()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_348()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_168() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_617() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_167() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3_166() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3_165() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3R_616() {
    if (jj_3R_596()) return true;
    return false;
  }

  static final private boolean jj_3R_365() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_221()) return true;
    return false;
  }

  static final private boolean jj_3_164() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_615() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_163() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_614() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_162() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_613() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_63() {
    if (jj_scan_token(LEXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_278() {
    if (jj_3R_276()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_365()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_161() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_612() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_611() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_610() {
    if (jj_3R_595()) return true;
    return false;
  }

  static final private boolean jj_3R_609() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_364() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_601() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_609()) {
    jj_scanpos = xsp;
    if (jj_3R_610()) {
    jj_scanpos = xsp;
    if (jj_3R_611()) {
    jj_scanpos = xsp;
    if (jj_3R_612()) {
    jj_scanpos = xsp;
    if (jj_3R_613()) {
    jj_scanpos = xsp;
    if (jj_3R_614()) {
    jj_scanpos = xsp;
    if (jj_3R_615()) {
    jj_scanpos = xsp;
    if (jj_3R_616()) {
    jj_scanpos = xsp;
    if (jj_3R_617()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_260() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_113()) return true;
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_363() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3R_277() {
    if (jj_scan_token(VARIABLE_DECLARATOR)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_363()) {
    jj_scanpos = xsp;
    if (jj_3R_364()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_196() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_595() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_3R_600()) return true;
    }
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_601()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_601()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_400() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_160() {
    if (jj_scan_token(INITIALIZER_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_503() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_159() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3R_259() {
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_158() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3R_440() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_157() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_502() {
    if (jj_3R_395()) return true;
    return false;
  }

  static final private boolean jj_3_156() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_501() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3_155() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_500() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3_154() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_499() {
    if (jj_3R_398()) return true;
    return false;
  }

  static final private boolean jj_3R_97() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_153() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_498() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3_152() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_497() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3_151() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_496() {
    if (jj_3R_402()) return true;
    return false;
  }

  static final private boolean jj_3_150() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_495() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_149() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_494() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_148() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_493() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_147() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_492() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_491() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_235() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_196()) return true;
    return false;
  }

  static final private boolean jj_3R_345() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3R_490() {
    if (jj_3R_401()) return true;
    return false;
  }

  static final private boolean jj_3R_489() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_385() {
    if (jj_scan_token(VOLATILE)) return true;
    return false;
  }

  static final private boolean jj_3R_441() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_489()) {
    jj_scanpos = xsp;
    if (jj_3R_490()) {
    jj_scanpos = xsp;
    if (jj_3R_491()) {
    jj_scanpos = xsp;
    if (jj_3R_492()) {
    jj_scanpos = xsp;
    if (jj_3R_493()) {
    jj_scanpos = xsp;
    if (jj_3R_494()) {
    jj_scanpos = xsp;
    if (jj_3R_495()) {
    jj_scanpos = xsp;
    if (jj_3R_496()) {
    jj_scanpos = xsp;
    if (jj_3R_497()) {
    jj_scanpos = xsp;
    if (jj_3R_498()) {
    jj_scanpos = xsp;
    if (jj_3R_499()) {
    jj_scanpos = xsp;
    if (jj_3R_500()) {
    jj_scanpos = xsp;
    if (jj_3R_501()) {
    jj_scanpos = xsp;
    if (jj_3R_502()) {
    jj_scanpos = xsp;
    if (jj_3R_503()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_384() {
    if (jj_scan_token(TRANSIENT)) return true;
    return false;
  }

  static final private boolean jj_3R_383() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_382() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  static final private boolean jj_3R_381() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  static final private boolean jj_3R_380() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  static final private boolean jj_3R_258() {
    if (jj_scan_token(IF)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_113()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_345()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_61() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3R_401() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_3R_440()) return true;
    }
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_441()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_441()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_312() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_379()) {
    jj_scanpos = xsp;
    if (jj_3R_380()) {
    jj_scanpos = xsp;
    if (jj_3R_381()) {
    jj_scanpos = xsp;
    if (jj_3R_382()) {
    jj_scanpos = xsp;
    if (jj_3R_383()) {
    jj_scanpos = xsp;
    if (jj_3R_384()) {
    jj_scanpos = xsp;
    if (jj_3R_385()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_379() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  static final private boolean jj_3R_234() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_312()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_233() {
    if (jj_3R_76()) return true;
    return false;
  }

  static final private boolean jj_3_62() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_147() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_233()) {
    jj_scanpos = xsp;
    if (jj_3R_234()) return true;
    }
    if (jj_3R_101()) return true;
    if (jj_3R_196()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_235()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_460() {
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3R_452() {
    if (jj_scan_token(_DEFAULT)) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  static final private boolean jj_3_144() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_146() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_459() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_143() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_451() {
    if (jj_scan_token(CASE)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  static final private boolean jj_3R_96() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) {
    jj_scanpos = xsp;
    if (jj_3R_147()) return true;
    }
    return false;
  }

  static final private boolean jj_3_142() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_458() {
    if (jj_3R_268()) return true;
    return false;
  }

  static final private boolean jj_3R_410() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_451()) {
    jj_scanpos = xsp;
    if (jj_3R_452()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_457() {
    if (jj_3R_269()) return true;
    return false;
  }

  static final private boolean jj_3R_456() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_141() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3R_420() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_456()) {
    jj_scanpos = xsp;
    if (jj_3R_457()) {
    jj_scanpos = xsp;
    if (jj_3R_458()) {
    jj_scanpos = xsp;
    if (jj_3R_459()) {
    jj_scanpos = xsp;
    if (jj_3R_460()) return true;
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_146() {
    if (jj_scan_token(ELSE)) return true;
    return false;
  }

  static final private boolean jj_3_59() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_419() {
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_140() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_418() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_139() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_356() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_420()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_420()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3_138() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_220() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3R_417() {
    if (jj_3R_268()) return true;
    return false;
  }

  static final private boolean jj_3R_411() {
    if (jj_3R_340()) return true;
    return false;
  }

  static final private boolean jj_3R_416() {
    if (jj_3R_269()) return true;
    return false;
  }

  static final private boolean jj_3_60() {
    if (jj_scan_token(LEXECDEC)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(REXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_415() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_141() {
    if (jj_scan_token(LEXECDEC)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(EXECDECSEPARATOR)) return true;
    if (jj_3R_87()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_220()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(REXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_344() {
    if (jj_3R_410()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_411()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_355() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_415()) {
    jj_scanpos = xsp;
    if (jj_3R_416()) {
    jj_scanpos = xsp;
    if (jj_3R_417()) {
    jj_scanpos = xsp;
    if (jj_3R_418()) {
    jj_scanpos = xsp;
    if (jj_3R_419()) return true;
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_140() {
    if (jj_scan_token(LEXECDEC)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(REXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_257() {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_344()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_268() {
    if (jj_scan_token(CONDITIONAL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_355()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_355()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_356()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_88() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_140()) {
    jj_scanpos = xsp;
    if (jj_3R_141()) return true;
    }
    return false;
  }

  static final private boolean jj_3_137() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_636() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_136() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3_135() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3_134() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_635() {
    if (jj_3R_596()) return true;
    return false;
  }

  static final private boolean jj_3_133() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_634() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_132() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_633() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3R_450() {
    if (jj_3R_219()) return true;
    if (jj_3R_87()) return true;
    return false;
  }

  static final private boolean jj_3_131() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_632() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3R_449() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  static final private boolean jj_3_130() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_631() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3_210() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  static final private boolean jj_3R_630() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_448() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  static final private boolean jj_3_209() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  static final private boolean jj_3R_409() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_448()) {
    jj_scanpos = xsp;
    if (jj_3R_449()) {
    jj_scanpos = xsp;
    if (jj_3R_450()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3R_629() {
    if (jj_3R_595()) return true;
    return false;
  }

  static final private boolean jj_3R_628() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_343() {
    if (jj_3R_93()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_409()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_129() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_627() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_628()) {
    jj_scanpos = xsp;
    if (jj_3R_629()) {
    jj_scanpos = xsp;
    if (jj_3R_630()) {
    jj_scanpos = xsp;
    if (jj_3R_631()) {
    jj_scanpos = xsp;
    if (jj_3R_632()) {
    jj_scanpos = xsp;
    if (jj_3R_633()) {
    jj_scanpos = xsp;
    if (jj_3R_634()) {
    jj_scanpos = xsp;
    if (jj_3R_635()) {
    jj_scanpos = xsp;
    if (jj_3R_636()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_342() {
    if (jj_3R_389()) return true;
    return false;
  }

  static final private boolean jj_3R_626() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_128() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_341() {
    if (jj_3R_388()) return true;
    return false;
  }

  static final private boolean jj_3_127() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_256() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_341()) {
    jj_scanpos = xsp;
    if (jj_3R_342()) {
    jj_scanpos = xsp;
    if (jj_3R_343()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_126() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_625() {
    if (jj_3R_596()) return true;
    return false;
  }

  static final private boolean jj_3R_603() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_627()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_627()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3R_132() {
    if (jj_scan_token(JIDENTIFIER)) return true;
    return false;
  }

  static final private boolean jj_3_125() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_624() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_58() {
    if (jj_scan_token(LEXECDEC)) return true;
    return false;
  }

  static final private boolean jj_3_124() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_623() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_123() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_622() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_122() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_621() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_131() {
    if (jj_3R_88()) return true;
    return false;
  }

  static final private boolean jj_3R_620() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_619() {
    if (jj_3R_595()) return true;
    return false;
  }

  static final private boolean jj_3R_76() {
    if (jj_scan_token(MODIFIER_LIST)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_131()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) return true;
    }
    return false;
  }

  static final private boolean jj_3R_618() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_602() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_618()) {
    jj_scanpos = xsp;
    if (jj_3R_619()) {
    jj_scanpos = xsp;
    if (jj_3R_620()) {
    jj_scanpos = xsp;
    if (jj_3R_621()) {
    jj_scanpos = xsp;
    if (jj_3R_622()) {
    jj_scanpos = xsp;
    if (jj_3R_623()) {
    jj_scanpos = xsp;
    if (jj_3R_624()) {
    jj_scanpos = xsp;
    if (jj_3R_625()) {
    jj_scanpos = xsp;
    if (jj_3R_626()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_255() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_596() {
    if (jj_scan_token(CONDITIONAL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_602()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_602()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_603()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_57() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3_56() {
    if (jj_scan_token(FIELD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_578() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_197() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_196()) return true;
    return false;
  }

  static final private boolean jj_3R_577() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_55() {
    if (jj_3R_83()) return true;
    return false;
  }

  static final private boolean jj_3R_576() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3_121() {
    if (jj_scan_token(INITIALIZER_SET)) return true;
    return false;
  }

  static final private boolean jj_3_54() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_559() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_120() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3_53() {
    if (jj_scan_token(METHOD_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3_119() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3R_575() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_118() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_558() {
    if (jj_3R_395()) return true;
    return false;
  }

  static final private boolean jj_3_52() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_574() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3R_195() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3_117() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3R_557() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3R_573() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_116() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_556() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3_51() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_86() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_50() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_86()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3_115() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_115() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_195()) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_196()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_197()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3R_555() {
    if (jj_3R_398()) return true;
    return false;
  }

  static final private boolean jj_3R_572() {
    if (jj_3R_596()) return true;
    return false;
  }

  static final private boolean jj_3R_85() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(64)) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_114() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_554() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3_49() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_85()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3_113() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_553() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_571() {
    if (jj_3R_595()) return true;
    return false;
  }

  static final private boolean jj_3_112() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3R_552() {
    if (jj_3R_402()) return true;
    return false;
  }

  static final private boolean jj_3R_570() {
    if (jj_3R_397()) return true;
    return false;
  }

  static final private boolean jj_3_111() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_551() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3R_569() {
    if (jj_3R_396()) return true;
    return false;
  }

  static final private boolean jj_3R_544() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_569()) {
    jj_scanpos = xsp;
    if (jj_3R_570()) {
    jj_scanpos = xsp;
    if (jj_3R_571()) {
    jj_scanpos = xsp;
    if (jj_3R_572()) {
    jj_scanpos = xsp;
    if (jj_3R_573()) {
    jj_scanpos = xsp;
    if (jj_3R_574()) {
    jj_scanpos = xsp;
    if (jj_3R_575()) {
    jj_scanpos = xsp;
    if (jj_3R_576()) {
    jj_scanpos = xsp;
    if (jj_3R_577()) {
    jj_scanpos = xsp;
    if (jj_3R_578()) {
    jj_scanpos = xsp;
    if (jj_scan_token(136)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_110() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_550() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_109() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_549() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_108() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_548() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3_208() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  static final private boolean jj_3R_547() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_546() {
    if (jj_3R_401()) return true;
    return false;
  }

  static final private boolean jj_3R_447() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3R_545() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_408() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_447()) jj_scanpos = xsp;
    if (jj_3R_439()) return true;
    return false;
  }

  static final private boolean jj_3_107() {
    if (jj_scan_token(INITIALIZER_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_519() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_545()) {
    jj_scanpos = xsp;
    if (jj_3R_546()) {
    jj_scanpos = xsp;
    if (jj_3R_547()) {
    jj_scanpos = xsp;
    if (jj_3R_548()) {
    jj_scanpos = xsp;
    if (jj_3R_549()) {
    jj_scanpos = xsp;
    if (jj_3R_550()) {
    jj_scanpos = xsp;
    if (jj_3R_551()) {
    jj_scanpos = xsp;
    if (jj_3R_552()) {
    jj_scanpos = xsp;
    if (jj_3R_553()) {
    jj_scanpos = xsp;
    if (jj_3R_554()) {
    jj_scanpos = xsp;
    if (jj_3R_555()) {
    jj_scanpos = xsp;
    if (jj_3R_556()) {
    jj_scanpos = xsp;
    if (jj_3R_557()) {
    jj_scanpos = xsp;
    if (jj_3R_558()) {
    jj_scanpos = xsp;
    if (jj_3R_559()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_207() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  static final private boolean jj_3R_518() {
    if (jj_3R_403()) return true;
    return false;
  }

  static final private boolean jj_3_106() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3_105() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3R_446() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  static final private boolean jj_3_104() {
    if (jj_scan_token(CONSTRUCTOR_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_517() {
    if (jj_3R_395()) return true;
    return false;
  }

  static final private boolean jj_3R_443() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_519()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_519()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static final private boolean jj_3_103() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3R_407() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_446()) jj_scanpos = xsp;
    if (jj_3R_437()) return true;
    return false;
  }

  static final private boolean jj_3R_516() {
    if (jj_3R_100()) return true;
    return false;
  }

  static final private boolean jj_3R_488() {
    if (jj_3R_544()) return true;
    return false;
  }

  static final private boolean jj_3_102() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_543() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_375()) return true;
    return false;
  }

  static final private boolean jj_3R_515() {
    if (jj_3R_79()) return true;
    return false;
  }

  static final private boolean jj_3_206() {
    if (jj_scan_token(BLOCK)) return true;
    return false;
  }

  static final private boolean jj_3R_406() {
    if (jj_3R_113()) return true;
    return false;
  }

  static final private boolean jj_3_101() {
    if (jj_scan_token(CONDITIONAL)) return true;
    return false;
  }

  static final private boolean jj_3R_514() {
    if (jj_3R_398()) return true;
    return false;
  }

  static final private boolean jj_3_47() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_205() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(30)) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_3R_71()) return true;
    return false;
  }

  static final private boolean jj_3_100() {
    if (jj_scan_token(METHOD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_513() {
    if (jj_3R_99()) return true;
    return false;
  }

  static final private boolean jj_3_99() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3R_512() {
    if (jj_3R_82()) return true;
    return false;
  }

  static final private boolean jj_3R_405() {
    if (jj_scan_token(BLOCK)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(JIDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3_98() {
    if (jj_scan_token(FIELD_DECLARATION_SET)) return true;
    return false;
  }

  static final private boolean jj_3R_541() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_511() {
    if (jj_3R_402()) return true;
    return false;
  }

  static final private boolean jj_3R_542() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_97() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_404() {
    if (jj_3R_115()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_510() {
    if (jj_3R_399()) return true;
    return false;
  }

  static final private boolean jj_3_46() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  static final private boolean jj_3_96() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_340() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_404()) {
    jj_scanpos = xsp;
    if (jj_3R_405()) {
    jj_scanpos = xsp;
    if (jj_3R_406()) {
    jj_scanpos = xsp;
    if (jj_3R_407()) {
    jj_scanpos = xsp;
    if (jj_3R_408()) return true;
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_509() {
    if (jj_3R_98()) return true;
    return false;
  }

  static final private boolean jj_3_95() {
    if (jj_scan_token(ITERATIVE_DECLARATION)) return true;
    return false;
  }

  static final private boolean jj_3R_508() {
    if (jj_3R_400()) return true;
    return false;
  }

  static final private boolean jj_3_94() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_507() {
    if (jj_3R_97()) return true;
    return false;
  }

  static final private boolean jj_3R_540() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_375()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ROPTCDEC)) return true;
    return false;
  }

  static final private boolean jj_3R_84() {
    if (jj_scan_token(LOPTDEC)) return true;
    if (jj_scan_token(EXTENDS)) return true;
    return false;
  }

  static final private boolean jj_3_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_scan_token(28)) return true;
    }
    return false;
  }

  static final private boolean jj_3R_506() {
    if (jj_3R_96()) return true;
    return false;
  }

  static final private boolean jj_3R_505() {
    if (jj_3R_401()) return true;
    return false;
  }

  static final private boolean jj_3R_504() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  static final private boolean jj_3R_487() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_540()) {
    jj_scanpos = xsp;
    if (jj_3R_541()) {
    jj_scanpos = xsp;
    if (jj_3R_542()) {
    jj_scanpos = xsp;
    if (jj_3R_543()) return true;
    }
    }
    }
    return false;
  }

  static final private boolean jj_3R_442() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_504()) {
    jj_scanpos = xsp;
    if (jj_3R_505()) {
    jj_scanpos = xsp;
    if (jj_3R_506()) {
    jj_scanpos = xsp;
    if (jj_3R_507()) {
    jj_scanpos = xsp;
    if (jj_3R_508()) {
    jj_scanpos = xsp;
    if (jj_3R_509()) {
    jj_scanpos = xsp;
    if (jj_3R_510()) {
    jj_scanpos = xsp;
    if (jj_3R_511()) {
    jj_scanpos = xsp;
    if (jj_3R_512()) {
    jj_scanpos = xsp;
    if (jj_3R_513()) {
    jj_scanpos = xsp;
    if (jj_3R_514()) {
    jj_scanpos = xsp;
    if (jj_3R_515()) {
    jj_scanpos = xsp;
    if (jj_3R_516()) {
    jj_scanpos = xsp;
    if (jj_3R_517()) {
    jj_scanpos = xsp;
    if (jj_3R_518()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_203() {
    if (jj_3R_112()) return true;
    return false;
  }

  static final private boolean jj_3R_253() {
    if (jj_3R_340()) return true;
    return false;
  }

  static final private boolean jj_3R_402() {
    if (jj_scan_token(CONDITIONAL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_87()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_442()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_442()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_443()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3R_252() {
    if (jj_3R_112()) return true;
    return false;
  }

  static final private boolean jj_3R_439() {
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_3R_71()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_487()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_488()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public JaTSParserTokenManager token_source;
  static JavaCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[205];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static private int[] jj_la1_4;
  static private int[] jj_la1_5;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
      jj_la1_3();
      jj_la1_4();
      jj_la1_5();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x66b3c000,0x66b3c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40202000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40002000,0x40002000,0x0,0x10000000,0x0,0x0,0x4432a000,0x40002000,0x40002000,0x44128000,0x2000,0x2000,0x40002000,0x40002000,0x0,0x10000000,0x4432a000,0x44128000,0x0,0x40002000,0x40002000,0x0,0x40000000,0x40000000,0x0,0x44128000,0x0,0x0,0x0,0x0,0x24128000,0x24128000,0x0,0x40002000,0x40002000,0x4412a000,0x40002000,0x40002000,0x0,0x0,0x0,0x4412a000,0x0,0x0,0x44128000,0x0,0x0,0x40000000,0x44128000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x24128000,0x0,0x0,0x0,0x4128000,0x0,0x4128000,0x4128000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x44128000,0x0,0x4412a000,0x4412a000,0x4412a000,0x4412a000,0x8000000,0x4412a000,0x4412a000,0x4412a000,0x4412a000,0x8000000,0x2693c000,0x6693c000,0x2693c000,0x6693c000,0x0,0x4412a000,0x4412a000,0x0,0x4412a000,0x4412a000,0x0,0x2693c000,0x6693c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x24128000,0x0,0x0,0x24128000,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0x20000000,0x20000000,0x0,0x24128000,0x0,0x0,0x0,0x0,0x0,0x0,0x2810000,0x4000,0x66b3c000,0x0,0x40000000,0x40000000,0x2693c000,0x40000000,0x0,0x0,0x0,0x24128000,0x1040000,0x66b3c000,0x1040000,0x8000000,0x64128000,0x24128000,0x24128000,0x24128000,0x0,0x0,0x0,0x24128000,0x0,0x80000,0x80000000,0x0,0x66b3c000,0x0,0x0,0x0,0x0,0x0,0x4412a000,0x4412a000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0xb9f61b8b,0xb9f61b8b,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000,0x20,0x10100,0x0,0x0,0x2000,0x0,0x0,0x20,0x0,0x10000,0x10000,0x0,0x0,0x0,0x10,0x644dc781,0x9c000,0x9c000,0x440dc281,0x10000,0x10000,0x9c000,0x9c000,0x0,0x0,0x644dc781,0x440dc281,0x0,0x4449c400,0x4449c400,0x0,0x4409c000,0x4409c000,0x0,0x440dc281,0x0,0x0,0x0,0x0,0x28941a81,0x28941a81,0x0,0x49c400,0x49c400,0x204dc681,0x49c400,0x49c400,0x0,0x2000000,0x0,0x204dc681,0x0,0x0,0x40281,0x0,0x0,0x0,0x40281,0x1c000,0x1c000,0x1c000,0x1c000,0x1c000,0x0,0x2000000,0x1c000,0x28941a81,0x80000,0x0,0x0,0x40281,0x0,0x40281,0x20040281,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40281,0x0,0x204dc681,0x644dc681,0x204dc681,0x644dc681,0x0,0x204dc681,0x644dc681,0x204dc681,0x644dc681,0x0,0xb9f61a8b,0xb9f61a8b,0xb9f61a8b,0xb9f61a8b,0x0,0x204dc681,0x644dc681,0x0,0x204dc681,0x644dc681,0x0,0xb9f61a8b,0xb9f61a8b,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x28941a81,0x0,0x0,0x28941a81,0x8901800,0x0,0x0,0x0,0x0,0x900000,0x0,0x0,0x8001000,0x8001000,0x8000000,0x0,0x28941a81,0x0,0x0,0x800,0x0,0x0,0x0,0x91420002,0x0,0xb9f61b8b,0x0,0x0,0x0,0xb9f61a8b,0x0,0x0,0x0,0x0,0x28941a81,0x0,0xb9f61b8b,0x0,0x0,0x28941a81,0x28941a81,0x28941a81,0x28941a81,0x0,0x0,0x0,0x28941a81,0x20000,0x0,0x0,0x0,0xb9f61b8b,0x0,0x0,0x0,0x0,0x0,0x204dc681,0x204dc681,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x1100c07a,0x1100d87a,0x0,0x0,0x0,0x0,0x1000000,0x1000000,0x1000000,0x72,0x0,0x0,0x20000000,0x1,0x0,0x0,0x0,0x0,0x0,0x20000000,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x9dcd8001,0x1,0x1,0x1400000,0x1,0x1,0x1,0x1,0x0,0x0,0x11c00001,0x1400000,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x1000000,0x0,0x1000000,0x1000000,0x0,0x1,0x1,0x1000001,0x1,0x1,0x0,0x0,0x8000,0x1000001,0x0,0x0,0x1000000,0x0,0x0,0x0,0x1000000,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x1000000,0x0,0x1000000,0x0,0x1000000,0x1000000,0x0,0x0,0x1000000,0x1000000,0x1000000,0x1000000,0x1000001,0x1dcc8001,0x1000001,0x1dcc8001,0x0,0x1000001,0x11c00001,0x1000001,0x11c00001,0x0,0x1100c008,0x1100c008,0x1100c008,0x1100c008,0x0,0x1000001,0x1dcc8001,0x0,0x1000001,0x11c00001,0x0,0x1100c008,0x1100c008,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4008,0x1100c008,0x0,0x0,0x0,0x1100c008,0x0,0x0,0x0,0x0,0x1000000,0x0,0x1100c008,0x0,0x0,0x1000000,0x1000000,0x1000000,0x1000000,0x0,0x1000000,0x1000000,0x1000000,0x0,0x0,0x0,0x0,0x1100c008,0x4,0x500780,0x0,0x0,0x0,0x1000001,0x1000001,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_3() {
      jj_la1_3 = new int[] {0x4ba32042,0x4ba33062,0x8000000,0x8000000,0x40,0x8000000,0xa000000,0xa000000,0xa000000,0x0,0x0,0x100,0x0,0x20,0x0,0x2000000,0x100,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xa012079,0x0,0x0,0xa002060,0x0,0x0,0x0,0x0,0x0,0x0,0xa012078,0xa002060,0x2000000,0x0,0x0,0x0,0x0,0x0,0x0,0xa002060,0x2000000,0x0,0xa004000,0x0,0x4ba22042,0x4ba22042,0x0,0x0,0x0,0xa002060,0x0,0x0,0x0,0x0,0x0,0xa002060,0x2000000,0x0,0xa002260,0x400,0x2000000,0x20,0xa002260,0x0,0x0,0xa000020,0x0,0x0,0x0,0x0,0xa000020,0x4ba22042,0x0,0x2002000,0xa000040,0xa000040,0x0,0x0,0xa002040,0x2000040,0xa000000,0x2000000,0x2000000,0xa000000,0x2000000,0x0,0xa0000c0,0xa000040,0xa002260,0xa004000,0xa002068,0xa012078,0xa002068,0xa012078,0x0,0xa002068,0xa012078,0xa002068,0xa012078,0x0,0x4ba32042,0x4ba32042,0x4ba32042,0x4ba32042,0x2000000,0xa002068,0xa012078,0x2000000,0xa002068,0xa012078,0x2000000,0x4ba32042,0x4ba32042,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4ba22042,0x0,0x0,0x4ba22042,0x81a20002,0x40000000,0x0,0x0,0x40000000,0x40000000,0xa000040,0x40000000,0x1a20000,0x1a20002,0x0,0x2000000,0x4ba22042,0x0,0x40000000,0x0,0x0,0x0,0x0,0x0,0x0,0x4ba32042,0x0,0x0,0x0,0x4ba32042,0x0,0x0,0x0,0x0,0x4ba22042,0x0,0x4ba32042,0x0,0x0,0x4ba22042,0x4ba22042,0x4ba22042,0x4ba22042,0x0,0xa000000,0xa000000,0x4ba22042,0x0,0x0,0x0,0x0,0x4ba32042,0x0,0x220c,0x0,0x0,0x0,0xa002068,0xa002068,0x0,0x0,0xa000000,0x0,0x8000000,0x0,0x0,0x4a000000,};
   }
   private static void jj_la1_4() {
      jj_la1_4 = new int[] {0x6000141,0x6000141,0x0,0x4,0x0,0x0,0x40,0x40,0x40,0x0,0x0,0x10,0x0,0x100,0x0,0x0,0x0,0x400,0x400,0x0,0x100,0x0,0x0,0x10,0x0,0x10,0x0,0x141,0x0,0x0,0x140,0x0,0x0,0x0,0x0,0x10,0x0,0x140,0x140,0x0,0x0,0x0,0x40,0x0,0x0,0x200,0x40,0x0,0x1000,0x40,0x4,0x1e018040,0x1e018041,0x200,0x0,0x0,0x40,0x0,0x0,0x10,0x0,0x101,0x40,0x40,0x200,0x40,0x0,0x40,0x0,0x40,0x0,0x0,0x40,0x0,0x0,0x10,0x0,0x40,0x40,0x0,0x0,0x40,0x40,0x4,0x0,0x40,0x0,0x40,0x40,0x0,0x0,0x40,0x200,0x40,0x40,0x40,0x40,0x40,0x41,0x40,0x41,0x0,0x40,0x40,0x40,0x40,0x0,0x6000141,0x6000141,0x6000141,0x6000141,0x40,0x40,0x41,0x40,0x40,0x40,0x40,0x6000141,0x6000141,0x1000,0x1000,0x20000,0x800000,0x1000000,0x0,0x0,0x80000000,0x480000,0x480000,0x0,0x306000,0x0,0x18000000,0x18000000,0x60000000,0x60000000,0x18000000,0x1e018040,0x18000,0x18000,0x40,0x18000,0x0,0x6000000,0x6000000,0x0,0x0,0x40,0x400,0x0,0x0,0x0,0x40,0x1e018040,0x200,0x4,0x0,0x4,0x4,0x100,0x0,0x0,0x6000141,0x1,0x0,0x0,0x6000141,0x0,0x200,0x6001000,0x6001000,0x40,0x0,0x6000141,0x0,0x0,0x6000040,0x1e018040,0x6000040,0x6000040,0x200,0x40,0x40,0x1e018040,0x0,0x0,0x0,0x40000,0x6000141,0x0,0x0,0x0,0x0,0x0,0x40,0x40,0x0,0x1800000,0x4,0x0,0x0,0x0,0x1800000,0x4,};
   }
   private static void jj_la1_5() {
      jj_la1_5 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100000,0x0,0x0,0x0,0x100000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1ffc0,0x1ffc0,0x0,0x0,0x0,0x1,0x2,0x0,0x0,0x0,0x0,0x0,0x38,0x0,0x0,0x4,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1ffc0,0x1ffc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x400000,0x400000,0x100000,0x0,0x0,0x3f800018,0x0,0x0,0x1,0x0,0x3f800018,0x0,0x0,};
   }
  static final private JJCalls[] jj_2_rtns = new JJCalls[224];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public JaTSParser(java.io.InputStream stream) {
     this(stream, null);
  }
  public JaTSParser(java.io.InputStream stream, String encoding) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new JaTSParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
     ReInit(stream);
  }
  static public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public JaTSParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new JaTSParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public JaTSParser(JaTSParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(JaTSParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 205; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  static final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[190];
    for (int i = 0; i < 190; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 205; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 190; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 224; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
            case 52: jj_3_53(); break;
            case 53: jj_3_54(); break;
            case 54: jj_3_55(); break;
            case 55: jj_3_56(); break;
            case 56: jj_3_57(); break;
            case 57: jj_3_58(); break;
            case 58: jj_3_59(); break;
            case 59: jj_3_60(); break;
            case 60: jj_3_61(); break;
            case 61: jj_3_62(); break;
            case 62: jj_3_63(); break;
            case 63: jj_3_64(); break;
            case 64: jj_3_65(); break;
            case 65: jj_3_66(); break;
            case 66: jj_3_67(); break;
            case 67: jj_3_68(); break;
            case 68: jj_3_69(); break;
            case 69: jj_3_70(); break;
            case 70: jj_3_71(); break;
            case 71: jj_3_72(); break;
            case 72: jj_3_73(); break;
            case 73: jj_3_74(); break;
            case 74: jj_3_75(); break;
            case 75: jj_3_76(); break;
            case 76: jj_3_77(); break;
            case 77: jj_3_78(); break;
            case 78: jj_3_79(); break;
            case 79: jj_3_80(); break;
            case 80: jj_3_81(); break;
            case 81: jj_3_82(); break;
            case 82: jj_3_83(); break;
            case 83: jj_3_84(); break;
            case 84: jj_3_85(); break;
            case 85: jj_3_86(); break;
            case 86: jj_3_87(); break;
            case 87: jj_3_88(); break;
            case 88: jj_3_89(); break;
            case 89: jj_3_90(); break;
            case 90: jj_3_91(); break;
            case 91: jj_3_92(); break;
            case 92: jj_3_93(); break;
            case 93: jj_3_94(); break;
            case 94: jj_3_95(); break;
            case 95: jj_3_96(); break;
            case 96: jj_3_97(); break;
            case 97: jj_3_98(); break;
            case 98: jj_3_99(); break;
            case 99: jj_3_100(); break;
            case 100: jj_3_101(); break;
            case 101: jj_3_102(); break;
            case 102: jj_3_103(); break;
            case 103: jj_3_104(); break;
            case 104: jj_3_105(); break;
            case 105: jj_3_106(); break;
            case 106: jj_3_107(); break;
            case 107: jj_3_108(); break;
            case 108: jj_3_109(); break;
            case 109: jj_3_110(); break;
            case 110: jj_3_111(); break;
            case 111: jj_3_112(); break;
            case 112: jj_3_113(); break;
            case 113: jj_3_114(); break;
            case 114: jj_3_115(); break;
            case 115: jj_3_116(); break;
            case 116: jj_3_117(); break;
            case 117: jj_3_118(); break;
            case 118: jj_3_119(); break;
            case 119: jj_3_120(); break;
            case 120: jj_3_121(); break;
            case 121: jj_3_122(); break;
            case 122: jj_3_123(); break;
            case 123: jj_3_124(); break;
            case 124: jj_3_125(); break;
            case 125: jj_3_126(); break;
            case 126: jj_3_127(); break;
            case 127: jj_3_128(); break;
            case 128: jj_3_129(); break;
            case 129: jj_3_130(); break;
            case 130: jj_3_131(); break;
            case 131: jj_3_132(); break;
            case 132: jj_3_133(); break;
            case 133: jj_3_134(); break;
            case 134: jj_3_135(); break;
            case 135: jj_3_136(); break;
            case 136: jj_3_137(); break;
            case 137: jj_3_138(); break;
            case 138: jj_3_139(); break;
            case 139: jj_3_140(); break;
            case 140: jj_3_141(); break;
            case 141: jj_3_142(); break;
            case 142: jj_3_143(); break;
            case 143: jj_3_144(); break;
            case 144: jj_3_145(); break;
            case 145: jj_3_146(); break;
            case 146: jj_3_147(); break;
            case 147: jj_3_148(); break;
            case 148: jj_3_149(); break;
            case 149: jj_3_150(); break;
            case 150: jj_3_151(); break;
            case 151: jj_3_152(); break;
            case 152: jj_3_153(); break;
            case 153: jj_3_154(); break;
            case 154: jj_3_155(); break;
            case 155: jj_3_156(); break;
            case 156: jj_3_157(); break;
            case 157: jj_3_158(); break;
            case 158: jj_3_159(); break;
            case 159: jj_3_160(); break;
            case 160: jj_3_161(); break;
            case 161: jj_3_162(); break;
            case 162: jj_3_163(); break;
            case 163: jj_3_164(); break;
            case 164: jj_3_165(); break;
            case 165: jj_3_166(); break;
            case 166: jj_3_167(); break;
            case 167: jj_3_168(); break;
            case 168: jj_3_169(); break;
            case 169: jj_3_170(); break;
            case 170: jj_3_171(); break;
            case 171: jj_3_172(); break;
            case 172: jj_3_173(); break;
            case 173: jj_3_174(); break;
            case 174: jj_3_175(); break;
            case 175: jj_3_176(); break;
            case 176: jj_3_177(); break;
            case 177: jj_3_178(); break;
            case 178: jj_3_179(); break;
            case 179: jj_3_180(); break;
            case 180: jj_3_181(); break;
            case 181: jj_3_182(); break;
            case 182: jj_3_183(); break;
            case 183: jj_3_184(); break;
            case 184: jj_3_185(); break;
            case 185: jj_3_186(); break;
            case 186: jj_3_187(); break;
            case 187: jj_3_188(); break;
            case 188: jj_3_189(); break;
            case 189: jj_3_190(); break;
            case 190: jj_3_191(); break;
            case 191: jj_3_192(); break;
            case 192: jj_3_193(); break;
            case 193: jj_3_194(); break;
            case 194: jj_3_195(); break;
            case 195: jj_3_196(); break;
            case 196: jj_3_197(); break;
            case 197: jj_3_198(); break;
            case 198: jj_3_199(); break;
            case 199: jj_3_200(); break;
            case 200: jj_3_201(); break;
            case 201: jj_3_202(); break;
            case 202: jj_3_203(); break;
            case 203: jj_3_204(); break;
            case 204: jj_3_205(); break;
            case 205: jj_3_206(); break;
            case 206: jj_3_207(); break;
            case 207: jj_3_208(); break;
            case 208: jj_3_209(); break;
            case 209: jj_3_210(); break;
            case 210: jj_3_211(); break;
            case 211: jj_3_212(); break;
            case 212: jj_3_213(); break;
            case 213: jj_3_214(); break;
            case 214: jj_3_215(); break;
            case 215: jj_3_216(); break;
            case 216: jj_3_217(); break;
            case 217: jj_3_218(); break;
            case 218: jj_3_219(); break;
            case 219: jj_3_220(); break;
            case 220: jj_3_221(); break;
            case 221: jj_3_222(); break;
            case 222: jj_3_223(); break;
            case 223: jj_3_224(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
